/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/addrregistry.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_addrregistry.h"
#include "pmc_hash.h"
#include "pmc_default.h"
#include "addrregistry.str"
#include "pmc_continuation.h"
#include "pmc_callcontext.h"
#line 1 "./src/pmc/addrregistry.pmc"
/*
Copyright (C) 2005-2009, Parrot Foundation.
$Id: addrregistry.pmc 46300 2010-05-05 03:58:50Z jimmy $

=head1 NAME

src/pmc/addrregistry.pmc - A GC Registry PMC

=head1 DESCRIPTION

The AddrRegistry class provides the equivalence of reference counts
mainly for extenders and embedders of Parrot. The hash keys are the
addresses of the key PMC, values are reference counts, i.e. the
difference of (set_pmc_keyed - delete_pmc_keyed). If the reference
goes to zero, the entry is deleted physically.

Please note that you have to anchor an instance of AddrRegistry yourself with
C<Parrot_register_pmc> if it isn't visible to Parrot.

=head2 Functions

=over 4

=cut

*/

#include "parrot/hash.h"
#include "pmc/pmc_hash.h"

/* HEADERIZER HFILE: none */
/* HEADERIZER BEGIN: static */
/* HEADERIZER END: static */
#line 57 "./src/pmc/addrregistry.c"
static  void  Parrot_AddrRegistry_delete_keyed(PARROT_INTERP, PMC *_self, PMC *key);
static  INTVAL  Parrot_AddrRegistry_elements(PARROT_INTERP, PMC *_self);
static  INTVAL  Parrot_AddrRegistry_get_bool(PARROT_INTERP, PMC *_self);
static  INTVAL  Parrot_AddrRegistry_get_integer_keyed(PARROT_INTERP, PMC *_self, PMC *key);
static  void  Parrot_AddrRegistry_init(PARROT_INTERP, PMC *_self);
static  void  Parrot_AddrRegistry_set_integer_keyed(PARROT_INTERP, PMC *_self, PMC *key, INTVAL value);
static  void  Parrot_AddrRegistry_set_pmc_keyed(PARROT_INTERP, PMC *_self, PMC *key, PMC *value);
void    Parrot_AddrRegistry_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_AddrRegistry_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_AddrRegistry_get_vtable(PARROT_INTERP);
void    Parrot_AddrRegistry_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_AddrRegistry_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_AddrRegistry_ro_get_vtable(PARROT_INTERP);
static  void 
Parrot_AddrRegistry_delete_keyed(PARROT_INTERP, PMC *_self, PMC *key)
{
#line 147 "./src/pmc/addrregistry.pmc"

    Hash       *hash;
    void       *value;

    GETATTR_AddrRegistry_hash(interp, _self, hash);
    value = parrot_hash_get(interp, hash, key);

    /* these casts look bad, but they avoid type punning warnings with -O */
    if (value) {
        long val = (long)value;
        if (val == 1L)
            parrot_hash_delete(interp, hash, key);
        else {
            value = (void *)(--val);
            parrot_hash_put(interp, hash, key, value);
        }
    }
#line 92 "./src/pmc/addrregistry.c"
}
static  INTVAL 
Parrot_AddrRegistry_elements(PARROT_INTERP, PMC *_self)
{
#line 89 "./src/pmc/addrregistry.pmc"

    const Hash *hash;

    GETATTR_AddrRegistry_hash(interp, _self, hash);

    return parrot_hash_size(interp, hash);
#line 104 "./src/pmc/addrregistry.c"
}
static  INTVAL 
Parrot_AddrRegistry_get_bool(PARROT_INTERP, PMC *_self)
{
#line 97 "./src/pmc/addrregistry.pmc"

    const Hash *hash;

    GETATTR_AddrRegistry_hash(interp, _self, hash);

    return parrot_hash_size(interp, hash) != 0;
#line 116 "./src/pmc/addrregistry.c"
}
static  INTVAL 
Parrot_AddrRegistry_get_integer_keyed(PARROT_INTERP, PMC *_self, PMC *key)
{
#line 76 "./src/pmc/addrregistry.pmc"

    Hash       *hash;
    const void *value;

    GETATTR_AddrRegistry_hash(interp, _self, hash);
    value = parrot_hash_get(interp, hash, key);

    if (value)
        return (INTVAL)value;

    return 0;
#line 133 "./src/pmc/addrregistry.c"
}
static  void 
Parrot_AddrRegistry_init(PARROT_INTERP, PMC *_self)
{
#line 46 "./src/pmc/addrregistry.pmc"

    Hash  *registry = parrot_create_hash(interp,
            enum_type_int,
            Hash_key_type_PMC,
            int_compare,
            key_hash_int);

    SETATTR_AddrRegistry_hash(interp, _self, registry);
    PObj_custom_mark_destroy_SETALL(_self);

#line 149 "./src/pmc/addrregistry.c"
}
static  void 
Parrot_AddrRegistry_set_integer_keyed(PARROT_INTERP, PMC *_self, PMC *key, INTVAL value)
{
#line 141 "./src/pmc/addrregistry.pmc"

    Hash *hash;
    GETATTR_AddrRegistry_hash(interp, _self, hash);
    parrot_hash_put(interp, hash, key, (void *)value);
#line 159 "./src/pmc/addrregistry.c"
}
static  void 
Parrot_AddrRegistry_set_pmc_keyed(PARROT_INTERP, PMC *_self, PMC *key, PMC *value)
{
#line 125 "./src/pmc/addrregistry.pmc"

    const void *oldval;
    long        newval = 1;
    Hash       *hash;
    UNUSED(value);

    GETATTR_AddrRegistry_hash(interp, _self, hash);

    oldval = parrot_hash_get(interp, hash, key);

    if (oldval)
        newval += (long)oldval;

    parrot_hash_put(interp, hash, key, (void *)newval);
#line 179 "./src/pmc/addrregistry.c"
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_AddrRegistry_update_vtable(VTABLE *vt) {
    vt->delete_keyed = Parrot_AddrRegistry_delete_keyed;
    vt->elements = Parrot_AddrRegistry_elements;
    vt->get_bool = Parrot_AddrRegistry_get_bool;
    vt->get_integer_keyed = Parrot_AddrRegistry_get_integer_keyed;
    vt->init = Parrot_AddrRegistry_init;
    vt->set_integer_keyed = Parrot_AddrRegistry_set_integer_keyed;
    vt->set_pmc_keyed = Parrot_AddrRegistry_set_pmc_keyed;
    vt->attr_size = sizeof(Parrot_AddrRegistry_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_AddrRegistry_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->elements = Parrot_AddrRegistry_elements;
    vt->get_bool = Parrot_AddrRegistry_get_bool;
    vt->get_integer_keyed = Parrot_AddrRegistry_get_integer_keyed;
    vt->init = Parrot_AddrRegistry_init;
    vt->attr_size = sizeof(Parrot_AddrRegistry_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_AddrRegistry_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_Hash_get_vtable(interp);
    Parrot_AddrRegistry_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_AddrRegistry_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_Hash_ro_get_vtable(interp);
    Parrot_AddrRegistry_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_AddrRegistry_get_mro(PARROT_INTERP, PMC* mro) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }
    mro = Parrot_Hash_get_mro(interp, mro);

    VTABLE_unshift_string(interp, mro,
        string_make(interp, "AddrRegistry", 12, NULL, 0));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_AddrRegistry_get_isa(PARROT_INTERP, Hash* isa) {
    isa = Parrot_Hash_get_isa(interp, isa);
    parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "AddrRegistry")), PMCNULL);
    return isa;
}

void
Parrot_AddrRegistry_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        ":hash ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_AddrRegistry_get_vtable(interp);
        vt->base_type      = enum_class_AddrRegistry;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "AddrRegistry");
        vt->provides_str = CONST_STRING_GEN(interp, "hash");
        vt->isa_hash     = Parrot_AddrRegistry_get_isa(interp, NULL);
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_AddrRegistry_ro_get_vtable(interp);
            vt_ro->base_type      = enum_class_AddrRegistry;
            vt_ro->flags          = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_AddrRegistry_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        {
        }
    } /* pass */
} /* Parrot_AddrRegistry_class_init */
#line 165 "./src/pmc/addrregistry.pmc"


/*

=back

=head1 SEE ALSO

F<src/pmc.c:gc_register_pmc()>

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
