/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/bignum.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_bignum.h"
#include "pmc_default.h"
#include "bignum.str"
#include "pmc_continuation.h"
#include "pmc_callcontext.h"
#line 1 "./src/pmc/bignum.pmc"
/*
Copyright (C) 2004-2010, Parrot Foundation.
$Id: bignum.pmc 46300 2010-05-05 03:58:50Z jimmy $

=head1 NAME

src/pmc/bignum.pmc - BigNum PMC class

=head1 DESCRIPTION

C<BigNum> provides arbitrary precision floating point mathematic
functions, based on the GMP mpf library.

=head1 SYNOPSIS

Make mixing of classes work, like in:

        new $P0 ['BigInt']
        new $P1 ['BigNum']
        set $P0, 10
        set $P1, 2
        div P2, P0, P1  # $P2 = $P0 / $P1; (BigNum) 5.0

Make auto-upgrading/downgrading work.

        set $N1, $P0
        set $N1, $P1
        set $I1, $P0
        set $I1, $P1
        set $P0, $I1
        set $P0, $N1
        set $P1, $I1
        set $P1, $N1

  BigNum
    => BigInt => Integer
    => Number: float (can be long double) and double
    => Integer (unsigned long)

=head2 Functions

=over 4

=item C<static void bignum_init(PARROT_INTERP, PMC *self)>

=item C<static void bignum_clear(PARROT_INTERP, PMC *self)>

=item C<static void bignum_set(PARROT_INTERP, PMC *dest, PMC *src)>

=item C<static void bignum_set_si(PARROT_INTERP, PMC *self, long value)>

=item C<static void bignum_set_ui(PARROT_INTERP, PMC *self, unsigned long
value)>

=item C<static void bignum_set_float(PARROT_INTERP, PMC *self, FLOATVAL value)>

=item C<static void bignum_set_double(PARROT_INTERP, PMC *self, double value)>

=item C<static void bignum_set_str(PARROT_INTERP, PMC *self, const char *value,
int base)>

=item C<static void bignum_set_bigint(PARROT_INTERP, PMC *self, struct BIGINT
*value)>

=item C<static BIGNUM* bignum_get_self(PARROT_INTERP, PMC *self)>

=item C<static void bignum_set_self(PARROT_INTERP, PMC *self, BIGNUM *value)>

=item C<static long bignum_get_si(PARROT_INTERP, PMC *self)>

=item C<static unsigned long bignum_get_ui(PARROT_INTERP, PMC *self)>

=item C<static INTVAL bignum_get_bool(PARROT_INTERP, ARGIN(PMC *self))>

=item C<static char * bignum_get_string(PARROT_INTERP, PMC *self, int base)>

=item C<static char * bignum_get_string_size(PARROT_INTERP, PMC *self, int base,
int digits)>

=item C<static double bignum_get_double(PARROT_INTERP, PMC *self)>

=item C<static FLOATVAL bignum_get_float(PARROT_INTERP, PMC *self)>

=item C<static BIGINT bignum_get_bigint(Interp*, ARGIN(PMC *self))>

=item C<static void bignum_add_bignum(PARROT_INTERP, PMC *self, PMC *value, PMC
*dest)>

=item C<static void bignum_add_bignum_int(PARROT_INTERP, PMC *self, INTVAL
value, PMC *dest)>

=item C<static void bignum_add_bignum_float(PARROT_INTERP, PMC *self, FLOATVAL
value, PMC *dest)>

=item C<static void bignum_sub_bignum(PARROT_INTERP, PMC *self, PMC *value, PMC
*dest)>

=item C<static void bignum_sub_bignum_int(PARROT_INTERP, PMC *self, INTVAL
value, PMC *dest)>

=item C<static void bignum_sub_bignum_float(PARROT_INTERP, PMC *self, FLOATVAL
value, PMC *dest)>

=item C<static void bignum_mul_bignum(PARROT_INTERP, PMC *self, PMC *value, PMC
*dest)>

=item C<static void bignum_mul_bignum_int(PARROT_INTERP, PMC *self, INTVAL
value, PMC *dest)>

=item C<static void bignum_mul_bignum_float(PARROT_INTERP, PMC *self, FLOATVAL
value, PMC *dest)>

=item C<static void bignum_pow_bignum_int(PARROT_INTERP, PMC *self, INTVAL
value, PMC *dest)>

=item C<static void bignum_check_divide_zero(Interp*, PMC *value)>

=item C<static void bignum_div_bignum(PARROT_INTERP, PMC *self, PMC *value, PMC
*dest)>

=item C<static void bignum_div_bignum_int(PARROT_INTERP, PMC *self, INTVAL
value, PMC *dest)>

=item C<static void bignum_div_bignum_float(PARROT_INTERP, PMC *self, FLOATVAL
value, PMC *dest)>

=item C<static void bignum_fdiv_bignum(PARROT_INTERP, PMC *self, PMC *value, PMC
*dest)>

=item C<static void bignum_fdiv_bignum_int(PARROT_INTERP, PMC *self, INTVAL
value, PMC *dest)>

=item C<static INTVAL bignum_cmp(PARROT_INTERP, PMC *self, PMC *value)>

=item C<static INTVAL bignum_cmp_double(PARROT_INTERP, PMC *self, double value)>

=item C<static INTVAL bignum_cmp_int(PARROT_INTERP, PMC *self, INTVAL value)>

=item C<static INTVAL bignum_cmp_ulong(PARROT_INTERP, PMC *self, unsigned long
value)>

=item C<static void bignum_abs(PARROT_INTERP, PMC *self, PMC *dest)>

=item C<static void bignum_neg(PARROT_INTERP, PMC *self, PMC *dest)>

=item C<static INTVAL bignum_get_default_prec(PARROT_INTERP, PMC *self)>

=item C<static void bignum_set_default_prec(PARROT_INTERP, PMC *self, INTVAL
prec)>

=cut

*/

#ifdef S_SPLINT_S
#  undef PARROT_HAS_GMP /* splint barfs on the gmp.h header */
#endif /* S_SPLINT_S */


#ifdef PARROT_HAS_GMP
#  include "pmc_bigint.h"
#  include <gmp.h>
typedef struct BIGNUM {
    mpf_t b;
} BIGNUM;
#endif

/* HEADERIZER HFILE: none */
/* HEADERIZER BEGIN: static */
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */

static void bignum_abs(PARROT_INTERP, ARGIN(PMC *self), ARGMOD(PMC *dest))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(3)
        FUNC_MODIFIES(*dest);

static void bignum_add_bignum(PARROT_INTERP,
    ARGIN(PMC *self),
    ARGIN(PMC *value),
    ARGMOD(PMC *dest))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(3)
        __attribute__nonnull__(4)
        FUNC_MODIFIES(*dest);

static void bignum_add_bignum_float(PARROT_INTERP,
    ARGIN(PMC *self),
    FLOATVAL value,
    ARGMOD(PMC *dest))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(4)
        FUNC_MODIFIES(*dest);

static void bignum_add_bignum_int(PARROT_INTERP,
    ARGIN(PMC *self),
    INTVAL value,
    ARGMOD(PMC *dest))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(4)
        FUNC_MODIFIES(*dest);

static void bignum_clear(PARROT_INTERP, ARGIN(PMC *self))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2);

static INTVAL bignum_cmp(PARROT_INTERP, ARGIN(PMC *self), ARGIN(PMC *value))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(3);

static INTVAL bignum_cmp_double(PARROT_INTERP,
    ARGIN(PMC *self),
    double value)
        __attribute__nonnull__(1)
        __attribute__nonnull__(2);

static INTVAL bignum_cmp_int(PARROT_INTERP, ARGIN(PMC *self), INTVAL value)
        __attribute__nonnull__(1)
        __attribute__nonnull__(2);

static INTVAL bignum_cmp_ulong(PARROT_INTERP,
    ARGIN(PMC *self),
    unsigned long value)
        __attribute__nonnull__(1)
        __attribute__nonnull__(2);

static void bignum_div_bignum(PARROT_INTERP,
    ARGIN(PMC *self),
    ARGIN(PMC *value),
    ARGMOD(PMC *dest))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(3)
        __attribute__nonnull__(4)
        FUNC_MODIFIES(*dest);

static void bignum_div_bignum_float(PARROT_INTERP,
    ARGIN(PMC *self),
    FLOATVAL value,
    ARGMOD(PMC *dest))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(4)
        FUNC_MODIFIES(*dest);

static void bignum_div_bignum_int(PARROT_INTERP,
    ARGIN(PMC *self),
    INTVAL value,
    ARGMOD(PMC *dest))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(4)
        FUNC_MODIFIES(*dest);

static void bignum_fdiv_bignum(PARROT_INTERP,
    ARGIN(PMC *self),
    ARGIN(PMC *value),
    ARGMOD(PMC *dest))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(3)
        __attribute__nonnull__(4)
        FUNC_MODIFIES(*dest);

static void bignum_fdiv_bignum_int(PARROT_INTERP,
    ARGIN(PMC *self),
    INTVAL value,
    ARGMOD(PMC *dest))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(4)
        FUNC_MODIFIES(*dest);

static INTVAL bignum_get_default_prec(PARROT_INTERP, ARGIN(PMC *self))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2);

PARROT_WARN_UNUSED_RESULT
static double bignum_get_double(PARROT_INTERP, ARGIN(PMC *self))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2);

PARROT_WARN_UNUSED_RESULT
static FLOATVAL bignum_get_float(PARROT_INTERP, ARGIN(PMC *self))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2);

PARROT_WARN_UNUSED_RESULT
static long bignum_get_si(PARROT_INTERP, ARGIN(PMC *self))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2);

PARROT_WARN_UNUSED_RESULT
PARROT_CANNOT_RETURN_NULL
static char * bignum_get_string(PARROT_INTERP, ARGIN(PMC *self), int base)
        __attribute__nonnull__(1)
        __attribute__nonnull__(2);

PARROT_WARN_UNUSED_RESULT
PARROT_CANNOT_RETURN_NULL
static char * bignum_get_string_size(PARROT_INTERP,
    ARGIN(PMC *self),
    int base,
    int digits)
        __attribute__nonnull__(1)
        __attribute__nonnull__(2);

PARROT_WARN_UNUSED_RESULT
static unsigned long bignum_get_ui(PARROT_INTERP, ARGIN(PMC *self))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2);

static void bignum_init(PARROT_INTERP, ARGIN(PMC *self))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2);

static void bignum_mul_bignum(PARROT_INTERP,
    ARGIN(PMC *self),
    ARGIN(PMC *value),
    ARGMOD(PMC *dest))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(3)
        __attribute__nonnull__(4)
        FUNC_MODIFIES(*dest);

static void bignum_mul_bignum_float(PARROT_INTERP,
    ARGIN(PMC *self),
    FLOATVAL value,
    ARGMOD(PMC *dest))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(4)
        FUNC_MODIFIES(*dest);

static void bignum_mul_bignum_int(PARROT_INTERP,
    ARGIN(PMC *self),
    INTVAL value,
    ARGMOD(PMC *dest))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(4)
        FUNC_MODIFIES(*dest);

static void bignum_neg(PARROT_INTERP, ARGIN(PMC *self), ARGMOD(PMC *dest))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(3)
        FUNC_MODIFIES(*dest);

static void bignum_pow_bignum_int(PARROT_INTERP,
    ARGIN(PMC *self),
    INTVAL value,
    ARGMOD(PMC *dest))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(4)
        FUNC_MODIFIES(*dest);

static void bignum_set(PARROT_INTERP, ARGMOD(PMC *dest), ARGIN(PMC *src))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(3)
        FUNC_MODIFIES(*dest);

static void bignum_set_default_prec(PARROT_INTERP,
    ARGIN(PMC *self),
    INTVAL prec)
        __attribute__nonnull__(1)
        __attribute__nonnull__(2);

static void bignum_set_double(PARROT_INTERP, ARGIN(PMC *self), double value)
        __attribute__nonnull__(1)
        __attribute__nonnull__(2);

static void bignum_set_float(PARROT_INTERP,
    ARGIN(PMC *self),
    FLOATVAL value)
        __attribute__nonnull__(1)
        __attribute__nonnull__(2);

static void bignum_set_si(PARROT_INTERP, ARGIN(PMC *self), long value)
        __attribute__nonnull__(1)
        __attribute__nonnull__(2);

static void bignum_set_str(PARROT_INTERP,
    ARGIN(PMC *self),
    ARGIN(const char *value),
    int base)
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(3);

static void bignum_set_ui(PARROT_INTERP,
    ARGIN(PMC *self),
    unsigned long value)
        __attribute__nonnull__(1)
        __attribute__nonnull__(2);

static void bignum_sub_bignum(PARROT_INTERP,
    ARGIN(PMC *self),
    ARGIN(PMC *value),
    ARGMOD(PMC *dest))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(3)
        __attribute__nonnull__(4)
        FUNC_MODIFIES(*dest);

static void bignum_sub_bignum_float(PARROT_INTERP,
    ARGIN(PMC *self),
    FLOATVAL value,
    ARGMOD(PMC *dest))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(4)
        FUNC_MODIFIES(*dest);

static void bignum_sub_bignum_int(PARROT_INTERP,
    ARGIN(PMC *self),
    INTVAL value,
    ARGMOD(PMC *dest))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(4)
        FUNC_MODIFIES(*dest);

#define ASSERT_ARGS_bignum_abs __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(dest))
#define ASSERT_ARGS_bignum_add_bignum __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(value) \
    , PARROT_ASSERT_ARG(dest))
#define ASSERT_ARGS_bignum_add_bignum_float __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(dest))
#define ASSERT_ARGS_bignum_add_bignum_int __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(dest))
#define ASSERT_ARGS_bignum_clear __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self))
#define ASSERT_ARGS_bignum_cmp __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(value))
#define ASSERT_ARGS_bignum_cmp_double __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self))
#define ASSERT_ARGS_bignum_cmp_int __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self))
#define ASSERT_ARGS_bignum_cmp_ulong __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self))
#define ASSERT_ARGS_bignum_div_bignum __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(value) \
    , PARROT_ASSERT_ARG(dest))
#define ASSERT_ARGS_bignum_div_bignum_float __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(dest))
#define ASSERT_ARGS_bignum_div_bignum_int __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(dest))
#define ASSERT_ARGS_bignum_fdiv_bignum __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(value) \
    , PARROT_ASSERT_ARG(dest))
#define ASSERT_ARGS_bignum_fdiv_bignum_int __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(dest))
#define ASSERT_ARGS_bignum_get_default_prec __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self))
#define ASSERT_ARGS_bignum_get_double __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self))
#define ASSERT_ARGS_bignum_get_float __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self))
#define ASSERT_ARGS_bignum_get_si __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self))
#define ASSERT_ARGS_bignum_get_string __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self))
#define ASSERT_ARGS_bignum_get_string_size __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self))
#define ASSERT_ARGS_bignum_get_ui __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self))
#define ASSERT_ARGS_bignum_init __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self))
#define ASSERT_ARGS_bignum_mul_bignum __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(value) \
    , PARROT_ASSERT_ARG(dest))
#define ASSERT_ARGS_bignum_mul_bignum_float __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(dest))
#define ASSERT_ARGS_bignum_mul_bignum_int __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(dest))
#define ASSERT_ARGS_bignum_neg __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(dest))
#define ASSERT_ARGS_bignum_pow_bignum_int __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(dest))
#define ASSERT_ARGS_bignum_set __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(dest) \
    , PARROT_ASSERT_ARG(src))
#define ASSERT_ARGS_bignum_set_default_prec __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self))
#define ASSERT_ARGS_bignum_set_double __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self))
#define ASSERT_ARGS_bignum_set_float __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self))
#define ASSERT_ARGS_bignum_set_si __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self))
#define ASSERT_ARGS_bignum_set_str __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(value))
#define ASSERT_ARGS_bignum_set_ui __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self))
#define ASSERT_ARGS_bignum_sub_bignum __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(value) \
    , PARROT_ASSERT_ARG(dest))
#define ASSERT_ARGS_bignum_sub_bignum_float __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(dest))
#define ASSERT_ARGS_bignum_sub_bignum_int __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(dest))
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */
/* HEADERIZER END: static */

/* Uncomment to easily disable it */
/*
#ifdef PARROT_HAS_GMP
#  undef PARROT_HAS_GMP
#endif
*/
#undef PARROT_BIGNUM_CAN_BIGINT

static void
bignum_init(PARROT_INTERP, ARGIN(PMC *self)) {
    ASSERT_ARGS(bignum_init)

#ifdef PARROT_HAS_GMP
    BIGNUM * const bn = mem_gc_allocate_zeroed_typed(interp, BIGNUM);
    SETATTR_BigNum_bn(interp, self, bn);
    mpf_clear(bn->b);
    mpf_init(bn->b);
#else
    SETATTR_BigNum_bn(interp, self, NULL);
#endif
}


static void
bignum_clear(PARROT_INTERP, ARGIN(PMC *self)) {
    ASSERT_ARGS(bignum_clear)

#ifdef PARROT_HAS_GMP
    BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    mpf_clear(bn->b);
    mem_gc_free(interp, bn);
#endif
}


#ifdef PARROT_HAS_GMP

static void
bignum_set(PARROT_INTERP, ARGMOD(PMC *dest), ARGIN(PMC *src)) {
    ASSERT_ARGS(bignum_set)

    BIGNUM *bn_dest, *bn_src;
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    GETATTR_BigNum_bn(interp, src,  bn_src);
    mpf_set(bn_dest->b, bn_src->b);
}

static void
bignum_set_si(PARROT_INTERP, ARGIN(PMC *self), long value) {
    ASSERT_ARGS(bignum_set_si)

    BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    mpf_set_si(bn->b, value);
}

static void
bignum_set_ui(PARROT_INTERP, ARGIN(PMC *self), unsigned long value) {
    ASSERT_ARGS(bignum_set_ui)

    BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    mpf_set_ui(bn->b, value);
}

static void
bignum_set_float(PARROT_INTERP, ARGIN(PMC *self), FLOATVAL value) {
    ASSERT_ARGS(bignum_set_float)

    BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    mpf_set_d(bn->b, (double)value);
}

static void
bignum_set_double(PARROT_INTERP, ARGIN(PMC *self), double value) {
    ASSERT_ARGS(bignum_set_double)

    BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    mpf_set_d(bn->b, value);
}

static void
bignum_set_str(PARROT_INTERP, ARGIN(PMC *self), ARGIN(const char *value), int base) {
    ASSERT_ARGS(bignum_set_str)

    BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    mpf_set_str(bn->b, value, base);
}


PARROT_WARN_UNUSED_RESULT
static long
bignum_get_si(PARROT_INTERP, ARGIN(PMC *self)) {
    ASSERT_ARGS(bignum_get_si)

    BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    if (mpf_fits_slong_p(bn->b))
        return mpf_get_si(bn->b);

    Parrot_ex_throw_from_c_args(interp, NULL, 1, "bignum_get_si: number too big");
}

PARROT_WARN_UNUSED_RESULT
static unsigned long
bignum_get_ui(PARROT_INTERP, ARGIN(PMC *self)) {
    ASSERT_ARGS(bignum_get_ui)

    BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    if (mpf_fits_slong_p(bn->b))
        return mpf_get_ui(bn->b);

    Parrot_ex_throw_from_c_args(interp, NULL, 1, "bignum_get_ui: number too big");
}

PARROT_WARN_UNUSED_RESULT
static INTVAL
bignum_get_bool(PARROT_INTERP, ARGIN(PMC *self)) {
    BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    if (mpf_sgn(bn->b) != 0)
        return 1;
    else
        return 0;
}

PARROT_WARN_UNUSED_RESULT
PARROT_CANNOT_RETURN_NULL
static char *
bignum_get_string(PARROT_INTERP, ARGIN(PMC *self), int base) {
    ASSERT_ARGS(bignum_get_string)

    BIGNUM *bn;
    size_t  n;
    char   *s;
    mp_exp_t exponent;

    GETATTR_BigNum_bn(interp, self, bn);
    n = (mpf_get_prec(bn->b)) / log(base) * log(2);
    s = mem_gc_allocate_n_typed(interp, n + 5, char);
    return mpf_get_str(s, &exponent, base, 0, bn->b);
}

PARROT_WARN_UNUSED_RESULT
PARROT_CANNOT_RETURN_NULL
static char *
bignum_get_string_size(PARROT_INTERP, ARGIN(PMC *self), int base, int digits) {
    ASSERT_ARGS(bignum_get_string_size)

    BIGNUM *bn;
    char   *s;
    mp_exp_t exponent;

    GETATTR_BigNum_bn(interp, self, bn);
    s = mem_gc_allocate_n_typed(interp, digits + 5, char);
    return mpf_get_str(s, &exponent, base, digits, bn->b);
}

PARROT_WARN_UNUSED_RESULT
static double
bignum_get_double(PARROT_INTERP, ARGIN(PMC *self)) {
    ASSERT_ARGS(bignum_get_double)

    BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    return mpf_get_d(bn->b);
}

PARROT_WARN_UNUSED_RESULT
static FLOATVAL
bignum_get_float(PARROT_INTERP, ARGIN(PMC *self)) {
    ASSERT_ARGS(bignum_get_float)

    BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    return mpf_get_d(bn->b);
}

static void
bignum_add_bignum(PARROT_INTERP, ARGIN(PMC *self), ARGIN(PMC *value), ARGMOD(PMC *dest)) {
    ASSERT_ARGS(bignum_add_bignum)

    BIGNUM *bn_self, *bn_value, *bn_dest;
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, value, bn_value);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    mpf_add(bn_dest->b, bn_self->b, bn_value->b);
}

static void
bignum_add_bignum_int(PARROT_INTERP, ARGIN(PMC *self), INTVAL value, ARGMOD(PMC *dest)) {
    ASSERT_ARGS(bignum_add_bignum_int)

    BIGNUM *bn_self, *bn_dest;
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    if (value < 0)
        mpf_sub_ui(bn_dest->b, bn_self->b, (unsigned long int)-value);
    else
        mpf_add_ui(bn_dest->b, bn_self->b, (unsigned long int)value);
}

static void
bignum_add_bignum_float(PARROT_INTERP, ARGIN(PMC *self), FLOATVAL value, ARGMOD(PMC *dest)) {
    ASSERT_ARGS(bignum_add_bignum_float)

    BIGNUM *bn_value, *bn_self, *bn_dest;
    GETATTR_BigNum_bn(interp, self, bn_value);
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    mpf_set_d(bn_value->b, value);
    mpf_add(bn_dest->b, bn_self->b, bn_value->b);
}

static void
bignum_sub_bignum(PARROT_INTERP, ARGIN(PMC *self), ARGIN(PMC *value), ARGMOD(PMC *dest)) {
    ASSERT_ARGS(bignum_sub_bignum)

    BIGNUM *bn_self, *bn_value, *bn_dest;
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, value, bn_value);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    mpf_sub(bn_dest->b, bn_self->b, bn_value->b);
}

static void
bignum_sub_bignum_int(PARROT_INTERP, ARGIN(PMC *self), INTVAL value, ARGMOD(PMC *dest)) {
    ASSERT_ARGS(bignum_sub_bignum_int)

    BIGNUM *bn_self, *bn_dest;
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    if (value < 0)
        mpf_add_ui(bn_dest->b, bn_self->b, (unsigned long int)-value);
    else
        mpf_sub_ui(bn_dest->b, bn_self->b, (unsigned long int)value);
}

static void
bignum_sub_bignum_float(PARROT_INTERP, ARGIN(PMC *self), FLOATVAL value, ARGMOD(PMC *dest)) {
    ASSERT_ARGS(bignum_sub_bignum_float)

    BIGNUM *bn_tmp, *bn_self, *bn_dest;
    GETATTR_BigNum_bn(interp, self, bn_tmp);
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    mpf_set_d(bn_tmp->b, value);
    mpf_sub(bn_dest->b, bn_self->b, bn_tmp->b);
}

static void
bignum_mul_bignum(PARROT_INTERP, ARGIN(PMC *self), ARGIN(PMC *value), ARGMOD(PMC *dest)) {
    ASSERT_ARGS(bignum_mul_bignum)

    BIGNUM *bn_self, *bn_value, *bn_dest;
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, value, bn_value);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    mpf_mul(bn_dest->b, bn_self->b, bn_value->b);
}

static void
bignum_mul_bignum_int(PARROT_INTERP, ARGIN(PMC *self), INTVAL value, ARGMOD(PMC *dest)) {
    ASSERT_ARGS(bignum_mul_bignum_int)

    BIGNUM *bn_self, *bn_dest;
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    mpf_mul_ui(bn_dest->b, bn_self->b, (unsigned long)value);
}

static void
bignum_mul_bignum_float(PARROT_INTERP, ARGIN(PMC *self), FLOATVAL value, ARGMOD(PMC *dest)) {
    ASSERT_ARGS(bignum_mul_bignum_float)

    BIGNUM *bn_tmp, *bn_self, *bn_dest;
    GETATTR_BigNum_bn(interp, self, bn_tmp);
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    mpf_set_d(bn_tmp->b, value);
    mpf_mul(bn_dest->b, bn_self->b, bn_tmp->b);
}

static void
bignum_pow_bignum_int(PARROT_INTERP, ARGIN(PMC *self), INTVAL value, ARGMOD(PMC *dest)) {
    ASSERT_ARGS(bignum_pow_bignum_int)

    BIGNUM *bn_self, *bn_dest;
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    mpf_pow_ui(bn_dest->b, bn_self->b, (unsigned long int)value);
}

static void
int_check_divide_zero(PARROT_INTERP, INTVAL value) {
    if (value == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
            "Divide by zero");
}

static void
bignum_check_divide_zero(PARROT_INTERP, ARGIN(PMC *value)) {
    /* Throw an exception if we are dividing by zero. */
    BIGNUM *bn;
    GETATTR_BigNum_bn(interp, value, bn);
    if (mpf_cmp_si(bn->b, 0) == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
            "Divide by zero");
}

static void
bignum_div_bignum(PARROT_INTERP, ARGIN(PMC *self), ARGIN(PMC *value), ARGMOD(PMC *dest)) {
    ASSERT_ARGS(bignum_div_bignum)

    BIGNUM *bn_self, *bn_value, *bn_dest;
    bignum_check_divide_zero(interp, value);
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, value, bn_value);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    mpf_div(bn_dest->b, bn_self->b, bn_value->b);
}

static void
bignum_div_bignum_int(PARROT_INTERP, ARGIN(PMC *self), INTVAL value, ARGMOD(PMC *dest)) {
    ASSERT_ARGS(bignum_div_bignum_int)

    BIGNUM *bn_self, *bn_dest;
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    int_check_divide_zero(interp, value);

    /* this is mpz_fdiv_q */
    if (value < 0) {
        mpf_div_ui(bn_dest->b, bn_self->b, (unsigned long int)-value);
        mpf_neg(bn_dest->b, bn_dest->b);
    }
    else
        mpf_div_ui(bn_dest->b, bn_self->b, (unsigned long int)value);
}

static void
bignum_div_bignum_float(PARROT_INTERP, ARGIN(PMC *self), FLOATVAL value, ARGMOD(PMC *dest)) {
    ASSERT_ARGS(bignum_div_bignum_float)

    BIGNUM bn, *bn_self, *bn_dest;
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    int_check_divide_zero(interp, value);
    mpf_init(bn.b);

    if (value < 0) {
        mpf_set_d(bn.b, -value);
        mpf_div(bn_dest->b, bn_self->b, bn.b);
        mpf_neg(bn_dest->b, bn_dest->b);
    }
    else {
        mpf_set_d(bn.b, value);
        mpf_div(bn_dest->b, bn_self->b, bn.b);
    }
    mpf_clear(bn.b);
}

/* There's no such mpf_fdiv, only mpz_fdiv and mpf_div */
static void
bignum_fdiv_bignum(PARROT_INTERP, ARGIN(PMC *self), ARGIN(PMC *value), ARGMOD(PMC *dest)) {
    ASSERT_ARGS(bignum_fdiv_bignum)

    BIGNUM *bn_self, *bn_value, *bn_dest;
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, value, bn_value);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    bignum_check_divide_zero(interp, value);
    mpf_div(bn_dest->b, bn_self->b, bn_value->b);
}

static void
bignum_fdiv_bignum_int(PARROT_INTERP, ARGIN(PMC *self), INTVAL value, ARGMOD(PMC *dest)) {
    ASSERT_ARGS(bignum_fdiv_bignum_int)

    BIGNUM *bn_self, *bn_dest;
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    int_check_divide_zero(interp, value);

    if (value < 0) {
        mpf_div_ui(bn_dest->b, bn_self->b, (unsigned long int)-value);
        mpf_neg(bn_dest->b, bn_dest->b);
    }
    else
        mpf_div_ui(bn_dest->b, bn_self->b, (unsigned long int)value);
}

static INTVAL
bignum_cmp(PARROT_INTERP, ARGIN(PMC *self), ARGIN(PMC *value)) {
    ASSERT_ARGS(bignum_cmp)

    BIGNUM *bn_self, *bn_value;
    GETATTR_BigNum_bn(interp, self,  bn_self);
    GETATTR_BigNum_bn(interp, value, bn_value);
    return mpf_cmp(bn_self->b, bn_value->b);
}

static INTVAL
bignum_cmp_double(PARROT_INTERP, ARGIN(PMC *self), double value) {
    ASSERT_ARGS(bignum_cmp_double)

    BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    return mpf_cmp_d(bn->b, value);
}

static INTVAL
bignum_cmp_int(PARROT_INTERP, ARGIN(PMC *self), INTVAL value) {
    ASSERT_ARGS(bignum_cmp_int)

    BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    return mpf_cmp_si(bn->b, value);
}

static INTVAL
bignum_cmp_ulong(PARROT_INTERP, ARGIN(PMC *self), unsigned long value) {
    ASSERT_ARGS(bignum_cmp_ulong)

    BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    return mpf_cmp_ui(bn->b, value);
}

static void
bignum_abs(PARROT_INTERP, ARGIN(PMC *self), ARGMOD(PMC *dest)) {
    ASSERT_ARGS(bignum_abs)

    BIGNUM *bn_self, *bn_dest;
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    mpf_abs(bn_dest->b, bn_self->b);
}

static void
bignum_neg(PARROT_INTERP, ARGIN(PMC *self), ARGMOD(PMC *dest)) {
    ASSERT_ARGS(bignum_neg)

    BIGNUM *bn_self, *bn_dest;
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    mpf_neg(bn_dest->b, bn_self->b);
}

static INTVAL
bignum_get_default_prec(PARROT_INTERP, ARGIN(PMC *self)) {
    ASSERT_ARGS(bignum_get_default_prec)

    return mpf_get_default_prec();
}

static void
bignum_set_default_prec(PARROT_INTERP, ARGIN(PMC *self), INTVAL prec) {
    ASSERT_ARGS(bignum_set_default_prec)

    mpf_set_default_prec(prec);
}

/* HEADERIZER STOP */
/* Don't headerize these BIGINT and BIGNUM funcs */

PARROT_WARN_UNUSED_RESULT
PARROT_CANNOT_RETURN_NULL
static BIGNUM*
bignum_get_self(PARROT_INTERP, ARGIN(PMC *self)) {
    BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    return bn;
}

static void
bignum_set_self(PARROT_INTERP, ARGIN(PMC *self), ARGIN(BIGNUM *value)) {
    BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    mpf_set(bn->b, (mpf_srcptr)(value)->b);
}


#  ifdef PARROT_BIGNUM_CAN_BIGINT
PARROT_WARN_UNUSED_RESULT
static struct BIGINT
bignum_get_bigint(PARROT_INTERP, ARGIN(PMC *self)) {
    BIGNUM *bn;
    struct BIGINT *bi_dest;
    GETATTR_BigNum_bn(interp, self, bn);
    mpz_clear(bi_dest->b);
    mpz_init(bi_dest->b);
    if (mpf_fits_slong_p(bn->b)) {
        bi_dest->b = mpf_get_ui(bn->b);
    }
    else {
        Parrot_ex_throw_from_c_args(interp, NULL, 1,
            "bignum_get_bigint: Precision loss");
    }
    return bi_dest;
}

static void
bignum_set_bigint(PARROT_INTERP, ARGIN(PMC *self), ARGIN(struct BIGINT *value)) {
    BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    mpf_set(bn->b, (mpf_srcptr)value->b);
}
#  endif

#else /* ifdef PARROT_HAS_GMP */

typedef struct BIGNUM {
    FLOATVAL b; /* bogus definition for users without libgmp*/
} BIGNUM;

#  define THROW_NYI Parrot_ex_throw_from_c_args(interp, NULL, \
                        EXCEPTION_LIBRARY_ERROR, "no bignum lib loaded")

static void
bignum_set(PARROT_INTERP, ARGMOD(PMC *dest), PMC *src) {
    THROW_NYI;
}

static void
bignum_set_si(PARROT_INTERP, ARGIN(PMC *self), long value) {
    THROW_NYI;
}

static void
bignum_set_double(PARROT_INTERP, ARGIN(PMC *self), double value) {
    THROW_NYI;
}

static void
bignum_set_str(PARROT_INTERP, ARGIN(PMC *self), const char *value, int base) {
    THROW_NYI;
}

static void
bignum_set_self(PARROT_INTERP, ARGIN(PMC *self), BIGNUM *value) {
    THROW_NYI;
}

static BIGNUM*
bignum_get_self(PARROT_INTERP, ARGIN(PMC *self)) {
    THROW_NYI;
}

static char *
bignum_get_string(PARROT_INTERP, ARGIN(PMC *self), int base) {
    THROW_NYI;
}

static char *
bignum_get_string_size(PARROT_INTERP, ARGIN(PMC *self), int base, int digits) {
    THROW_NYI;
}

static unsigned long
bignum_get_ui(PARROT_INTERP, ARGIN(PMC *self)) {
    THROW_NYI;
}

static long
bignum_get_si(PARROT_INTERP, ARGIN(PMC *self)) {
    THROW_NYI;
}

static INTVAL
bignum_get_bool(PARROT_INTERP, ARGIN(PMC *self)) {
    THROW_NYI;
}

static double
bignum_get_double(PARROT_INTERP, ARGIN(PMC *self)) {
    THROW_NYI;
}

static void
bignum_add_bignum(PARROT_INTERP, ARGIN(PMC *self), PMC *value, ARGMOD(PMC *dest)) {
    THROW_NYI;
}

static void
bignum_add_bignum_int(PARROT_INTERP, ARGIN(PMC *self), INTVAL value, ARGMOD(PMC *dest)) {
    THROW_NYI;
}

static void
bignum_add_bignum_float(PARROT_INTERP, ARGIN(PMC *self), FLOATVAL value, ARGMOD(PMC *dest)) {
    THROW_NYI;
}

static void
bignum_sub_bignum(PARROT_INTERP, ARGIN(PMC *self), PMC *value, ARGMOD(PMC *dest)) {
    THROW_NYI;
}

static void
bignum_sub_bignum_int(PARROT_INTERP, ARGIN(PMC *self), INTVAL value, ARGMOD(PMC *dest)) {
    THROW_NYI;
}

static void
bignum_sub_bignum_float(PARROT_INTERP, ARGIN(PMC *self), FLOATVAL value, ARGMOD(PMC *dest)) {
    THROW_NYI;
}

static void
bignum_mul_bignum(PARROT_INTERP, ARGIN(PMC *self), PMC *value, ARGMOD(PMC *dest)) {
    THROW_NYI;
}

static void
bignum_mul_bignum_int(PARROT_INTERP, ARGIN(PMC *self), INTVAL value, ARGMOD(PMC *dest)) {
    THROW_NYI;
}

static void
bignum_mul_bignum_float(PARROT_INTERP, ARGIN(PMC *self), FLOATVAL value, ARGMOD(PMC *dest)) {
    THROW_NYI;
}

static void
bignum_pow_bignum_int(PARROT_INTERP, ARGIN(PMC *self), INTVAL value, ARGMOD(PMC *dest)) {
    THROW_NYI;
}

static void
bignum_pow_bignum_float(PARROT_INTERP, ARGIN(PMC *self), FLOATVAL value, ARGMOD(PMC *dest)) {
    THROW_NYI;
}

static void
bignum_div_bignum(PARROT_INTERP, ARGIN(PMC *self), PMC *value, ARGMOD(PMC *dest)) {
    THROW_NYI;
}

static void
bignum_div_bignum_int(PARROT_INTERP, ARGIN(PMC *self), INTVAL value, ARGMOD(PMC *dest)) {
    THROW_NYI;
}

static void
bignum_div_bignum_float(PARROT_INTERP, ARGIN(PMC *self), FLOATVAL value, ARGMOD(PMC *dest)) {
    THROW_NYI;
}

static void
bignum_fdiv_bignum(PARROT_INTERP, ARGIN(PMC *self), PMC *value, ARGMOD(PMC *dest)) {
    THROW_NYI;
}

static void
bignum_fdiv_bignum_int(PARROT_INTERP, ARGIN(PMC *self), INTVAL value, ARGMOD(PMC *dest)) {
    THROW_NYI;
}

static void
bignum_fdiv_bignum_float(PARROT_INTERP, ARGIN(PMC *self), FLOATVAL value, ARGMOD(PMC *dest)) {
    THROW_NYI;
}

static INTVAL
bignum_cmp(PARROT_INTERP, ARGIN(PMC *self), PMC *value) {
    THROW_NYI;
}

static INTVAL
bignum_cmp_int(PARROT_INTERP, ARGIN(PMC *self), INTVAL value) {
    THROW_NYI;
}

static INTVAL
bignum_cmp_float(PARROT_INTERP, ARGIN(PMC *self), FLOATVAL value) {
    THROW_NYI;
}

static void
bignum_abs(PARROT_INTERP, ARGIN(PMC *self), ARGMOD(PMC *dest)) {
    THROW_NYI;
}

static void
bignum_neg(PARROT_INTERP, ARGIN(PMC *self), ARGMOD(PMC *dest)) {
    THROW_NYI;
}

static INTVAL
bignum_get_default_prec(PARROT_INTERP, ARGIN(PMC *self)) {
    THROW_NYI;
}

static void
bignum_set_default_prec(PARROT_INTERP, ARGIN(PMC *self), INTVAL prec) {
    THROW_NYI;
}

#  undef THROW_NYI

#endif /* ifdef PARROT_HAS_GMP */
#line 1301 "./src/pmc/bignum.c"
static  PMC  * Parrot_BigNum_absolute(PARROT_INTERP, PMC *_self, PMC *dest);
static  PMC * Parrot_BigNum_add(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest);
static  PMC  * Parrot_BigNum_add_int(PARROT_INTERP, PMC *_self, INTVAL value, PMC *dest);
static  PMC  * Parrot_BigNum_clone(PARROT_INTERP, PMC *_self);
static  INTVAL Parrot_BigNum_cmp(PARROT_INTERP, PMC *_self, PMC *value);
static  void  Parrot_BigNum_decrement(PARROT_INTERP, PMC *_self);
static  void  Parrot_BigNum_destroy(PARROT_INTERP, PMC *_self);
static  PMC * Parrot_BigNum_divide(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest);
static  PMC  * Parrot_BigNum_divide_float(PARROT_INTERP, PMC *_self, FLOATVAL value, PMC *dest);
static  PMC  * Parrot_BigNum_divide_int(PARROT_INTERP, PMC *_self, INTVAL value, PMC *dest);
static  PMC * Parrot_BigNum_floor_divide(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest);
static  PMC  * Parrot_BigNum_floor_divide_int(PARROT_INTERP, PMC *_self, INTVAL value, PMC *dest);
static  INTVAL  Parrot_BigNum_get_bool(PARROT_INTERP, PMC *_self);
static  INTVAL  Parrot_BigNum_get_integer(PARROT_INTERP, PMC *_self);
static  FLOATVAL  Parrot_BigNum_get_number(PARROT_INTERP, PMC *_self);
static  STRING  * Parrot_BigNum_get_repr(PARROT_INTERP, PMC *_self);
static  STRING  * Parrot_BigNum_get_string(PARROT_INTERP, PMC *_self);
static  STRING  * Parrot_BigNum_get_string_keyed_int(PARROT_INTERP, PMC *_self, INTVAL base);
static  void  Parrot_BigNum_i_absolute(PARROT_INTERP, PMC *_self);
static  void Parrot_BigNum_i_add(PARROT_INTERP, PMC *_self, PMC *value);
static  void  Parrot_BigNum_i_add_float(PARROT_INTERP, PMC *_self, FLOATVAL value);
static  void  Parrot_BigNum_i_add_int(PARROT_INTERP, PMC *_self, INTVAL value);
static  void Parrot_BigNum_i_divide(PARROT_INTERP, PMC *_self, PMC *value);
static  void  Parrot_BigNum_i_divide_int(PARROT_INTERP, PMC *_self, INTVAL value);
static  void Parrot_BigNum_i_floor_divide(PARROT_INTERP, PMC *_self, PMC *value);
static  void  Parrot_BigNum_i_floor_divide_int(PARROT_INTERP, PMC *_self, INTVAL value);
static  void Parrot_BigNum_i_multiply(PARROT_INTERP, PMC *_self, PMC *value);
static  void  Parrot_BigNum_i_multiply_float(PARROT_INTERP, PMC *_self, FLOATVAL value);
static  void  Parrot_BigNum_i_multiply_int(PARROT_INTERP, PMC *_self, INTVAL value);
static  void  Parrot_BigNum_i_neg(PARROT_INTERP, PMC *_self);
static  void Parrot_BigNum_i_subtract(PARROT_INTERP, PMC *_self, PMC *value);
static  void  Parrot_BigNum_i_subtract_float(PARROT_INTERP, PMC *_self, FLOATVAL value);
static  void  Parrot_BigNum_i_subtract_int(PARROT_INTERP, PMC *_self, INTVAL value);
static  void  Parrot_BigNum_increment(PARROT_INTERP, PMC *_self);
static  void  Parrot_BigNum_init(PARROT_INTERP, PMC *_self);
static  INTVAL Parrot_BigNum_is_equal(PARROT_INTERP, PMC *_self, PMC *value);
static  PMC * Parrot_BigNum_multiply(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest);
static  PMC  * Parrot_BigNum_multiply_int(PARROT_INTERP, PMC *_self, INTVAL value, PMC *dest);
static  PMC  * Parrot_BigNum_neg(PARROT_INTERP, PMC *_self, PMC *dest);
static  void  Parrot_BigNum_set_integer_native(PARROT_INTERP, PMC *_self, INTVAL value);
static  void  Parrot_BigNum_set_number_native(PARROT_INTERP, PMC *_self, FLOATVAL value);
static  void  Parrot_BigNum_set_pmc(PARROT_INTERP, PMC *_self, PMC *value);
static  void  Parrot_BigNum_set_string_keyed_int(PARROT_INTERP, PMC *_self, INTVAL base, STRING *value);
static  void  Parrot_BigNum_set_string_native(PARROT_INTERP, PMC *_self, STRING *value);
static  PMC * Parrot_BigNum_subtract(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest);
static  PMC  * Parrot_BigNum_subtract_int(PARROT_INTERP, PMC *_self, INTVAL value, PMC *dest);
static  void Parrot_BigNum_nci_version(PARROT_INTERP, PMC *_self);
static  PMC  * Parrot_BigNum_multi_add_BigNum_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest);
static  PMC  * Parrot_BigNum_multi_add_Integer_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest);
static  PMC  * Parrot_BigNum_multi_add_DEFAULT_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest);
static  void  Parrot_BigNum_multi_i_add_BigNum(PARROT_INTERP, PMC *_self, PMC *value);
static  void  Parrot_BigNum_multi_i_add_Integer(PARROT_INTERP, PMC *_self, PMC *value);
static  void  Parrot_BigNum_multi_i_add_Float(PARROT_INTERP, PMC *_self, PMC *value);
static  void  Parrot_BigNum_multi_i_add_DEFAULT(PARROT_INTERP, PMC *_self, PMC *value);
static  PMC  * Parrot_BigNum_multi_subtract_BigNum_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest);
static  PMC  * Parrot_BigNum_multi_subtract_Integer_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest);
static  PMC  * Parrot_BigNum_multi_subtract_DEFAULT_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest);
static  void  Parrot_BigNum_multi_i_subtract_BigNum(PARROT_INTERP, PMC *_self, PMC *value);
static  void  Parrot_BigNum_multi_i_subtract_Integer(PARROT_INTERP, PMC *_self, PMC *value);
static  void  Parrot_BigNum_multi_i_subtract_Float(PARROT_INTERP, PMC *_self, PMC *value);
static  void  Parrot_BigNum_multi_i_subtract_DEFAULT(PARROT_INTERP, PMC *_self, PMC *value);
static  PMC  * Parrot_BigNum_multi_multiply_BigNum_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest);
static  PMC  * Parrot_BigNum_multi_multiply_Integer_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest);
static  PMC  * Parrot_BigNum_multi_multiply_DEFAULT_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest);
static  void  Parrot_BigNum_multi_i_multiply_BigNum(PARROT_INTERP, PMC *_self, PMC *value);
static  void  Parrot_BigNum_multi_i_multiply_Float(PARROT_INTERP, PMC *_self, PMC *value);
static  void  Parrot_BigNum_multi_i_multiply_Integer(PARROT_INTERP, PMC *_self, PMC *value);
static  void  Parrot_BigNum_multi_i_multiply_DEFAULT(PARROT_INTERP, PMC *_self, PMC *value);
static  void Parrot_BigNum_nci_pow(PARROT_INTERP, PMC *_self);
static  PMC  * Parrot_BigNum_multi_divide_BigNum_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest);
static  PMC  * Parrot_BigNum_multi_divide_Integer_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest);
static  PMC  * Parrot_BigNum_multi_divide_DEFAULT_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest);
static  void  Parrot_BigNum_multi_i_divide_BigNum(PARROT_INTERP, PMC *_self, PMC *value);
static  void  Parrot_BigNum_multi_i_divide_Integer(PARROT_INTERP, PMC *_self, PMC *value);
static  void  Parrot_BigNum_multi_i_divide_Float(PARROT_INTERP, PMC *_self, PMC *value);
static  void  Parrot_BigNum_multi_i_divide_DEFAULT(PARROT_INTERP, PMC *_self, PMC *value);
static  PMC  * Parrot_BigNum_multi_floor_divide_BigNum_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest);
static  PMC  * Parrot_BigNum_multi_floor_divide_Integer_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest);
static  PMC  * Parrot_BigNum_multi_floor_divide_DEFAULT_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest);
static  void  Parrot_BigNum_multi_i_floor_divide_BigNum(PARROT_INTERP, PMC *_self, PMC *value);
static  void  Parrot_BigNum_multi_i_floor_divide_Integer(PARROT_INTERP, PMC *_self, PMC *value);
static  void  Parrot_BigNum_multi_i_floor_divide_DEFAULT(PARROT_INTERP, PMC *_self, PMC *value);
static  INTVAL  Parrot_BigNum_multi_cmp_BigNum(PARROT_INTERP, PMC *_self, PMC *value);
static  INTVAL  Parrot_BigNum_multi_cmp_Integer(PARROT_INTERP, PMC *_self, PMC *value);
static  INTVAL  Parrot_BigNum_multi_cmp_DEFAULT(PARROT_INTERP, PMC *_self, PMC *value);
static  INTVAL  Parrot_BigNum_multi_is_equal_BigNum(PARROT_INTERP, PMC *_self, PMC *value);
static  INTVAL  Parrot_BigNum_multi_is_equal_Integer(PARROT_INTERP, PMC *_self, PMC *value);
static  INTVAL  Parrot_BigNum_multi_is_equal_DEFAULT(PARROT_INTERP, PMC *_self, PMC *value);
void    Parrot_BigNum_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_BigNum_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_BigNum_get_vtable(PARROT_INTERP);
void    Parrot_BigNum_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_BigNum_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_BigNum_ro_get_vtable(PARROT_INTERP);
static  PMC  *
Parrot_BigNum_absolute(PARROT_INTERP, PMC *_self, PMC *dest)
{
#line 1929 "./src/pmc/bignum.pmc"

    dest = Parrot_pmc_new(interp, _self->vtable->base_type);

    bignum_abs(interp, _self, dest);
    return dest;
#line 1405 "./src/pmc/bignum.c"
}
static  PMC *
Parrot_BigNum_add(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigNum:
            return Parrot_BigNum_multi_add_BigNum_PMC(interp, _self, value, dest);
            break;

        case enum_class_Integer:
            return Parrot_BigNum_multi_add_Integer_PMC(interp, _self, value, dest);
            break;

        default:
            if (type < enum_class_core_max)
                return Parrot_BigNum_multi_add_DEFAULT_PMC(interp, _self, value, dest);
            else {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "add", "PPP->P", _self, value, dest, &retval);
                return retval;
            }
            break;

    }
}
static  PMC  *
Parrot_BigNum_add_int(PARROT_INTERP, PMC *_self, INTVAL value, PMC *dest)
{
#line 1570 "./src/pmc/bignum.pmc"

    dest = Parrot_pmc_new(interp, _self->vtable->base_type);

    bignum_add_bignum_int(interp, _self, value, dest);
    return dest;
#line 1444 "./src/pmc/bignum.c"
}
static  PMC  *
Parrot_BigNum_clone(PARROT_INTERP, PMC *_self)
{
#line 1313 "./src/pmc/bignum.pmc"

    PMC * const res = Parrot_pmc_new(interp, _self->vtable->base_type);
    bignum_set(interp, res, _self);
    return res;
#line 1454 "./src/pmc/bignum.c"
}
static  INTVAL
Parrot_BigNum_cmp(PARROT_INTERP, PMC *_self, PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigNum:
            return Parrot_BigNum_multi_cmp_BigNum(interp, _self, value);
            break;

        case enum_class_Integer:
            return Parrot_BigNum_multi_cmp_Integer(interp, _self, value);
            break;

        default:
            if (type < enum_class_core_max)
                return Parrot_BigNum_multi_cmp_DEFAULT(interp, _self, value);
            else {
                INTVAL retval;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "cmp", "PP->I", _self, value, &retval);
                return retval;
            }
            break;

    }
}
static  void 
Parrot_BigNum_decrement(PARROT_INTERP, PMC *_self)
{
#line 1537 "./src/pmc/bignum.pmc"

    bignum_sub_bignum_int(interp, _self, 1, _self);
#line 1490 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_destroy(PARROT_INTERP, PMC *_self)
{
#line 1319 "./src/pmc/bignum.pmc"

    bignum_clear(interp, _self);
#line 1498 "./src/pmc/bignum.c"
}
static  PMC *
Parrot_BigNum_divide(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigNum:
            return Parrot_BigNum_multi_divide_BigNum_PMC(interp, _self, value, dest);
            break;

        case enum_class_Integer:
            return Parrot_BigNum_multi_divide_Integer_PMC(interp, _self, value, dest);
            break;

        default:
            if (type < enum_class_core_max)
                return Parrot_BigNum_multi_divide_DEFAULT_PMC(interp, _self, value, dest);
            else {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "divide", "PPP->P", _self, value, dest, &retval);
                return retval;
            }
            break;

    }
}
static  PMC  *
Parrot_BigNum_divide_float(PARROT_INTERP, PMC *_self, FLOATVAL value, PMC *dest)
{
#line 1789 "./src/pmc/bignum.pmc"

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    bignum_div_bignum_float(interp, _self, value, dest);
    return dest;
#line 1537 "./src/pmc/bignum.c"
}
static  PMC  *
Parrot_BigNum_divide_int(PARROT_INTERP, PMC *_self, INTVAL value, PMC *dest)
{
#line 1782 "./src/pmc/bignum.pmc"

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    bignum_div_bignum_int(interp, _self, value, dest);
    return dest;
#line 1548 "./src/pmc/bignum.c"
}
static  PMC *
Parrot_BigNum_floor_divide(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigNum:
            return Parrot_BigNum_multi_floor_divide_BigNum_PMC(interp, _self, value, dest);
            break;

        case enum_class_Integer:
            return Parrot_BigNum_multi_floor_divide_Integer_PMC(interp, _self, value, dest);
            break;

        default:
            if (type < enum_class_core_max)
                return Parrot_BigNum_multi_floor_divide_DEFAULT_PMC(interp, _self, value, dest);
            else {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "floor_divide", "PPP->P", _self, value, dest, &retval);
                return retval;
            }
            break;

    }
}
static  PMC  *
Parrot_BigNum_floor_divide_int(PARROT_INTERP, PMC *_self, INTVAL value, PMC *dest)
{
#line 1845 "./src/pmc/bignum.pmc"

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    bignum_fdiv_bignum_int(interp, _self, value, dest);
    return dest;
#line 1587 "./src/pmc/bignum.c"
}
static  INTVAL 
Parrot_BigNum_get_bool(PARROT_INTERP, PMC *_self)
{
#line 1460 "./src/pmc/bignum.pmc"

    return bignum_get_bool(interp, _self);
#line 1595 "./src/pmc/bignum.c"
}
static  INTVAL 
Parrot_BigNum_get_integer(PARROT_INTERP, PMC *_self)
{
#line 1413 "./src/pmc/bignum.pmc"

    return bignum_get_si(interp, _self);
#line 1603 "./src/pmc/bignum.c"
}
static  FLOATVAL 
Parrot_BigNum_get_number(PARROT_INTERP, PMC *_self)
{
#line 1399 "./src/pmc/bignum.pmc"

    return bignum_get_double(interp, _self);
#line 1611 "./src/pmc/bignum.c"
}
static  STRING  *
Parrot_BigNum_get_repr(PARROT_INTERP, PMC *_self)
{
#line 1509 "./src/pmc/bignum.pmc"

    STRING *s = VTABLE_get_string(interp, _self);
    return Parrot_str_concat(interp, s, Parrot_str_new(interp, "N", 1));
#line 1620 "./src/pmc/bignum.c"
}
static  STRING  *
Parrot_BigNum_get_string(PARROT_INTERP, PMC *_self)
{
#line 1488 "./src/pmc/bignum.pmc"

    char   *s  = bignum_get_string(interp, _self, 10);
    STRING *ps = Parrot_str_new(interp, s, 0);
    mem_gc_free(interp, s);
    return ps;
#line 1631 "./src/pmc/bignum.c"
}
static  STRING  *
Parrot_BigNum_get_string_keyed_int(PARROT_INTERP, PMC *_self, INTVAL base)
{
#line 1495 "./src/pmc/bignum.pmc"

    char   *s  = bignum_get_string(interp, _self, base);
    STRING *ps = Parrot_str_new(interp, s, 0);
    mem_gc_free(interp, s);
    return ps;
#line 1642 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_i_absolute(PARROT_INTERP, PMC *_self)
{
#line 1936 "./src/pmc/bignum.pmc"

    bignum_abs(interp, _self, _self);
#line 1650 "./src/pmc/bignum.c"
}
static  void
Parrot_BigNum_i_add(PARROT_INTERP, PMC *_self, PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigNum:
            Parrot_BigNum_multi_i_add_BigNum(interp, _self, value);
            break;

        case enum_class_Integer:
            Parrot_BigNum_multi_i_add_Integer(interp, _self, value);
            break;

        case enum_class_Float:
            Parrot_BigNum_multi_i_add_Float(interp, _self, value);
            break;

        default:
            if (type < enum_class_core_max)
                Parrot_BigNum_multi_i_add_DEFAULT(interp, _self, value);
            else {
                
                Parrot_mmd_multi_dispatch_from_c_args(interp, "i_add", "PP->", _self, value);
                return;
            }
            break;

    }
}
static  void 
Parrot_BigNum_i_add_float(PARROT_INTERP, PMC *_self, FLOATVAL value)
{
#line 1600 "./src/pmc/bignum.pmc"

    bignum_add_bignum_float(interp, _self, value, _self);
#line 1690 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_i_add_int(PARROT_INTERP, PMC *_self, INTVAL value)
{
#line 1596 "./src/pmc/bignum.pmc"

    bignum_add_bignum_int(interp, _self, value, _self);
#line 1698 "./src/pmc/bignum.c"
}
static  void
Parrot_BigNum_i_divide(PARROT_INTERP, PMC *_self, PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigNum:
            Parrot_BigNum_multi_i_divide_BigNum(interp, _self, value);
            break;

        case enum_class_Integer:
            Parrot_BigNum_multi_i_divide_Integer(interp, _self, value);
            break;

        case enum_class_Float:
            Parrot_BigNum_multi_i_divide_Float(interp, _self, value);
            break;

        default:
            if (type < enum_class_core_max)
                Parrot_BigNum_multi_i_divide_DEFAULT(interp, _self, value);
            else {
                
                Parrot_mmd_multi_dispatch_from_c_args(interp, "i_divide", "PP->", _self, value);
                return;
            }
            break;

    }
}
static  void 
Parrot_BigNum_i_divide_int(PARROT_INTERP, PMC *_self, INTVAL value)
{
#line 1812 "./src/pmc/bignum.pmc"

    bignum_div_bignum_int(interp, _self, value, _self);
#line 1738 "./src/pmc/bignum.c"
}
static  void
Parrot_BigNum_i_floor_divide(PARROT_INTERP, PMC *_self, PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigNum:
            Parrot_BigNum_multi_i_floor_divide_BigNum(interp, _self, value);
            break;

        case enum_class_Integer:
            Parrot_BigNum_multi_i_floor_divide_Integer(interp, _self, value);
            break;

        default:
            if (type < enum_class_core_max)
                Parrot_BigNum_multi_i_floor_divide_DEFAULT(interp, _self, value);
            else {
                
                Parrot_mmd_multi_dispatch_from_c_args(interp, "i_floor_divide", "PP->", _self, value);
                return;
            }
            break;

    }
}
static  void 
Parrot_BigNum_i_floor_divide_int(PARROT_INTERP, PMC *_self, INTVAL value)
{
#line 1867 "./src/pmc/bignum.pmc"

    bignum_fdiv_bignum_int(interp, _self, value, _self);
#line 1774 "./src/pmc/bignum.c"
}
static  void
Parrot_BigNum_i_multiply(PARROT_INTERP, PMC *_self, PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigNum:
            Parrot_BigNum_multi_i_multiply_BigNum(interp, _self, value);
            break;

        case enum_class_Float:
            Parrot_BigNum_multi_i_multiply_Float(interp, _self, value);
            break;

        case enum_class_Integer:
            Parrot_BigNum_multi_i_multiply_Integer(interp, _self, value);
            break;

        default:
            if (type < enum_class_core_max)
                Parrot_BigNum_multi_i_multiply_DEFAULT(interp, _self, value);
            else {
                
                Parrot_mmd_multi_dispatch_from_c_args(interp, "i_multiply", "PP->", _self, value);
                return;
            }
            break;

    }
}
static  void 
Parrot_BigNum_i_multiply_float(PARROT_INTERP, PMC *_self, FLOATVAL value)
{
#line 1726 "./src/pmc/bignum.pmc"

    bignum_mul_bignum_float(interp, _self, value, _self);
#line 1814 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_i_multiply_int(PARROT_INTERP, PMC *_self, INTVAL value)
{
#line 1722 "./src/pmc/bignum.pmc"

    bignum_mul_bignum_int(interp, _self, value, _self);
#line 1822 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_i_neg(PARROT_INTERP, PMC *_self)
{
#line 1960 "./src/pmc/bignum.pmc"

    bignum_neg(interp, _self, _self);
#line 1830 "./src/pmc/bignum.c"
}
static  void
Parrot_BigNum_i_subtract(PARROT_INTERP, PMC *_self, PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigNum:
            Parrot_BigNum_multi_i_subtract_BigNum(interp, _self, value);
            break;

        case enum_class_Integer:
            Parrot_BigNum_multi_i_subtract_Integer(interp, _self, value);
            break;

        case enum_class_Float:
            Parrot_BigNum_multi_i_subtract_Float(interp, _self, value);
            break;

        default:
            if (type < enum_class_core_max)
                Parrot_BigNum_multi_i_subtract_DEFAULT(interp, _self, value);
            else {
                
                Parrot_mmd_multi_dispatch_from_c_args(interp, "i_subtract", "PP->", _self, value);
                return;
            }
            break;

    }
}
static  void 
Parrot_BigNum_i_subtract_float(PARROT_INTERP, PMC *_self, FLOATVAL value)
{
#line 1663 "./src/pmc/bignum.pmc"

    bignum_sub_bignum_float(interp, _self, value, _self);
#line 1870 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_i_subtract_int(PARROT_INTERP, PMC *_self, INTVAL value)
{
#line 1659 "./src/pmc/bignum.pmc"

    bignum_sub_bignum_int(interp, _self, value, _self);
#line 1878 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_increment(PARROT_INTERP, PMC *_self)
{
#line 1523 "./src/pmc/bignum.pmc"

    bignum_add_bignum_int(interp, _self, 1, _self);
#line 1886 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_init(PARROT_INTERP, PMC *_self)
{
#line 1308 "./src/pmc/bignum.pmc"

    bignum_init(interp, _self);
    PObj_custom_destroy_SET(_self);
#line 1895 "./src/pmc/bignum.c"
}
static  INTVAL
Parrot_BigNum_is_equal(PARROT_INTERP, PMC *_self, PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigNum:
            return Parrot_BigNum_multi_is_equal_BigNum(interp, _self, value);
            break;

        case enum_class_Integer:
            return Parrot_BigNum_multi_is_equal_Integer(interp, _self, value);
            break;

        default:
            if (type < enum_class_core_max)
                return Parrot_BigNum_multi_is_equal_DEFAULT(interp, _self, value);
            else {
                INTVAL retval;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "is_equal", "PP->I", _self, value, &retval);
                return retval;
            }
            break;

    }
}
static  PMC *
Parrot_BigNum_multiply(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigNum:
            return Parrot_BigNum_multi_multiply_BigNum_PMC(interp, _self, value, dest);
            break;

        case enum_class_Integer:
            return Parrot_BigNum_multi_multiply_Integer_PMC(interp, _self, value, dest);
            break;

        default:
            if (type < enum_class_core_max)
                return Parrot_BigNum_multi_multiply_DEFAULT_PMC(interp, _self, value, dest);
            else {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "multiply", "PPP->P", _self, value, dest, &retval);
                return retval;
            }
            break;

    }
}
static  PMC  *
Parrot_BigNum_multiply_int(PARROT_INTERP, PMC *_self, INTVAL value, PMC *dest)
{
#line 1696 "./src/pmc/bignum.pmc"

    dest = Parrot_pmc_new(interp, _self->vtable->base_type);

    bignum_mul_bignum_int(interp, _self, value, dest);
    return dest;
#line 1962 "./src/pmc/bignum.c"
}
static  PMC  *
Parrot_BigNum_neg(PARROT_INTERP, PMC *_self, PMC *dest)
{
#line 1953 "./src/pmc/bignum.pmc"

    dest = Parrot_pmc_new(interp, _self->vtable->base_type);

    bignum_neg(interp, _self, dest);
    return dest;
#line 1973 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_set_integer_native(PARROT_INTERP, PMC *_self, INTVAL value)
{
#line 1331 "./src/pmc/bignum.pmc"

    bignum_set_si(interp, _self, (long)value);
#line 1981 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_set_number_native(PARROT_INTERP, PMC *_self, FLOATVAL value)
{
#line 1345 "./src/pmc/bignum.pmc"

    bignum_set_double(interp, _self, (double)value);
#line 1989 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_set_pmc(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 1385 "./src/pmc/bignum.pmc"

    bignum_set_self(interp, _self, bignum_get_self(interp, value));
#line 1997 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_set_string_keyed_int(PARROT_INTERP, PMC *_self, INTVAL base, STRING *value)
{
#line 1370 "./src/pmc/bignum.pmc"

    char * const s = Parrot_str_to_cstring(interp, value);
    bignum_set_str(interp, _self, s, base);
    Parrot_str_free_cstring(s);
#line 2007 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_set_string_native(PARROT_INTERP, PMC *_self, STRING *value)
{
#line 1364 "./src/pmc/bignum.pmc"

    char * const s = Parrot_str_to_cstring(interp, value);
    bignum_set_str(interp, _self, s, 10);
    Parrot_str_free_cstring(s);
#line 2017 "./src/pmc/bignum.c"
}
static  PMC *
Parrot_BigNum_subtract(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigNum:
            return Parrot_BigNum_multi_subtract_BigNum_PMC(interp, _self, value, dest);
            break;

        case enum_class_Integer:
            return Parrot_BigNum_multi_subtract_Integer_PMC(interp, _self, value, dest);
            break;

        default:
            if (type < enum_class_core_max)
                return Parrot_BigNum_multi_subtract_DEFAULT_PMC(interp, _self, value, dest);
            else {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "subtract", "PPP->P", _self, value, dest, &retval);
                return retval;
            }
            break;

    }
}
static  PMC  *
Parrot_BigNum_subtract_int(PARROT_INTERP, PMC *_self, INTVAL value, PMC *dest)
{
#line 1633 "./src/pmc/bignum.pmc"

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    bignum_sub_bignum_int(interp, _self, value, dest);
    return dest;
#line 2056 "./src/pmc/bignum.c"
}
static  void
Parrot_BigNum_nci_version(PARROT_INTERP, PMC *_self)
{
#line 422 "/home/mandrake/rpm/BUILD/parrot-2.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 2068 "./src/pmc/bignum.pmc"
PMC* _self;

#line 430 "/home/mandrake/rpm/BUILD/parrot-2.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
#line 434 "/home/mandrake/rpm/BUILD/parrot-2.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 1298 "./src/pmc/bignum.pmc"

    STRING *version;
#ifdef PARROT_HAS_GMP
    version = Parrot_str_new(interp, gmp_version, 0);
#else
    version = Parrot_str_new(interp, "0.0.0", 5);
#endif
    #line 260 "/home/mandrake/rpm/BUILD/parrot-2.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *version */
#line 267 "/home/mandrake/rpm/BUILD/parrot-2.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "S", (STRING*)version);
    return;
    /*END RETURN STRING *version */
    }
#line 1305 "./src/pmc/bignum.pmc"

#line 441 "/home/mandrake/rpm/BUILD/parrot-2.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 2100 "./src/pmc/bignum.c"
}
static  PMC  *
Parrot_BigNum_multi_add_BigNum_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest)
{
#line 1549 "./src/pmc/bignum.pmc"

    dest = Parrot_pmc_new(interp, _self->vtable->base_type);

    bignum_add_bignum(interp, _self, value, dest);
    return dest;
#line 2111 "./src/pmc/bignum.c"
}
static  PMC  *
Parrot_BigNum_multi_add_Integer_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest)
{
#line 1556 "./src/pmc/bignum.pmc"

    dest = Parrot_pmc_new(interp, _self->vtable->base_type);

    bignum_add_bignum_int(interp, _self, VTABLE_get_integer(interp, value), dest);
    return dest;
#line 2122 "./src/pmc/bignum.c"
}
static  PMC  *
Parrot_BigNum_multi_add_DEFAULT_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest)
{
#line 1563 "./src/pmc/bignum.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigNum: no multiple dispatch variant 'add' for %Ss",
        VTABLE_name(interp, value));
#line 2133 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_multi_i_add_BigNum(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 1577 "./src/pmc/bignum.pmc"

    bignum_add_bignum(interp, _self, value, _self);
#line 2141 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_multi_i_add_Integer(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 1581 "./src/pmc/bignum.pmc"

    bignum_add_bignum_int(interp, _self, VTABLE_get_integer(interp, value), _self);
#line 2149 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_multi_i_add_Float(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 1585 "./src/pmc/bignum.pmc"

    bignum_add_bignum_float(interp, _self, VTABLE_get_number(interp, value), _self);
#line 2157 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_multi_i_add_DEFAULT(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 1589 "./src/pmc/bignum.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigNum: no multiple dispatch variant 'i_add' for %Ss",
        VTABLE_name(interp, value));
#line 2168 "./src/pmc/bignum.c"
}
static  PMC  *
Parrot_BigNum_multi_subtract_BigNum_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest)
{
#line 1612 "./src/pmc/bignum.pmc"

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    bignum_sub_bignum(interp, _self, value, dest);
    return dest;
#line 2179 "./src/pmc/bignum.c"
}
static  PMC  *
Parrot_BigNum_multi_subtract_Integer_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest)
{
#line 1619 "./src/pmc/bignum.pmc"

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    bignum_sub_bignum_int(interp, _self, VTABLE_get_integer(interp, value), dest);
    return dest;
#line 2190 "./src/pmc/bignum.c"
}
static  PMC  *
Parrot_BigNum_multi_subtract_DEFAULT_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest)
{
#line 1626 "./src/pmc/bignum.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigNum: no multiple dispatch variant 'subtract' for %Ss",
        VTABLE_name(interp, value));
#line 2201 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_multi_i_subtract_BigNum(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 1640 "./src/pmc/bignum.pmc"

    bignum_sub_bignum(interp, _self, value, _self);
#line 2209 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_multi_i_subtract_Integer(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 1644 "./src/pmc/bignum.pmc"

    bignum_sub_bignum_int(interp, _self, VTABLE_get_integer(interp, value), _self);
#line 2217 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_multi_i_subtract_Float(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 1648 "./src/pmc/bignum.pmc"

    bignum_sub_bignum_float(interp, _self, VTABLE_get_number(interp, value), _self);
#line 2225 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_multi_i_subtract_DEFAULT(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 1652 "./src/pmc/bignum.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigNum: no multiple dispatch variant 'i_subtract' for %Ss",
        VTABLE_name(interp, value));
#line 2236 "./src/pmc/bignum.c"
}
static  PMC  *
Parrot_BigNum_multi_multiply_BigNum_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest)
{
#line 1675 "./src/pmc/bignum.pmc"

    dest = Parrot_pmc_new(interp, _self->vtable->base_type);

    bignum_mul_bignum(interp, _self, value, dest);
    return dest;
#line 2247 "./src/pmc/bignum.c"
}
static  PMC  *
Parrot_BigNum_multi_multiply_Integer_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest)
{
#line 1682 "./src/pmc/bignum.pmc"

    dest = Parrot_pmc_new(interp, _self->vtable->base_type);

    bignum_mul_bignum_int(interp, _self, VTABLE_get_integer(interp, value), dest);
    return dest;
#line 2258 "./src/pmc/bignum.c"
}
static  PMC  *
Parrot_BigNum_multi_multiply_DEFAULT_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest)
{
#line 1689 "./src/pmc/bignum.pmc"

     Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigNum: no multiple dispatch variant 'multiply' for %Ss",
        VTABLE_name(interp, value));
#line 2269 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_multi_i_multiply_BigNum(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 1703 "./src/pmc/bignum.pmc"

    bignum_mul_bignum(interp, _self, value, _self);
#line 2277 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_multi_i_multiply_Float(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 1707 "./src/pmc/bignum.pmc"

    bignum_mul_bignum_float(interp, _self, VTABLE_get_number(interp, value), _self);
#line 2285 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_multi_i_multiply_Integer(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 1711 "./src/pmc/bignum.pmc"

    bignum_mul_bignum_int(interp, _self, VTABLE_get_integer(interp, value), _self);
#line 2293 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_multi_i_multiply_DEFAULT(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 1715 "./src/pmc/bignum.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigNum: no multiple dispatch variant 'i_multiply' for %Ss",
        VTABLE_name(interp, value));
#line 2304 "./src/pmc/bignum.c"
}
static  void
Parrot_BigNum_nci_pow(PARROT_INTERP, PMC *_self)
{
#line 422 "/home/mandrake/rpm/BUILD/parrot-2.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 2316 "./src/pmc/bignum.pmc"
PMC* _self;
PMC* value;

#line 430 "/home/mandrake/rpm/BUILD/parrot-2.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiP",
            &_self, &value);
#line 434 "/home/mandrake/rpm/BUILD/parrot-2.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 1744 "./src/pmc/bignum.pmc"

    /* only Integer RHS currently. TODO: check number and bignum types */
    INTVAL r = VTABLE_get_integer(interp, value);
    PMC *dest = Parrot_pmc_new(interp, _self->vtable->base_type);

    bignum_pow_bignum_int(interp, _self, r, dest);
    #line 260 "/home/mandrake/rpm/BUILD/parrot-2.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *dest */
#line 267 "/home/mandrake/rpm/BUILD/parrot-2.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "P", (PMC*)dest);
    return;
    /*END RETURN PMC *dest */
    }
#line 1750 "./src/pmc/bignum.pmc"

#line 441 "/home/mandrake/rpm/BUILD/parrot-2.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 2348 "./src/pmc/bignum.c"
}
static  PMC  *
Parrot_BigNum_multi_divide_BigNum_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest)
{
#line 1761 "./src/pmc/bignum.pmc"

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    bignum_div_bignum(interp, _self, value, dest);
    return dest;
#line 2359 "./src/pmc/bignum.c"
}
static  PMC  *
Parrot_BigNum_multi_divide_Integer_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest)
{
#line 1768 "./src/pmc/bignum.pmc"

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    bignum_div_bignum_int(interp, _self, VTABLE_get_integer(interp, value), dest);
    return dest;
#line 2370 "./src/pmc/bignum.c"
}
static  PMC  *
Parrot_BigNum_multi_divide_DEFAULT_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest)
{
#line 1775 "./src/pmc/bignum.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigNum: no multiple dispatch variant 'divide' for %Ss",
        VTABLE_name(interp, value));
#line 2381 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_multi_i_divide_BigNum(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 1796 "./src/pmc/bignum.pmc"

    bignum_div_bignum(interp, _self, value, _self);
#line 2389 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_multi_i_divide_Integer(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 1799 "./src/pmc/bignum.pmc"

    bignum_div_bignum_int(interp, _self, VTABLE_get_integer(interp, value), _self);
#line 2397 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_multi_i_divide_Float(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 1802 "./src/pmc/bignum.pmc"

    bignum_div_bignum_float(interp, _self, VTABLE_get_integer(interp, value), _self);
#line 2405 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_multi_i_divide_DEFAULT(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 1805 "./src/pmc/bignum.pmc"

     Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigNum: no multiple dispatch variant 'i_divide' for %Ss",
        VTABLE_name(interp, value));
#line 2416 "./src/pmc/bignum.c"
}
static  PMC  *
Parrot_BigNum_multi_floor_divide_BigNum_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest)
{
#line 1824 "./src/pmc/bignum.pmc"

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    bignum_fdiv_bignum(interp, _self, value, dest);
    return dest;
#line 2427 "./src/pmc/bignum.c"
}
static  PMC  *
Parrot_BigNum_multi_floor_divide_Integer_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest)
{
#line 1831 "./src/pmc/bignum.pmc"

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    bignum_fdiv_bignum_int(interp, _self, VTABLE_get_integer(interp, value), dest);
    return dest;
#line 2438 "./src/pmc/bignum.c"
}
static  PMC  *
Parrot_BigNum_multi_floor_divide_DEFAULT_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest)
{
#line 1838 "./src/pmc/bignum.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigNum: no multiple dispatch variant 'floor_divide' for %Ss",
        VTABLE_name(interp, value));
#line 2449 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_multi_i_floor_divide_BigNum(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 1852 "./src/pmc/bignum.pmc"

    bignum_fdiv_bignum(interp, _self, value, _self);
#line 2457 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_multi_i_floor_divide_Integer(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 1856 "./src/pmc/bignum.pmc"

    bignum_fdiv_bignum_int(interp, _self, VTABLE_get_integer(interp, value), _self);
#line 2465 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_multi_i_floor_divide_DEFAULT(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 1860 "./src/pmc/bignum.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigNum: no multiple dispatch variant 'i_floor_divide' for %Ss",
        VTABLE_name(interp, value));
#line 2476 "./src/pmc/bignum.c"
}
static  INTVAL 
Parrot_BigNum_multi_cmp_BigNum(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 1879 "./src/pmc/bignum.pmc"

    return bignum_cmp(interp, _self, value);
#line 2484 "./src/pmc/bignum.c"
}
static  INTVAL 
Parrot_BigNum_multi_cmp_Integer(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 1883 "./src/pmc/bignum.pmc"

    return bignum_cmp_int(interp, _self, VTABLE_get_integer(interp, value));
#line 2492 "./src/pmc/bignum.c"
}
static  INTVAL 
Parrot_BigNum_multi_cmp_DEFAULT(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 1887 "./src/pmc/bignum.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigNum: no multiple dispatch variant 'cmp' for %Ss",
        VTABLE_name(interp, value));
#line 2503 "./src/pmc/bignum.c"
}
static  INTVAL 
Parrot_BigNum_multi_is_equal_BigNum(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 1902 "./src/pmc/bignum.pmc"

    return bignum_cmp(interp, _self, value) == 0;
#line 2511 "./src/pmc/bignum.c"
}
static  INTVAL 
Parrot_BigNum_multi_is_equal_Integer(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 1906 "./src/pmc/bignum.pmc"

    return bignum_cmp_int(interp, _self, VTABLE_get_integer(interp, value)) == 0;
#line 2519 "./src/pmc/bignum.c"
}
static  INTVAL 
Parrot_BigNum_multi_is_equal_DEFAULT(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 1910 "./src/pmc/bignum.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigNum: no multiple dispatch variant 'is_equal' for %Ss",
        VTABLE_name(interp, value));
#line 2530 "./src/pmc/bignum.c"
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_BigNum_update_vtable(VTABLE *vt) {
    vt->absolute = Parrot_BigNum_absolute;
    vt->add = Parrot_BigNum_add;
    vt->add_int = Parrot_BigNum_add_int;
    vt->clone = Parrot_BigNum_clone;
    vt->cmp = Parrot_BigNum_cmp;
    vt->decrement = Parrot_BigNum_decrement;
    vt->destroy = Parrot_BigNum_destroy;
    vt->divide = Parrot_BigNum_divide;
    vt->divide_float = Parrot_BigNum_divide_float;
    vt->divide_int = Parrot_BigNum_divide_int;
    vt->floor_divide = Parrot_BigNum_floor_divide;
    vt->floor_divide_int = Parrot_BigNum_floor_divide_int;
    vt->get_bool = Parrot_BigNum_get_bool;
    vt->get_integer = Parrot_BigNum_get_integer;
    vt->get_number = Parrot_BigNum_get_number;
    vt->get_repr = Parrot_BigNum_get_repr;
    vt->get_string = Parrot_BigNum_get_string;
    vt->get_string_keyed_int = Parrot_BigNum_get_string_keyed_int;
    vt->i_absolute = Parrot_BigNum_i_absolute;
    vt->i_add = Parrot_BigNum_i_add;
    vt->i_add_float = Parrot_BigNum_i_add_float;
    vt->i_add_int = Parrot_BigNum_i_add_int;
    vt->i_divide = Parrot_BigNum_i_divide;
    vt->i_divide_int = Parrot_BigNum_i_divide_int;
    vt->i_floor_divide = Parrot_BigNum_i_floor_divide;
    vt->i_floor_divide_int = Parrot_BigNum_i_floor_divide_int;
    vt->i_multiply = Parrot_BigNum_i_multiply;
    vt->i_multiply_float = Parrot_BigNum_i_multiply_float;
    vt->i_multiply_int = Parrot_BigNum_i_multiply_int;
    vt->i_neg = Parrot_BigNum_i_neg;
    vt->i_subtract = Parrot_BigNum_i_subtract;
    vt->i_subtract_float = Parrot_BigNum_i_subtract_float;
    vt->i_subtract_int = Parrot_BigNum_i_subtract_int;
    vt->increment = Parrot_BigNum_increment;
    vt->init = Parrot_BigNum_init;
    vt->is_equal = Parrot_BigNum_is_equal;
    vt->multiply = Parrot_BigNum_multiply;
    vt->multiply_int = Parrot_BigNum_multiply_int;
    vt->neg = Parrot_BigNum_neg;
    vt->set_integer_native = Parrot_BigNum_set_integer_native;
    vt->set_number_native = Parrot_BigNum_set_number_native;
    vt->set_pmc = Parrot_BigNum_set_pmc;
    vt->set_string_keyed_int = Parrot_BigNum_set_string_keyed_int;
    vt->set_string_native = Parrot_BigNum_set_string_native;
    vt->subtract = Parrot_BigNum_subtract;
    vt->subtract_int = Parrot_BigNum_subtract_int;
    vt->attr_size = sizeof(Parrot_BigNum_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_BigNum_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->absolute = Parrot_BigNum_absolute;
    vt->add = Parrot_BigNum_add;
    vt->add_int = Parrot_BigNum_add_int;
    vt->clone = Parrot_BigNum_clone;
    vt->cmp = Parrot_BigNum_cmp;
    vt->destroy = Parrot_BigNum_destroy;
    vt->divide = Parrot_BigNum_divide;
    vt->divide_float = Parrot_BigNum_divide_float;
    vt->divide_int = Parrot_BigNum_divide_int;
    vt->floor_divide = Parrot_BigNum_floor_divide;
    vt->floor_divide_int = Parrot_BigNum_floor_divide_int;
    vt->get_bool = Parrot_BigNum_get_bool;
    vt->get_integer = Parrot_BigNum_get_integer;
    vt->get_number = Parrot_BigNum_get_number;
    vt->get_repr = Parrot_BigNum_get_repr;
    vt->get_string = Parrot_BigNum_get_string;
    vt->get_string_keyed_int = Parrot_BigNum_get_string_keyed_int;
    vt->init = Parrot_BigNum_init;
    vt->is_equal = Parrot_BigNum_is_equal;
    vt->multiply = Parrot_BigNum_multiply;
    vt->multiply_int = Parrot_BigNum_multiply_int;
    vt->neg = Parrot_BigNum_neg;
    vt->subtract = Parrot_BigNum_subtract;
    vt->subtract_int = Parrot_BigNum_subtract_int;
    vt->attr_size = sizeof(Parrot_BigNum_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_BigNum_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_get_vtable(interp);
    Parrot_BigNum_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_BigNum_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_ro_get_vtable(interp);
    Parrot_BigNum_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_BigNum_get_mro(PARROT_INTERP, PMC* mro) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }

    VTABLE_unshift_string(interp, mro,
        string_make(interp, "BigNum", 6, NULL, 0));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_BigNum_get_isa(PARROT_INTERP, Hash* isa) {
    if (isa == NULL) {
        isa = parrot_new_hash(interp);
    }
    parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "BigNum")), PMCNULL);
    return isa;
}

void
Parrot_BigNum_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        ":bn ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_BigNum_get_vtable(interp);
        vt->base_type      = enum_class_BigNum;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "BigNum");
        vt->provides_str = CONST_STRING_GEN(interp, "scalar");
        vt->isa_hash     = Parrot_BigNum_get_isa(interp, NULL);
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_BigNum_ro_get_vtable(interp);
            vt_ro->base_type      = enum_class_BigNum;
            vt_ro->flags          = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_BigNum_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_BigNum_nci_version), CONST_STRING_GEN(interp, "version"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_BigNum_nci_pow), CONST_STRING_GEN(interp, "pow"));
        {
            STRING * const mfl_0 = CONST_STRING_GEN(interp, "add");
            STRING * const mfl_1 = CONST_STRING_GEN(interp, "PJPPP");
            STRING * const mfl_2 = CONST_STRING_GEN(interp, "BigNum,BigNum,PMC");
            STRING * const mfl_3 = CONST_STRING_GEN(interp, "BigNum");
            STRING * const mfl_4 = CONST_STRING_GEN(interp, "BigNum,Integer,PMC");
            STRING * const mfl_5 = CONST_STRING_GEN(interp, "BigNum,DEFAULT,PMC");
            STRING * const mfl_6 = CONST_STRING_GEN(interp, "i_add");
            STRING * const mfl_7 = CONST_STRING_GEN(interp, "vJPP");
            STRING * const mfl_8 = CONST_STRING_GEN(interp, "BigNum,BigNum");
            STRING * const mfl_9 = CONST_STRING_GEN(interp, "BigNum,Integer");
            STRING * const mfl_10 = CONST_STRING_GEN(interp, "BigNum,Float");
            STRING * const mfl_11 = CONST_STRING_GEN(interp, "BigNum,DEFAULT");
            STRING * const mfl_12 = CONST_STRING_GEN(interp, "subtract");
            STRING * const mfl_13 = CONST_STRING_GEN(interp, "i_subtract");
            STRING * const mfl_14 = CONST_STRING_GEN(interp, "multiply");
            STRING * const mfl_15 = CONST_STRING_GEN(interp, "i_multiply");
            STRING * const mfl_16 = CONST_STRING_GEN(interp, "divide");
            STRING * const mfl_17 = CONST_STRING_GEN(interp, "i_divide");
            STRING * const mfl_18 = CONST_STRING_GEN(interp, "floor_divide");
            STRING * const mfl_19 = CONST_STRING_GEN(interp, "i_floor_divide");
            STRING * const mfl_20 = CONST_STRING_GEN(interp, "cmp");
            STRING * const mfl_21 = CONST_STRING_GEN(interp, "IJPP");
            STRING * const mfl_22 = CONST_STRING_GEN(interp, "is_equal");

            multi_func_list _temp_multi_func_list[40];
            _temp_multi_func_list[0].multi_name = mfl_0;
            _temp_multi_func_list[0].short_sig = mfl_1;
            _temp_multi_func_list[0].full_sig = mfl_2;
            _temp_multi_func_list[0].ns_name = mfl_3;
            _temp_multi_func_list[0].func_ptr = (funcptr_t) Parrot_BigNum_multi_add_BigNum_PMC;

            _temp_multi_func_list[1].multi_name = mfl_0;
            _temp_multi_func_list[1].short_sig = mfl_1;
            _temp_multi_func_list[1].full_sig = mfl_4;
            _temp_multi_func_list[1].ns_name = mfl_3;
            _temp_multi_func_list[1].func_ptr = (funcptr_t) Parrot_BigNum_multi_add_Integer_PMC;

            _temp_multi_func_list[2].multi_name = mfl_0;
            _temp_multi_func_list[2].short_sig = mfl_1;
            _temp_multi_func_list[2].full_sig = mfl_5;
            _temp_multi_func_list[2].ns_name = mfl_3;
            _temp_multi_func_list[2].func_ptr = (funcptr_t) Parrot_BigNum_multi_add_DEFAULT_PMC;

            _temp_multi_func_list[3].multi_name = mfl_6;
            _temp_multi_func_list[3].short_sig = mfl_7;
            _temp_multi_func_list[3].full_sig = mfl_8;
            _temp_multi_func_list[3].ns_name = mfl_3;
            _temp_multi_func_list[3].func_ptr = (funcptr_t) Parrot_BigNum_multi_i_add_BigNum;

            _temp_multi_func_list[4].multi_name = mfl_6;
            _temp_multi_func_list[4].short_sig = mfl_7;
            _temp_multi_func_list[4].full_sig = mfl_9;
            _temp_multi_func_list[4].ns_name = mfl_3;
            _temp_multi_func_list[4].func_ptr = (funcptr_t) Parrot_BigNum_multi_i_add_Integer;

            _temp_multi_func_list[5].multi_name = mfl_6;
            _temp_multi_func_list[5].short_sig = mfl_7;
            _temp_multi_func_list[5].full_sig = mfl_10;
            _temp_multi_func_list[5].ns_name = mfl_3;
            _temp_multi_func_list[5].func_ptr = (funcptr_t) Parrot_BigNum_multi_i_add_Float;

            _temp_multi_func_list[6].multi_name = mfl_6;
            _temp_multi_func_list[6].short_sig = mfl_7;
            _temp_multi_func_list[6].full_sig = mfl_11;
            _temp_multi_func_list[6].ns_name = mfl_3;
            _temp_multi_func_list[6].func_ptr = (funcptr_t) Parrot_BigNum_multi_i_add_DEFAULT;

            _temp_multi_func_list[7].multi_name = mfl_12;
            _temp_multi_func_list[7].short_sig = mfl_1;
            _temp_multi_func_list[7].full_sig = mfl_2;
            _temp_multi_func_list[7].ns_name = mfl_3;
            _temp_multi_func_list[7].func_ptr = (funcptr_t) Parrot_BigNum_multi_subtract_BigNum_PMC;

            _temp_multi_func_list[8].multi_name = mfl_12;
            _temp_multi_func_list[8].short_sig = mfl_1;
            _temp_multi_func_list[8].full_sig = mfl_4;
            _temp_multi_func_list[8].ns_name = mfl_3;
            _temp_multi_func_list[8].func_ptr = (funcptr_t) Parrot_BigNum_multi_subtract_Integer_PMC;

            _temp_multi_func_list[9].multi_name = mfl_12;
            _temp_multi_func_list[9].short_sig = mfl_1;
            _temp_multi_func_list[9].full_sig = mfl_5;
            _temp_multi_func_list[9].ns_name = mfl_3;
            _temp_multi_func_list[9].func_ptr = (funcptr_t) Parrot_BigNum_multi_subtract_DEFAULT_PMC;

            _temp_multi_func_list[10].multi_name = mfl_13;
            _temp_multi_func_list[10].short_sig = mfl_7;
            _temp_multi_func_list[10].full_sig = mfl_8;
            _temp_multi_func_list[10].ns_name = mfl_3;
            _temp_multi_func_list[10].func_ptr = (funcptr_t) Parrot_BigNum_multi_i_subtract_BigNum;

            _temp_multi_func_list[11].multi_name = mfl_13;
            _temp_multi_func_list[11].short_sig = mfl_7;
            _temp_multi_func_list[11].full_sig = mfl_9;
            _temp_multi_func_list[11].ns_name = mfl_3;
            _temp_multi_func_list[11].func_ptr = (funcptr_t) Parrot_BigNum_multi_i_subtract_Integer;

            _temp_multi_func_list[12].multi_name = mfl_13;
            _temp_multi_func_list[12].short_sig = mfl_7;
            _temp_multi_func_list[12].full_sig = mfl_10;
            _temp_multi_func_list[12].ns_name = mfl_3;
            _temp_multi_func_list[12].func_ptr = (funcptr_t) Parrot_BigNum_multi_i_subtract_Float;

            _temp_multi_func_list[13].multi_name = mfl_13;
            _temp_multi_func_list[13].short_sig = mfl_7;
            _temp_multi_func_list[13].full_sig = mfl_11;
            _temp_multi_func_list[13].ns_name = mfl_3;
            _temp_multi_func_list[13].func_ptr = (funcptr_t) Parrot_BigNum_multi_i_subtract_DEFAULT;

            _temp_multi_func_list[14].multi_name = mfl_14;
            _temp_multi_func_list[14].short_sig = mfl_1;
            _temp_multi_func_list[14].full_sig = mfl_2;
            _temp_multi_func_list[14].ns_name = mfl_3;
            _temp_multi_func_list[14].func_ptr = (funcptr_t) Parrot_BigNum_multi_multiply_BigNum_PMC;

            _temp_multi_func_list[15].multi_name = mfl_14;
            _temp_multi_func_list[15].short_sig = mfl_1;
            _temp_multi_func_list[15].full_sig = mfl_4;
            _temp_multi_func_list[15].ns_name = mfl_3;
            _temp_multi_func_list[15].func_ptr = (funcptr_t) Parrot_BigNum_multi_multiply_Integer_PMC;

            _temp_multi_func_list[16].multi_name = mfl_14;
            _temp_multi_func_list[16].short_sig = mfl_1;
            _temp_multi_func_list[16].full_sig = mfl_5;
            _temp_multi_func_list[16].ns_name = mfl_3;
            _temp_multi_func_list[16].func_ptr = (funcptr_t) Parrot_BigNum_multi_multiply_DEFAULT_PMC;

            _temp_multi_func_list[17].multi_name = mfl_15;
            _temp_multi_func_list[17].short_sig = mfl_7;
            _temp_multi_func_list[17].full_sig = mfl_8;
            _temp_multi_func_list[17].ns_name = mfl_3;
            _temp_multi_func_list[17].func_ptr = (funcptr_t) Parrot_BigNum_multi_i_multiply_BigNum;

            _temp_multi_func_list[18].multi_name = mfl_15;
            _temp_multi_func_list[18].short_sig = mfl_7;
            _temp_multi_func_list[18].full_sig = mfl_10;
            _temp_multi_func_list[18].ns_name = mfl_3;
            _temp_multi_func_list[18].func_ptr = (funcptr_t) Parrot_BigNum_multi_i_multiply_Float;

            _temp_multi_func_list[19].multi_name = mfl_15;
            _temp_multi_func_list[19].short_sig = mfl_7;
            _temp_multi_func_list[19].full_sig = mfl_9;
            _temp_multi_func_list[19].ns_name = mfl_3;
            _temp_multi_func_list[19].func_ptr = (funcptr_t) Parrot_BigNum_multi_i_multiply_Integer;

            _temp_multi_func_list[20].multi_name = mfl_15;
            _temp_multi_func_list[20].short_sig = mfl_7;
            _temp_multi_func_list[20].full_sig = mfl_11;
            _temp_multi_func_list[20].ns_name = mfl_3;
            _temp_multi_func_list[20].func_ptr = (funcptr_t) Parrot_BigNum_multi_i_multiply_DEFAULT;

            _temp_multi_func_list[21].multi_name = mfl_16;
            _temp_multi_func_list[21].short_sig = mfl_1;
            _temp_multi_func_list[21].full_sig = mfl_2;
            _temp_multi_func_list[21].ns_name = mfl_3;
            _temp_multi_func_list[21].func_ptr = (funcptr_t) Parrot_BigNum_multi_divide_BigNum_PMC;

            _temp_multi_func_list[22].multi_name = mfl_16;
            _temp_multi_func_list[22].short_sig = mfl_1;
            _temp_multi_func_list[22].full_sig = mfl_4;
            _temp_multi_func_list[22].ns_name = mfl_3;
            _temp_multi_func_list[22].func_ptr = (funcptr_t) Parrot_BigNum_multi_divide_Integer_PMC;

            _temp_multi_func_list[23].multi_name = mfl_16;
            _temp_multi_func_list[23].short_sig = mfl_1;
            _temp_multi_func_list[23].full_sig = mfl_5;
            _temp_multi_func_list[23].ns_name = mfl_3;
            _temp_multi_func_list[23].func_ptr = (funcptr_t) Parrot_BigNum_multi_divide_DEFAULT_PMC;

            _temp_multi_func_list[24].multi_name = mfl_17;
            _temp_multi_func_list[24].short_sig = mfl_7;
            _temp_multi_func_list[24].full_sig = mfl_8;
            _temp_multi_func_list[24].ns_name = mfl_3;
            _temp_multi_func_list[24].func_ptr = (funcptr_t) Parrot_BigNum_multi_i_divide_BigNum;

            _temp_multi_func_list[25].multi_name = mfl_17;
            _temp_multi_func_list[25].short_sig = mfl_7;
            _temp_multi_func_list[25].full_sig = mfl_9;
            _temp_multi_func_list[25].ns_name = mfl_3;
            _temp_multi_func_list[25].func_ptr = (funcptr_t) Parrot_BigNum_multi_i_divide_Integer;

            _temp_multi_func_list[26].multi_name = mfl_17;
            _temp_multi_func_list[26].short_sig = mfl_7;
            _temp_multi_func_list[26].full_sig = mfl_10;
            _temp_multi_func_list[26].ns_name = mfl_3;
            _temp_multi_func_list[26].func_ptr = (funcptr_t) Parrot_BigNum_multi_i_divide_Float;

            _temp_multi_func_list[27].multi_name = mfl_17;
            _temp_multi_func_list[27].short_sig = mfl_7;
            _temp_multi_func_list[27].full_sig = mfl_11;
            _temp_multi_func_list[27].ns_name = mfl_3;
            _temp_multi_func_list[27].func_ptr = (funcptr_t) Parrot_BigNum_multi_i_divide_DEFAULT;

            _temp_multi_func_list[28].multi_name = mfl_18;
            _temp_multi_func_list[28].short_sig = mfl_1;
            _temp_multi_func_list[28].full_sig = mfl_2;
            _temp_multi_func_list[28].ns_name = mfl_3;
            _temp_multi_func_list[28].func_ptr = (funcptr_t) Parrot_BigNum_multi_floor_divide_BigNum_PMC;

            _temp_multi_func_list[29].multi_name = mfl_18;
            _temp_multi_func_list[29].short_sig = mfl_1;
            _temp_multi_func_list[29].full_sig = mfl_4;
            _temp_multi_func_list[29].ns_name = mfl_3;
            _temp_multi_func_list[29].func_ptr = (funcptr_t) Parrot_BigNum_multi_floor_divide_Integer_PMC;

            _temp_multi_func_list[30].multi_name = mfl_18;
            _temp_multi_func_list[30].short_sig = mfl_1;
            _temp_multi_func_list[30].full_sig = mfl_5;
            _temp_multi_func_list[30].ns_name = mfl_3;
            _temp_multi_func_list[30].func_ptr = (funcptr_t) Parrot_BigNum_multi_floor_divide_DEFAULT_PMC;

            _temp_multi_func_list[31].multi_name = mfl_19;
            _temp_multi_func_list[31].short_sig = mfl_7;
            _temp_multi_func_list[31].full_sig = mfl_8;
            _temp_multi_func_list[31].ns_name = mfl_3;
            _temp_multi_func_list[31].func_ptr = (funcptr_t) Parrot_BigNum_multi_i_floor_divide_BigNum;

            _temp_multi_func_list[32].multi_name = mfl_19;
            _temp_multi_func_list[32].short_sig = mfl_7;
            _temp_multi_func_list[32].full_sig = mfl_9;
            _temp_multi_func_list[32].ns_name = mfl_3;
            _temp_multi_func_list[32].func_ptr = (funcptr_t) Parrot_BigNum_multi_i_floor_divide_Integer;

            _temp_multi_func_list[33].multi_name = mfl_19;
            _temp_multi_func_list[33].short_sig = mfl_7;
            _temp_multi_func_list[33].full_sig = mfl_11;
            _temp_multi_func_list[33].ns_name = mfl_3;
            _temp_multi_func_list[33].func_ptr = (funcptr_t) Parrot_BigNum_multi_i_floor_divide_DEFAULT;

            _temp_multi_func_list[34].multi_name = mfl_20;
            _temp_multi_func_list[34].short_sig = mfl_21;
            _temp_multi_func_list[34].full_sig = mfl_8;
            _temp_multi_func_list[34].ns_name = mfl_3;
            _temp_multi_func_list[34].func_ptr = (funcptr_t) Parrot_BigNum_multi_cmp_BigNum;

            _temp_multi_func_list[35].multi_name = mfl_20;
            _temp_multi_func_list[35].short_sig = mfl_21;
            _temp_multi_func_list[35].full_sig = mfl_9;
            _temp_multi_func_list[35].ns_name = mfl_3;
            _temp_multi_func_list[35].func_ptr = (funcptr_t) Parrot_BigNum_multi_cmp_Integer;

            _temp_multi_func_list[36].multi_name = mfl_20;
            _temp_multi_func_list[36].short_sig = mfl_21;
            _temp_multi_func_list[36].full_sig = mfl_11;
            _temp_multi_func_list[36].ns_name = mfl_3;
            _temp_multi_func_list[36].func_ptr = (funcptr_t) Parrot_BigNum_multi_cmp_DEFAULT;

            _temp_multi_func_list[37].multi_name = mfl_22;
            _temp_multi_func_list[37].short_sig = mfl_21;
            _temp_multi_func_list[37].full_sig = mfl_8;
            _temp_multi_func_list[37].ns_name = mfl_3;
            _temp_multi_func_list[37].func_ptr = (funcptr_t) Parrot_BigNum_multi_is_equal_BigNum;

            _temp_multi_func_list[38].multi_name = mfl_22;
            _temp_multi_func_list[38].short_sig = mfl_21;
            _temp_multi_func_list[38].full_sig = mfl_9;
            _temp_multi_func_list[38].ns_name = mfl_3;
            _temp_multi_func_list[38].func_ptr = (funcptr_t) Parrot_BigNum_multi_is_equal_Integer;

            _temp_multi_func_list[39].multi_name = mfl_22;
            _temp_multi_func_list[39].short_sig = mfl_21;
            _temp_multi_func_list[39].full_sig = mfl_11;
            _temp_multi_func_list[39].ns_name = mfl_3;
            _temp_multi_func_list[39].func_ptr = (funcptr_t) Parrot_BigNum_multi_is_equal_DEFAULT;

            Parrot_mmd_add_multi_list_from_c_args(interp,
                _temp_multi_func_list, 40);
        }
    } /* pass */
} /* Parrot_BigNum_class_init */
#line 1963 "./src/pmc/bignum.pmc"


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
