/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/eventhandler.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_eventhandler.h"
#include "pmc_sub.h"
#include "pmc_default.h"
#include "eventhandler.str"
#include "pmc_continuation.h"
#include "pmc_callcontext.h"
#line 1 "./src/pmc/eventhandler.pmc"
/*
Copyright (C) 2007-2010, Parrot Foundation.
$Id: eventhandler.pmc 46700 2010-05-16 12:30:35Z bacek $

=head1 NAME

src/pmc/eventhandler.pmc - a handler for events

=head1 DESCRIPTION

A PMC that captures the state of the interpreter to invoke when handling an
Event.

=head2 Vtable Functions

=over 4

=cut

*/

/* HEADERIZER HFILE: none */
/* HEADERIZER BEGIN: static */
/* HEADERIZER END: static */
#line 49 "./src/pmc/eventhandler.c"
static  PMC  * Parrot_EventHandler_get_attr_str(PARROT_INTERP, PMC *_self, STRING *name);
static  STRING  * Parrot_EventHandler_get_string(PARROT_INTERP, PMC *_self);
static  void  Parrot_EventHandler_init(PARROT_INTERP, PMC *_self);
static  void  Parrot_EventHandler_init_pmc(PARROT_INTERP, PMC *_self, PMC *data);
static  opcode_t  * Parrot_EventHandler_invoke(PARROT_INTERP, PMC *_self, void *next);
static  void  Parrot_EventHandler_mark(PARROT_INTERP, PMC *_self);
static  void  Parrot_EventHandler_set_integer_native(PARROT_INTERP, PMC *_self, INTVAL priority);
static  void  Parrot_EventHandler_set_pmc(PARROT_INTERP, PMC *_self, PMC *interpreter);
static  void Parrot_EventHandler_nci_can_handle(PARROT_INTERP, PMC *_self);
void    Parrot_EventHandler_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_EventHandler_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_EventHandler_get_vtable(PARROT_INTERP);
void    Parrot_EventHandler_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_EventHandler_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_EventHandler_ro_get_vtable(PARROT_INTERP);
static  PMC  *
Parrot_EventHandler_get_attr_str(PARROT_INTERP, PMC *_self, STRING *name)
{
#line 216 "./src/pmc/eventhandler.pmc"

    Parrot_EventHandler_attributes * const e = PARROT_EVENTHANDLER(_self);
    PMC *value = PMCNULL;

    if (Parrot_str_equal(interp, name, CONST_STRING(interp, "code"))) {
        value = e->code;
    }

    return value;
#line 78 "./src/pmc/eventhandler.c"
}
static  STRING  *
Parrot_EventHandler_get_string(PARROT_INTERP, PMC *_self)
{
#line 166 "./src/pmc/eventhandler.pmc"

    Parrot_EventHandler_attributes * const e = PARROT_EVENTHANDLER(_self);

    if (e)
        return e->type;

    return CONST_STRING(interp, "");
#line 91 "./src/pmc/eventhandler.c"
}
static  void 
Parrot_EventHandler_init(PARROT_INTERP, PMC *_self)
{
#line 45 "./src/pmc/eventhandler.pmc"

    PObj_custom_mark_SET(_self);
    PObj_custom_destroy_SET(_self);
#line 100 "./src/pmc/eventhandler.c"
}
static  void 
Parrot_EventHandler_init_pmc(PARROT_INTERP, PMC *_self, PMC *data)
{
#line 82 "./src/pmc/eventhandler.pmc"

    PMC                 *code        = NULL;
    PMC                 *interpreter = PMCNULL;
    STRING              *type        = NULL;
    INTVAL               priority    = 0;
    Parrot_EventHandler_attributes *e =
            (Parrot_EventHandler_attributes *) PMC_data(_self);

    if (VTABLE_isa(interp, data, CONST_STRING(interp, "Sub"))) {
        code = data;
    }
    else if (VTABLE_isa(interp, data, CONST_STRING(interp, "Hash"))) {
        code = VTABLE_get_pmc_keyed_str(interp, data, CONST_STRING(interp, "code"));
        interpreter = VTABLE_get_pmc_keyed_str(interp, data, CONST_STRING(interp, "interp"));
        type = VTABLE_get_string_keyed_str(interp, data, CONST_STRING(interp, "type"));
        priority = VTABLE_get_integer_keyed_str(interp, data, CONST_STRING(interp, "priority"));
    }
    else {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            "EventHandler initializer must be Sub or Hash");
    }

    if (PMC_IS_NULL(interpreter))
        interpreter = VTABLE_get_pmc_keyed_int(interp,
                interp->iglobals, IGLOBALS_INTERPRETER);

    PObj_custom_mark_SET(_self);
    PObj_custom_destroy_SET(_self);

    e->type        = type;
    e->code        = code;
    e->interp      = interpreter;
    e->priority    = priority;
#line 139 "./src/pmc/eventhandler.c"
}
static  opcode_t  *
Parrot_EventHandler_invoke(PARROT_INTERP, PMC *_self, void *next)
{
#line 236 "./src/pmc/eventhandler.pmc"

    Parrot_EventHandler_attributes * const e = PARROT_EVENTHANDLER(_self);

    /* can't invoke on interp and can't return its result; this may not be
     * the right interpreter */
    if (e) {
        void *unused;

        unused = VTABLE_invoke(PMC_data_typed(e->interp, Parrot_Interp),
                e->code, next);
        UNUSED(unused);
    }

    return (opcode_t *)next;
#line 159 "./src/pmc/eventhandler.c"
}
static  void 
Parrot_EventHandler_mark(PARROT_INTERP, PMC *_self)
{
#line 127 "./src/pmc/eventhandler.pmc"

    Parrot_EventHandler_attributes * const e = PARROT_EVENTHANDLER(_self);

    if (e) {
        Parrot_gc_mark_STRING_alive(interp, e->type);
        Parrot_gc_mark_PMC_alive(interp, e->interp);
        Parrot_gc_mark_PMC_alive(interp, e->code);

        interp->vtables[enum_class_Sub]->mark(interp, _self);
    }
#line 175 "./src/pmc/eventhandler.c"
}
static  void 
Parrot_EventHandler_set_integer_native(PARROT_INTERP, PMC *_self, INTVAL priority)
{
#line 184 "./src/pmc/eventhandler.pmc"

    Parrot_EventHandler_attributes * const e = PARROT_EVENTHANDLER(_self);

    if (e)
        e->priority = priority;
#line 186 "./src/pmc/eventhandler.c"
}
static  void 
Parrot_EventHandler_set_pmc(PARROT_INTERP, PMC *_self, PMC *interpreter)
{
#line 201 "./src/pmc/eventhandler.pmc"

    Parrot_EventHandler_attributes * const e = PARROT_EVENTHANDLER(_self);

    if (e)
        e->interp = interpreter;
#line 197 "./src/pmc/eventhandler.c"
}
static  void
Parrot_EventHandler_nci_can_handle(PARROT_INTERP, PMC *_self)
{
#line 422 "/home/mandrake/rpm/BUILD/parrot-2.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 209 "./src/pmc/eventhandler.pmc"
PMC* _self;
PMC* event;

#line 430 "/home/mandrake/rpm/BUILD/parrot-2.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiP",
            &_self, &event);
#line 434 "/home/mandrake/rpm/BUILD/parrot-2.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 274 "./src/pmc/eventhandler.pmc"


    if (event->vtable->base_type == enum_class_Task) {
        PMC    * const type     = VTABLE_get_attr_str(interp, event, CONST_STRING(interp, "type"));
        STRING * const type_str = VTABLE_get_string(interp, type);

        if (Parrot_str_equal(interp, type_str, CONST_STRING(interp, "event"))) {
            Parrot_EventHandler_attributes * const handler_struct = PARROT_EVENTHANDLER(_self);
            PMC    * const subtype     = VTABLE_get_attr_str(interp, event, CONST_STRING(interp, "subtype"));
            STRING * const subtype_str = VTABLE_get_string(interp, subtype);

            if (Parrot_str_equal(interp, subtype_str, handler_struct->type)) {
                #line 260 "/home/mandrake/rpm/BUILD/parrot-2.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL 1 */
#line 267 "/home/mandrake/rpm/BUILD/parrot-2.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "I", (INTVAL)1);
    return;
    /*END RETURN INTVAL 1 */
    }
#line 286 "./src/pmc/eventhandler.pmc"

            }
        }
    }

    #line 260 "/home/mandrake/rpm/BUILD/parrot-2.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL 0 */
#line 267 "/home/mandrake/rpm/BUILD/parrot-2.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "I", (INTVAL)0);
    return;
    /*END RETURN INTVAL 0 */
    }
#line 291 "./src/pmc/eventhandler.pmc"

#line 441 "/home/mandrake/rpm/BUILD/parrot-2.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 262 "./src/pmc/eventhandler.c"
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_EventHandler_update_vtable(VTABLE *vt) {
    vt->get_attr_str = Parrot_EventHandler_get_attr_str;
    vt->get_string = Parrot_EventHandler_get_string;
    vt->init = Parrot_EventHandler_init;
    vt->init_pmc = Parrot_EventHandler_init_pmc;
    vt->invoke = Parrot_EventHandler_invoke;
    vt->mark = Parrot_EventHandler_mark;
    vt->set_integer_native = Parrot_EventHandler_set_integer_native;
    vt->set_pmc = Parrot_EventHandler_set_pmc;
    vt->attr_size = sizeof(Parrot_EventHandler_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_EventHandler_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->get_attr_str = Parrot_EventHandler_get_attr_str;
    vt->get_string = Parrot_EventHandler_get_string;
    vt->init = Parrot_EventHandler_init;
    vt->init_pmc = Parrot_EventHandler_init_pmc;
    vt->invoke = Parrot_EventHandler_invoke;
    vt->mark = Parrot_EventHandler_mark;
    vt->attr_size = sizeof(Parrot_EventHandler_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_EventHandler_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_Sub_get_vtable(interp);
    Parrot_EventHandler_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_EventHandler_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_Sub_ro_get_vtable(interp);
    Parrot_EventHandler_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_EventHandler_get_mro(PARROT_INTERP, PMC* mro) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }
    mro = Parrot_Sub_get_mro(interp, mro);

    VTABLE_unshift_string(interp, mro,
        string_make(interp, "EventHandler", 12, NULL, 0));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_EventHandler_get_isa(PARROT_INTERP, Hash* isa) {
    isa = Parrot_Sub_get_isa(interp, isa);
    parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "EventHandler")), PMCNULL);
    return isa;
}

void
Parrot_EventHandler_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        ":seg :start_offs :end_offs IHLL_id Fnamespace_name Fnamespace_stash Sname Smethod_name Sns_entry_name Ssubid Ivtable_index Fmulti_signature :n_regs_used Flex_info Fouter_sub Feval_pmc Fctx :comp_flags :arg_info Fouter_ctx Stype Fcode Finterp Ipriority ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_EventHandler_get_vtable(interp);
        vt->base_type      = enum_class_EventHandler;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "EventHandler");
        vt->provides_str = CONST_STRING_GEN(interp, "invokable");
        vt->isa_hash     = Parrot_EventHandler_get_isa(interp, NULL);
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_EventHandler_ro_get_vtable(interp);
            vt_ro->base_type      = enum_class_EventHandler;
            vt_ro->flags          = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_EventHandler_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_EventHandler_nci_can_handle), CONST_STRING_GEN(interp, "can_handle"));
        {
        }
    } /* pass */
} /* Parrot_EventHandler_class_init */
#line 293 "./src/pmc/eventhandler.pmc"


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
