/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/hash.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_hash.h"
#include "pmc_default.h"
#include "hash.str"
#include "pmc_continuation.h"
#include "pmc_callcontext.h"
#line 1 "./src/pmc/hash.pmc"
/*
Copyright (C) 2001-2010, Parrot Foundation.
$Id: hash.pmc 48028 2010-07-07 12:45:50Z Util $

=head1 NAME

src/pmc/hash.pmc - Hash PMC

=head1 DESCRIPTION

Hash PMC wraps Parrot's _hash to provide a high-level API:

=over 4

=item *

Convert between various types to use as hash keys.

=item *

Convert between various types to use as hash values.

=item *

Handle compound Keys for nested Hash/Array lookups.

=item *

Provide C<HashIterator> to iterate over C<Hash>.

=back

By default Hash uses string keys and PMC values. Methods C<set_key_type> and
C<set_value_type> may be used to switch key and values type. For C<PMC> keys
hash value is calculated using VTABLE C<get_hashvalue> function.

These are the vtable functions for the Hash PMC.

=head2 Functions

=over 4

=cut

*/

#include "pmc/pmc_iterator.h"
#include "pmc/pmc_key.h"
#include "pmc/pmc_hashiteratorkey.h"

/* HEADERIZER HFILE: none */
/* HEADERIZER BEGIN: static */
/* HEADERIZER END: static */
#line 77 "./src/pmc/hash.c"
static  PMC  * Parrot_Hash_clone(PARROT_INTERP, PMC *_self);
static  INTVAL  Parrot_Hash_defined_keyed(PARROT_INTERP, PMC *_self, PMC *key);
static  INTVAL  Parrot_Hash_defined_keyed_str(PARROT_INTERP, PMC *_self, STRING *key);
static  void  Parrot_Hash_delete_keyed(PARROT_INTERP, PMC *_self, PMC *key);
static  void  Parrot_Hash_delete_keyed_str(PARROT_INTERP, PMC *_self, STRING *key);
static  void  Parrot_Hash_destroy(PARROT_INTERP, PMC *_self);
static  INTVAL  Parrot_Hash_elements(PARROT_INTERP, PMC *_self);
static  INTVAL  Parrot_Hash_exists_keyed(PARROT_INTERP, PMC *_self, PMC *key);
static  INTVAL  Parrot_Hash_exists_keyed_str(PARROT_INTERP, PMC *_self, STRING *key);
static  void  Parrot_Hash_freeze(PARROT_INTERP, PMC *_self, PMC *info);
static  INTVAL  Parrot_Hash_get_bool(PARROT_INTERP, PMC *_self);
static  INTVAL  Parrot_Hash_get_integer(PARROT_INTERP, PMC *_self);
static  INTVAL  Parrot_Hash_get_integer_keyed(PARROT_INTERP, PMC *_self, PMC *key);
static  INTVAL  Parrot_Hash_get_integer_keyed_int(PARROT_INTERP, PMC *_self, INTVAL key);
static  INTVAL  Parrot_Hash_get_integer_keyed_str(PARROT_INTERP, PMC *_self, STRING *key);
static  PMC  * Parrot_Hash_get_iter(PARROT_INTERP, PMC *_self);
static  FLOATVAL  Parrot_Hash_get_number(PARROT_INTERP, PMC *_self);
static  FLOATVAL  Parrot_Hash_get_number_keyed(PARROT_INTERP, PMC *_self, PMC *key);
static  FLOATVAL  Parrot_Hash_get_number_keyed_int(PARROT_INTERP, PMC *_self, INTVAL key);
static  FLOATVAL  Parrot_Hash_get_number_keyed_str(PARROT_INTERP, PMC *_self, STRING *key);
static  PMC  * Parrot_Hash_get_pmc_keyed(PARROT_INTERP, PMC *_self, PMC *key);
static  PMC  * Parrot_Hash_get_pmc_keyed_int(PARROT_INTERP, PMC *_self, INTVAL key);
static  PMC  * Parrot_Hash_get_pmc_keyed_str(PARROT_INTERP, PMC *_self, STRING *key);
static  void  * Parrot_Hash_get_pointer(PARROT_INTERP, PMC *_self);
static  STRING  * Parrot_Hash_get_repr(PARROT_INTERP, PMC *_self);
static  STRING  * Parrot_Hash_get_string(PARROT_INTERP, PMC *_self);
static  STRING  * Parrot_Hash_get_string_keyed(PARROT_INTERP, PMC *_self, PMC *key);
static  STRING  * Parrot_Hash_get_string_keyed_int(PARROT_INTERP, PMC *_self, INTVAL key);
static  STRING  * Parrot_Hash_get_string_keyed_str(PARROT_INTERP, PMC *_self, STRING *key);
static  void  Parrot_Hash_init(PARROT_INTERP, PMC *_self);
static  void  Parrot_Hash_init_int(PARROT_INTERP, PMC *_self, INTVAL value_type);
static  INTVAL  Parrot_Hash_is_equal(PARROT_INTERP, PMC *_self, PMC *value);
static  INTVAL  Parrot_Hash_is_same(PARROT_INTERP, PMC *_self, PMC *other);
static  void  Parrot_Hash_mark(PARROT_INTERP, PMC *_self);
static  void  Parrot_Hash_set_integer_keyed(PARROT_INTERP, PMC *_self, PMC *key, INTVAL value);
static  void  Parrot_Hash_set_integer_keyed_int(PARROT_INTERP, PMC *_self, INTVAL key, INTVAL value);
static  void  Parrot_Hash_set_integer_keyed_str(PARROT_INTERP, PMC *_self, STRING *key, INTVAL value);
static  void  Parrot_Hash_set_integer_native(PARROT_INTERP, PMC *_self, INTVAL type);
static  void  Parrot_Hash_set_number_keyed(PARROT_INTERP, PMC *_self, PMC *key, FLOATVAL value);
static  void  Parrot_Hash_set_number_keyed_str(PARROT_INTERP, PMC *_self, STRING *key, FLOATVAL value);
static  void  Parrot_Hash_set_pmc_keyed(PARROT_INTERP, PMC *_self, PMC *key, PMC *value);
static  void  Parrot_Hash_set_pmc_keyed_str(PARROT_INTERP, PMC *_self, STRING *key, PMC *value);
static  void  Parrot_Hash_set_pointer(PARROT_INTERP, PMC *_self, void *ptr);
static  void  Parrot_Hash_set_string_keyed(PARROT_INTERP, PMC *_self, PMC *key, STRING *value);
static  void  Parrot_Hash_set_string_keyed_int(PARROT_INTERP, PMC *_self, INTVAL key, STRING *value);
static  void  Parrot_Hash_set_string_keyed_str(PARROT_INTERP, PMC *_self, STRING *key, STRING *value);
static  void  Parrot_Hash_thaw(PARROT_INTERP, PMC *_self, PMC *info);
static  void  Parrot_Hash_visit(PARROT_INTERP, PMC *_self, PMC *info);
static  void Parrot_Hash_nci_set_key_type(PARROT_INTERP, PMC *_self);
static  void Parrot_Hash_nci_get_key_type(PARROT_INTERP, PMC *_self);
static  void Parrot_Hash_nci_set_value_type(PARROT_INTERP, PMC *_self);
static  void Parrot_Hash_nci_get_value_type(PARROT_INTERP, PMC *_self);
void    Parrot_Hash_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_Hash_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_Hash_get_vtable(PARROT_INTERP);
void    Parrot_Hash_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_Hash_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_Hash_ro_get_vtable(PARROT_INTERP);
static  PMC  *
Parrot_Hash_clone(PARROT_INTERP, PMC *_self)
{
#line 129 "./src/pmc/hash.pmc"

    PMC * const dest = Parrot_pmc_new(interp, _self->vtable->base_type);

    parrot_hash_clone(interp, (Hash *)VTABLE_get_pointer(interp, _self),
               (Hash *)VTABLE_get_pointer(interp, dest));

    return dest;
#line 147 "./src/pmc/hash.c"
}
static  INTVAL 
Parrot_Hash_defined_keyed(PARROT_INTERP, PMC *_self, PMC *key)
{
#line 922 "./src/pmc/hash.pmc"

    Hash       * const h  = (Hash *)VTABLE_get_pointer(interp, _self);
    void       * const sx = hash_key_from_pmc(interp, h, key);
    HashBucket * const b  = parrot_hash_get_bucket(interp, h, sx);

    /* no such key */
    if (!b)
        return 0;

    key = key_next(interp, key);

    if (!key)
        return VTABLE_defined(interp, hash_value_to_pmc(interp, h, b->value));
    else
        return VTABLE_defined_keyed(interp,
                hash_value_to_pmc(interp, h, b->value), key);
#line 169 "./src/pmc/hash.c"
}
static  INTVAL 
Parrot_Hash_defined_keyed_str(PARROT_INTERP, PMC *_self, STRING *key)
{
#line 900 "./src/pmc/hash.pmc"

    const Hash * const hash = (Hash *)VTABLE_get_pointer(interp, _self);
    HashBucket * const b = parrot_hash_get_bucket(interp, hash,
            hash_key_from_string(interp, hash, key));

    /* no such key */
    if (!b)
        return 0;

    return VTABLE_defined(interp, hash_value_to_pmc(interp, hash, b->value));
#line 185 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_delete_keyed(PARROT_INTERP, PMC *_self, PMC *key)
{
#line 963 "./src/pmc/hash.pmc"

    Hash       * const h  = (Hash *)VTABLE_get_pointer(interp, _self);
    void       * const sx = hash_key_from_pmc(interp, h, key);
    HashBucket * const b  = parrot_hash_get_bucket(interp, h, sx);

    /* no such key */
    if (!b)
        return;

    key = key_next(interp, key);

    if (!key)
        parrot_hash_delete(interp, h, sx);
    else
        VTABLE_delete_keyed(interp, (PMC *)b->value, key);
#line 206 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_delete_keyed_str(PARROT_INTERP, PMC *_self, STRING *key)
{
#line 948 "./src/pmc/hash.pmc"

    Hash * const hash = (Hash *)VTABLE_get_pointer(interp, _self);
    parrot_hash_delete(interp, hash, hash_key_from_string(interp, hash, key));
#line 215 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_destroy(PARROT_INTERP, PMC *_self)
{
#line 98 "./src/pmc/hash.pmc"

    Hash * const hash = (Hash *)VTABLE_get_pointer(interp, _self);
    if (hash)
        parrot_hash_destroy(interp, hash);
#line 225 "./src/pmc/hash.c"
}
static  INTVAL 
Parrot_Hash_elements(PARROT_INTERP, PMC *_self)
{
#line 1004 "./src/pmc/hash.pmc"

    return parrot_hash_size(interp, (Hash *)VTABLE_get_pointer(interp, _self));
#line 233 "./src/pmc/hash.c"
}
static  INTVAL 
Parrot_Hash_exists_keyed(PARROT_INTERP, PMC *_self, PMC *key)
{
#line 874 "./src/pmc/hash.pmc"

    Hash       * const h  = (Hash *)VTABLE_get_pointer(interp, _self);
    void       * const sx = hash_key_from_pmc(interp, h, key);
    HashBucket * const b  = parrot_hash_get_bucket(interp, h, sx);

    /* no such key */
    if (!b)
        return 0;

    key = key_next(interp, key);

    /* lookup stops here */
    if (!key)
        return 1;

    return VTABLE_exists_keyed(interp, hash_value_to_pmc(interp, h, b->value), key);
#line 255 "./src/pmc/hash.c"
}
static  INTVAL 
Parrot_Hash_exists_keyed_str(PARROT_INTERP, PMC *_self, STRING *key)
{
#line 857 "./src/pmc/hash.pmc"

    Hash * const hash = (Hash *)VTABLE_get_pointer(interp, _self);
    HashBucket * const b = parrot_hash_get_bucket(interp, hash,
            hash_key_from_string(interp, hash, key));
    return b != NULL;
#line 266 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_freeze(PARROT_INTERP, PMC *_self, PMC *info)
{
#line 1106 "./src/pmc/hash.pmc"

    Hash     * const hash = (Hash *)VTABLE_get_pointer(interp, _self);

    interp->vtables[enum_class_default]->freeze(interp, _self, info);
    VTABLE_push_integer(interp, info, VTABLE_elements(interp, _self));
    VTABLE_push_integer(interp, info, (INTVAL)hash->key_type);
    VTABLE_push_integer(interp, info, hash->entry_type);
#line 279 "./src/pmc/hash.c"
}
static  INTVAL 
Parrot_Hash_get_bool(PARROT_INTERP, PMC *_self)
{
#line 990 "./src/pmc/hash.pmc"

    return parrot_hash_size(interp, (Hash *)VTABLE_get_pointer(interp, _self)) != 0;
#line 287 "./src/pmc/hash.c"
}
static  INTVAL 
Parrot_Hash_get_integer(PARROT_INTERP, PMC *_self)
{
#line 308 "./src/pmc/hash.pmc"

    return parrot_hash_size(interp, (Hash *)VTABLE_get_pointer(interp, _self));
#line 295 "./src/pmc/hash.c"
}
static  INTVAL 
Parrot_Hash_get_integer_keyed(PARROT_INTERP, PMC *_self, PMC *key)
{
#line 423 "./src/pmc/hash.pmc"

    const Hash * const hash = (Hash *)VTABLE_get_pointer(interp, _self);
    HashBucket * const b = parrot_hash_get_bucket(interp, hash,
            hash_key_from_pmc(interp, hash, key));
    PMC        *valpmc;
    PMC        *nextkey;

    if (!b)
        return 0;

    nextkey = key_next(interp, key);
    valpmc  = hash_value_to_pmc(interp, hash, b->value);

    /* Stop recursion. This is last step */
    if (!nextkey)
        return VTABLE_get_integer(interp, valpmc);

    /* Recusively call to enclosed aggregate */
    return VTABLE_get_integer_keyed(interp, valpmc, nextkey);
#line 320 "./src/pmc/hash.c"
}
static  INTVAL 
Parrot_Hash_get_integer_keyed_int(PARROT_INTERP, PMC *_self, INTVAL key)
{
#line 402 "./src/pmc/hash.pmc"

    const Hash * const hash = (Hash*)VTABLE_get_pointer(interp, _self);
    HashBucket * const b = parrot_hash_get_bucket(interp, hash,
            hash_key_from_int(interp, hash, key));

    if (!b)
        return 0;

    return hash_value_to_int(interp, hash, b->value);
#line 335 "./src/pmc/hash.c"
}
static  INTVAL 
Parrot_Hash_get_integer_keyed_str(PARROT_INTERP, PMC *_self, STRING *key)
{
#line 391 "./src/pmc/hash.pmc"

    const Hash * const hash = (Hash*)VTABLE_get_pointer(interp, _self);
    HashBucket * const b = parrot_hash_get_bucket(interp, hash,
            hash_key_from_string(interp, hash, key));

    if (!b)
        return 0;

    return hash_value_to_int(interp, hash, b->value);
#line 350 "./src/pmc/hash.c"
}
static  PMC  *
Parrot_Hash_get_iter(PARROT_INTERP, PMC *_self)
{
#line 1018 "./src/pmc/hash.pmc"

    return Parrot_pmc_new_init(interp, enum_class_HashIterator, _self);
#line 358 "./src/pmc/hash.c"
}
static  FLOATVAL 
Parrot_Hash_get_number(PARROT_INTERP, PMC *_self)
{
#line 312 "./src/pmc/hash.pmc"

    return VTABLE_get_integer(interp, _self);
#line 366 "./src/pmc/hash.c"
}
static  FLOATVAL 
Parrot_Hash_get_number_keyed(PARROT_INTERP, PMC *_self, PMC *key)
{
#line 541 "./src/pmc/hash.pmc"

    PMC               *nextkey;
    PMC               *valpmc;
    const Hash * const hash   = (Hash *)VTABLE_get_pointer(interp, _self);
    void       * const keystr = hash_key_from_pmc(interp, hash, key);
    HashBucket * const b      = parrot_hash_get_bucket(interp, hash, keystr);

    if (!b)
        return 0.0;

    nextkey = key_next(interp, key);
    valpmc  = hash_value_to_pmc(interp, hash, b->value);

    if (!nextkey)
        return VTABLE_get_number(interp, valpmc);

    return VTABLE_get_number_keyed(interp, valpmc, nextkey);
#line 389 "./src/pmc/hash.c"
}
static  FLOATVAL 
Parrot_Hash_get_number_keyed_int(PARROT_INTERP, PMC *_self, INTVAL key)
{
#line 520 "./src/pmc/hash.pmc"

    const Hash * const hash = (Hash *)VTABLE_get_pointer(interp, _self);
    HashBucket * const b = parrot_hash_get_bucket(interp, hash,
            hash_key_from_int(interp, hash, key));

    if (!b)
        return 0.0;

    return hash_value_to_number(interp, hash, b->value);
#line 404 "./src/pmc/hash.c"
}
static  FLOATVAL 
Parrot_Hash_get_number_keyed_str(PARROT_INTERP, PMC *_self, STRING *key)
{
#line 509 "./src/pmc/hash.pmc"

    const Hash * const hash = (Hash *)VTABLE_get_pointer(interp, _self);
    HashBucket * const b = parrot_hash_get_bucket(interp, hash,
            hash_key_from_string(interp, hash, key));

    if (!b)
        return 0.0;

    return hash_value_to_number(interp, hash, b->value);
#line 419 "./src/pmc/hash.c"
}
static  PMC  *
Parrot_Hash_get_pmc_keyed(PARROT_INTERP, PMC *_self, PMC *key)
{
#line 729 "./src/pmc/hash.pmc"

    const Hash * const hash = (Hash *)VTABLE_get_pointer(interp, _self);
    HashBucket * const b = parrot_hash_get_bucket(interp, hash,
            hash_key_from_pmc(interp, hash, key));
    PMC        *valpmc;
    PMC        *nextkey;

    if (!b)
        return PMCNULL;

    nextkey = key_next(interp, key);
    valpmc  = hash_value_to_pmc(interp, hash, b->value);

    /* Stop recursion. This is last step */
    if (!nextkey)
        return valpmc;

    /* Recusively call to enclosed aggregate */
    return VTABLE_get_pmc_keyed(interp, valpmc, nextkey);
#line 444 "./src/pmc/hash.c"
}
static  PMC  *
Parrot_Hash_get_pmc_keyed_int(PARROT_INTERP, PMC *_self, INTVAL key)
{
#line 717 "./src/pmc/hash.pmc"

    const Hash * const hash = (Hash *)VTABLE_get_pointer(interp, _self);
    HashBucket * const b    = parrot_hash_get_bucket(interp, hash,
            hash_key_from_int(interp, hash, key));

    if (!b)
        return PMCNULL;

    return hash_value_to_pmc(interp, hash, b->value);
#line 459 "./src/pmc/hash.c"
}
static  PMC  *
Parrot_Hash_get_pmc_keyed_str(PARROT_INTERP, PMC *_self, STRING *key)
{
#line 694 "./src/pmc/hash.pmc"

    const Hash *hash;
    HashBucket *b = NULL;

    GETATTR_Hash_hash(interp, _self, hash);

    /* special case the most key type, for speed */
    if (hash->key_type == Hash_key_type_STRING)
        b = parrot_hash_get_bucket(interp, hash, key);
    else
        b = parrot_hash_get_bucket(interp, hash,
            hash_key_from_string(interp, hash, key));

    if (!b)
        return PMCNULL;

    /* special case the most likely value type, for speed */
    if (hash->entry_type == enum_type_PMC)
        return (PMC *)b->value;
    else
        return hash_value_to_pmc(interp, hash, b->value);
#line 486 "./src/pmc/hash.c"
}
static  void  *
Parrot_Hash_get_pointer(PARROT_INTERP, PMC *_self)
{
#line 292 "./src/pmc/hash.pmc"

    return PARROT_HASH(_self)->hash;
#line 494 "./src/pmc/hash.c"
}
static  STRING  *
Parrot_Hash_get_repr(PARROT_INTERP, PMC *_self)
{
#line 335 "./src/pmc/hash.pmc"

    /* TT #1231:  Use freeze in get_repr() (for hashes) */
    PMC * const  iter = VTABLE_get_iter(interp, _self);
    STRING      *res  = CONST_STRING(interp, "{");
    const INTVAL n    = VTABLE_elements(interp, _self);
    INTVAL       j;

    for (j = 0; j < n; ++j) {
        STRING * const key      = VTABLE_shift_string(interp, iter);
        char *   const key_str  = Parrot_str_to_cstring(interp, key);
        const size_t   str_len  = strlen(key_str);
        size_t         i;
        int            all_digit = 1;
        PMC           *val;

        for (i = 0; i < str_len; ++i) {
            if (!isdigit((unsigned char)key_str[i])) {
                all_digit = 0;
                break;
            }
        }

        Parrot_str_free_cstring(key_str);

        if (all_digit) {
            res = Parrot_str_concat(interp, res, key);
        }
        else {
            res = Parrot_str_concat(interp, res, CONST_STRING(interp, "'"));
            res = Parrot_str_concat(interp, res, key);
            res = Parrot_str_concat(interp, res, CONST_STRING(interp, "'"));
        }

        res = Parrot_str_concat(interp, res, CONST_STRING(interp, ": "));
        val = VTABLE_get_pmc_keyed_str(interp, _self, key);
        res = Parrot_str_concat(interp, res, VTABLE_get_string(interp, val));

        if (j < n - 1)
            res = Parrot_str_concat(interp, res, CONST_STRING(interp, ", "));
    }

    res = Parrot_str_concat(interp, res, CONST_STRING(interp, "}"));

    return res;
#line 544 "./src/pmc/hash.c"
}
static  STRING  *
Parrot_Hash_get_string(PARROT_INTERP, PMC *_self)
{
#line 331 "./src/pmc/hash.pmc"

    return Parrot_sprintf_c(interp, "Hash[0x%x]", _self);
#line 552 "./src/pmc/hash.c"
}
static  STRING  *
Parrot_Hash_get_string_keyed(PARROT_INTERP, PMC *_self, PMC *key)
{
#line 603 "./src/pmc/hash.pmc"

    const Hash * const hash = (Hash *)VTABLE_get_pointer(interp, _self);
    HashBucket * const b = parrot_hash_get_bucket(interp, hash,
            hash_key_from_pmc(interp, hash, key));
    PMC        *valpmc;
    PMC        *nextkey;

    if (!b)
        return Parrot_str_new_noinit(interp, enum_stringrep_one, 0);

    nextkey = key_next(interp, key);
    valpmc  = hash_value_to_pmc(interp, hash, b->value);

    /* Stop recursion. This is last step */
    if (!nextkey)
        return VTABLE_get_string(interp, valpmc);

    /* Recusively call to enclosed aggregate */
    return VTABLE_get_string_keyed(interp, valpmc, nextkey);
#line 577 "./src/pmc/hash.c"
}
static  STRING  *
Parrot_Hash_get_string_keyed_int(PARROT_INTERP, PMC *_self, INTVAL key)
{
#line 582 "./src/pmc/hash.pmc"

    const Hash * const hash = (Hash*)VTABLE_get_pointer(interp, _self);
    HashBucket * const b =
        parrot_hash_get_bucket(interp, hash, hash_key_from_int(interp, hash, key));

    if (!b)
        return Parrot_str_new_noinit(interp, enum_stringrep_one, 0);

    return hash_value_to_string(interp, hash, b->value);
#line 592 "./src/pmc/hash.c"
}
static  STRING  *
Parrot_Hash_get_string_keyed_str(PARROT_INTERP, PMC *_self, STRING *key)
{
#line 571 "./src/pmc/hash.pmc"

    const Hash * const hash = (Hash*)VTABLE_get_pointer(interp, _self);
    HashBucket * const b =
        parrot_hash_get_bucket(interp, hash, hash_key_from_string(interp, hash, key));

    if (!b)
        return Parrot_str_new_noinit(interp, enum_stringrep_one, 0);

    return hash_value_to_string(interp, hash, b->value);
#line 607 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_init(PARROT_INTERP, PMC *_self)
{
#line 76 "./src/pmc/hash.pmc"

    Parrot_Hash_attributes * const attr =
        (Parrot_Hash_attributes *) PMC_data(_self);

    attr->hash            = parrot_new_hash(interp);
    attr->hash->container = _self;
    PObj_custom_mark_destroy_SETALL(_self);
#line 620 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_init_int(PARROT_INTERP, PMC *_self, INTVAL value_type)
{
#line 85 "./src/pmc/hash.pmc"

    Parrot_Hash_attributes * const attr =
        (Parrot_Hash_attributes *) PMC_data(_self);

    attr->hash = parrot_create_hash(interp,
            (PARROT_DATA_TYPE)value_type,
            Hash_key_type_STRING,
            STRING_compare,
            (hash_hash_key_fn)key_hash_STRING);
    attr->hash->container = _self;
    PObj_custom_mark_destroy_SETALL(_self);
#line 637 "./src/pmc/hash.c"
}
static  INTVAL 
Parrot_Hash_is_equal(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 1049 "./src/pmc/hash.pmc"

    PMC * const iter = VTABLE_get_iter(interp, _self);
    INTVAL      j, n;

    if (value->vtable->base_type != _self->vtable->base_type)
        return 0;

    n = VTABLE_elements(interp, _self);

    if (VTABLE_elements(interp, value) != n)
        return 0;

    for (j = 0; j < n; ++j) {
        STRING * const key = VTABLE_shift_string(interp, iter);
        PMC           *item1, *item2;

        if (!VTABLE_exists_keyed_str(interp, value, key))
            return 0;

        item1 = VTABLE_get_pmc_keyed_str(interp, _self, key);
        item2 = VTABLE_get_pmc_keyed_str(interp, value, key);

        if (item1 == item2)
            continue;

        if (!VTABLE_is_equal(interp, item1, item2))
            return 0;
    }

    return 1;
#line 673 "./src/pmc/hash.c"
}
static  INTVAL 
Parrot_Hash_is_same(PARROT_INTERP, PMC *_self, PMC *other)
{
#line 1032 "./src/pmc/hash.pmc"

    return (INTVAL)(other->vtable == _self->vtable &&
        VTABLE_get_pointer(interp, other) == VTABLE_get_pointer(interp, _self));
#line 682 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_mark(PARROT_INTERP, PMC *_self)
{
#line 113 "./src/pmc/hash.pmc"

    Hash * const hash = (Hash *)VTABLE_get_pointer(interp, _self);
    if (hash != NULL)
        parrot_mark_hash(interp, hash);
#line 692 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_set_integer_keyed(PARROT_INTERP, PMC *_self, PMC *key, INTVAL value)
{
#line 452 "./src/pmc/hash.pmc"

    Hash   * const hash    = (Hash *)VTABLE_get_pointer(interp, _self);
    void   * const keystr  = hash_key_from_pmc(interp, hash, key);
    PMC    * const nextkey = key_next(interp, key);
    PMC    *box;
    HashBucket *b;

    if (!nextkey) {
        parrot_hash_put(interp, hash, keystr,
                hash_value_from_int(interp, hash, value));
        return;
    }

    b = parrot_hash_get_bucket(interp, hash, keystr);
    if (b)
        box = hash_value_to_pmc(interp, hash, b->value);
    else {
        /* autovivify an Hash */
        box = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
        parrot_hash_put(interp, hash, keystr,
                hash_value_from_pmc(interp, hash, box));
    }

    VTABLE_set_integer_keyed(interp, box, nextkey, value);
#line 722 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_set_integer_keyed_int(PARROT_INTERP, PMC *_self, INTVAL key, INTVAL value)
{
#line 478 "./src/pmc/hash.pmc"

    Hash * const hash = (Hash *)VTABLE_get_pointer(interp, _self);
    parrot_hash_put(interp, hash, hash_key_from_int(interp, hash, key),
            hash_value_from_int(interp, hash, value));
#line 732 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_set_integer_keyed_str(PARROT_INTERP, PMC *_self, STRING *key, INTVAL value)
{
#line 492 "./src/pmc/hash.pmc"

    Hash * const hash = (Hash *)VTABLE_get_pointer(interp, _self);
    parrot_hash_put(interp, hash, hash_key_from_string(interp, hash, key),
            hash_value_from_int(interp, hash, value));
#line 742 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_set_integer_native(PARROT_INTERP, PMC *_self, INTVAL type)
{
#line 174 "./src/pmc/hash.pmc"

    Hash            *new_hash;
    Hash * const     old_hash   = PARROT_HASH(_self)->hash;
    PARROT_DATA_TYPE entry_type = old_hash
                                ? old_hash->entry_type
                                : enum_type_PMC;

    if (type == Hash_key_type_STRING)
        new_hash = parrot_create_hash(interp,
                entry_type,
                Hash_key_type_STRING,
                STRING_compare,
                (hash_hash_key_fn)key_hash_STRING);
    else if (type == Hash_key_type_int)
        /* new_int_hash set BOTH keys and values to INTVAL */
        new_hash = parrot_create_hash(interp,
                entry_type,
                Hash_key_type_int,
                int_compare,
                key_hash_int);
    else if (type == Hash_key_type_PMC)
        /* new_int_hash set BOTH keys and values to INTVAL */
        new_hash = parrot_create_hash(interp,
                entry_type,
                Hash_key_type_PMC,
                (hash_comp_fn)PMC_compare,
                (hash_hash_key_fn)key_hash_PMC);
    else
        /* We probably will not implement other types of keys. They are way
         * too dangerous to use from PIR */
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNIMPLEMENTED,
            "Hash: Unknown key type");


    PARROT_HASH(_self)->hash = new_hash;
    new_hash->container     = _self;

    if (old_hash)
        parrot_hash_destroy(interp, old_hash);
#line 787 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_set_number_keyed(PARROT_INTERP, PMC *_self, PMC *key, FLOATVAL value)
{
#line 758 "./src/pmc/hash.pmc"

    Hash   * const hash    = (Hash *)VTABLE_get_pointer(interp, _self);
    void   * const keystr  = hash_key_from_pmc(interp, hash, key);
    PMC    * const nextkey = key_next(interp, key);
    PMC    *box            = PMCNULL;
    HashBucket *b;


    if (!nextkey) {
        PMC * const val = get_number_pmc(interp, value);
        parrot_hash_put(interp, hash, keystr, hash_value_from_pmc(interp, hash, val));
        return;
    }

    b = parrot_hash_get_bucket(interp, (Hash *)VTABLE_get_pointer(interp, _self), keystr);
    if (b)
        box = hash_value_to_pmc(interp, hash, b->value);

    /* autovivify an Hash */
    if (PMC_IS_NULL(box))
        box = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    VTABLE_set_number_keyed(interp, box, nextkey, value);
#line 816 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_set_number_keyed_str(PARROT_INTERP, PMC *_self, STRING *key, FLOATVAL value)
{
#line 793 "./src/pmc/hash.pmc"

    PMC * const val  = get_number_pmc(interp, value);

    parrot_hash_put(interp, (Hash *)VTABLE_get_pointer(interp, _self), key, val);
#line 826 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_set_pmc_keyed(PARROT_INTERP, PMC *_self, PMC *key, PMC *value)
{
#line 807 "./src/pmc/hash.pmc"

    Hash   * const hash    = (Hash *)VTABLE_get_pointer(interp, _self);
    void   * const keystr  = hash_key_from_pmc(interp, hash, key);
    PMC    * const nextkey = key_next(interp, key);
    PMC    *box;
    HashBucket *b;

    if (!nextkey) {
        parrot_hash_put(interp, hash, keystr, value);
        return;
    }

    b = parrot_hash_get_bucket(interp, hash, keystr);
    if (b)
        box = hash_value_to_pmc(interp, hash, b->value);
    else {
        /* autovivify an Hash */
        box = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
        parrot_hash_put(interp, hash, keystr,
                hash_value_from_pmc(interp, hash, box));
    }


    VTABLE_set_pmc_keyed(interp, box, nextkey, value);
#line 856 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_set_pmc_keyed_str(PARROT_INTERP, PMC *_self, STRING *key, PMC *value)
{
#line 843 "./src/pmc/hash.pmc"

    Hash * const hash = (Hash *)VTABLE_get_pointer(interp, _self);
    parrot_hash_put(interp, hash, hash_key_from_string(interp, hash, key),
            hash_value_from_pmc(interp, hash, value));
#line 866 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_set_pointer(PARROT_INTERP, PMC *_self, void *ptr)
{
#line 148 "./src/pmc/hash.pmc"

    Hash * const old_hash = (Hash *)VTABLE_get_pointer(interp, _self);
    Hash * const new_hash = (Hash *)ptr;

    PARROT_HASH(_self)->hash = new_hash;
    new_hash->container     = _self;

    if (old_hash)
        parrot_hash_destroy(interp, old_hash);
#line 881 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_set_string_keyed(PARROT_INTERP, PMC *_self, PMC *key, STRING *value)
{
#line 632 "./src/pmc/hash.pmc"

    Hash   * const hash    = (Hash *)VTABLE_get_pointer(interp, _self);
    void   * const keystr  = hash_key_from_pmc(interp, hash, key);
    PMC    * const nextkey = key_next(interp, key);
    PMC    *box;
    HashBucket *b;

    if (!nextkey) {
        parrot_hash_put(interp, hash, keystr,
                hash_value_from_string(interp, hash, value));
        return;
    }

    b = parrot_hash_get_bucket(interp, hash, keystr);
    if (b)
        box = hash_value_to_pmc(interp, hash, b->value);
    else {
        /* autovivify an Hash */
        box = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
        parrot_hash_put(interp, hash, keystr,
                hash_value_from_pmc(interp, hash, box));
    }

    VTABLE_set_string_keyed(interp, box, nextkey, value);
#line 911 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_set_string_keyed_int(PARROT_INTERP, PMC *_self, INTVAL key, STRING *value)
{
#line 673 "./src/pmc/hash.pmc"

    Hash * const hash = (Hash *)VTABLE_get_pointer(interp, _self);
    parrot_hash_put(interp, hash,
            hash_key_from_int(interp, hash, key),
            hash_value_from_string(interp, hash, value));
#line 922 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_set_string_keyed_str(PARROT_INTERP, PMC *_self, STRING *key, STRING *value)
{
#line 666 "./src/pmc/hash.pmc"

    Hash * const hash = (Hash *)VTABLE_get_pointer(interp, _self);
    parrot_hash_put(interp, hash,
            hash_key_from_string(interp, hash, key),
            hash_value_from_string(interp, hash, value));
#line 933 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_thaw(PARROT_INTERP, PMC *_self, PMC *info)
{
#line 1125 "./src/pmc/hash.pmc"

    interp->vtables[enum_class_default]->thaw(interp, _self, info);

    {
        const INTVAL elems  = VTABLE_shift_integer(interp, info);
        const INTVAL k_type = VTABLE_shift_integer(interp, info);
        const INTVAL v_type = VTABLE_shift_integer(interp, info);
        Hash        *hash;

        if (k_type != Hash_key_type_STRING || v_type != enum_hash_pmc) {
            hash_comp_fn cmp_fn;
            hash_hash_key_fn key_fn;

            switch (k_type) {
              case Hash_key_type_int:
                key_fn = (hash_hash_key_fn)key_hash_int;
                cmp_fn = (hash_comp_fn)int_compare;
                break;
              case Hash_key_type_STRING:
                key_fn = (hash_hash_key_fn)key_hash_STRING;
                cmp_fn = (hash_comp_fn)STRING_compare;
                break;
              case Hash_key_type_PMC:
                key_fn = (hash_hash_key_fn)key_hash_PMC;
                cmp_fn = (hash_comp_fn)PMC_compare;
                break;
              default:
                Parrot_ex_throw_from_c_args(interp, NULL, 1,
                        "unimplemented key type");
                break;
            }

            VTABLE_set_pointer(interp, _self, parrot_create_hash(interp, (PARROT_DATA_TYPE)v_type,
                                                (Hash_key_type)k_type, cmp_fn, key_fn));
        }

        hash = (Hash *)VTABLE_get_pointer(interp, _self);

        PARROT_ASSERT((INTVAL)hash->key_type == k_type);
        PARROT_ASSERT(hash->entry_type       == v_type);

        hash->container = _self;
        hash->entries   = elems;
    }
#line 983 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_visit(PARROT_INTERP, PMC *_self, PMC *info)
{
#line 1091 "./src/pmc/hash.pmc"

    parrot_hash_visit(interp, (Hash *)VTABLE_get_pointer(interp, _self), info);
    interp->vtables[enum_class_default]->visit(interp, _self, info);
#line 992 "./src/pmc/hash.c"
}
static  void
Parrot_Hash_nci_set_key_type(PARROT_INTERP, PMC *_self)
{
#line 422 "/home/mandrake/rpm/BUILD/parrot-2.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 1004 "./src/pmc/hash.pmc"
PMC* _self;
INTVAL type;

#line 430 "/home/mandrake/rpm/BUILD/parrot-2.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiI",
            &_self, &type);
#line 434 "/home/mandrake/rpm/BUILD/parrot-2.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 215 "./src/pmc/hash.pmc"

    _self->vtable->set_integer_native(interp, _self, type);
#line 441 "/home/mandrake/rpm/BUILD/parrot-2.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 1021 "./src/pmc/hash.c"
}
static  void
Parrot_Hash_nci_get_key_type(PARROT_INTERP, PMC *_self)
{
#line 422 "/home/mandrake/rpm/BUILD/parrot-2.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 1033 "./src/pmc/hash.pmc"
PMC* _self;

#line 430 "/home/mandrake/rpm/BUILD/parrot-2.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
#line 434 "/home/mandrake/rpm/BUILD/parrot-2.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 228 "./src/pmc/hash.pmc"

    const INTVAL ret = ((Hash *)_self->vtable->get_pointer(interp, _self))->key_type;
    #line 260 "/home/mandrake/rpm/BUILD/parrot-2.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL ret */
#line 267 "/home/mandrake/rpm/BUILD/parrot-2.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "I", (INTVAL)ret);
    return;
    /*END RETURN INTVAL ret */
    }
#line 230 "./src/pmc/hash.pmc"

#line 441 "/home/mandrake/rpm/BUILD/parrot-2.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 1060 "./src/pmc/hash.c"
}
static  void
Parrot_Hash_nci_set_value_type(PARROT_INTERP, PMC *_self)
{
#line 422 "/home/mandrake/rpm/BUILD/parrot-2.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 1072 "./src/pmc/hash.pmc"
PMC* _self;
INTVAL type;

#line 430 "/home/mandrake/rpm/BUILD/parrot-2.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiI",
            &_self, &type);
#line 434 "/home/mandrake/rpm/BUILD/parrot-2.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 244 "./src/pmc/hash.pmc"

    Hash *old_hash = (Hash *)_self->vtable->get_pointer(interp, _self);
    Hash *new_hash;

    /*
    If someone called Hash.set_pointer with NULL pointer...
    It will create STRING* keys hash. Because we can't use STRING_compare
    directly - it declared static in F<src/hash.c>
    */
    if (old_hash && old_hash->entry_type == type)
        return;

    switch (type) {
      case enum_type_INTVAL:
      case enum_type_STRING:
      case enum_type_PMC:
        new_hash = parrot_create_hash(interp,
                    (PARROT_DATA_TYPE)type,
                    old_hash ? old_hash->key_type : Hash_key_type_STRING,
                    old_hash ? old_hash->compare : STRING_compare,
                    old_hash ? old_hash->hash_val : (hash_hash_key_fn)key_hash_STRING);
        break;
      default:
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNIMPLEMENTED,
                    "Hash: unsupported entry_type %d", type);
    }

    PARROT_HASH(_self)->hash = new_hash;
    new_hash->container     = _self;

    if (old_hash)
        parrot_hash_destroy(interp, old_hash);
#line 441 "/home/mandrake/rpm/BUILD/parrot-2.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 1119 "./src/pmc/hash.c"
}
static  void
Parrot_Hash_nci_get_value_type(PARROT_INTERP, PMC *_self)
{
#line 422 "/home/mandrake/rpm/BUILD/parrot-2.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 1131 "./src/pmc/hash.pmc"
PMC* _self;

#line 430 "/home/mandrake/rpm/BUILD/parrot-2.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
#line 434 "/home/mandrake/rpm/BUILD/parrot-2.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 278 "./src/pmc/hash.pmc"

    INTVAL ret = ((Hash *)_self->vtable->get_pointer(interp, _self))->entry_type;
    #line 260 "/home/mandrake/rpm/BUILD/parrot-2.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL ret */
#line 267 "/home/mandrake/rpm/BUILD/parrot-2.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "I", (INTVAL)ret);
    return;
    /*END RETURN INTVAL ret */
    }
#line 280 "./src/pmc/hash.pmc"

#line 441 "/home/mandrake/rpm/BUILD/parrot-2.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 1158 "./src/pmc/hash.c"
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_Hash_update_vtable(VTABLE *vt) {
    vt->clone = Parrot_Hash_clone;
    vt->defined_keyed = Parrot_Hash_defined_keyed;
    vt->defined_keyed_str = Parrot_Hash_defined_keyed_str;
    vt->delete_keyed = Parrot_Hash_delete_keyed;
    vt->delete_keyed_str = Parrot_Hash_delete_keyed_str;
    vt->destroy = Parrot_Hash_destroy;
    vt->elements = Parrot_Hash_elements;
    vt->exists_keyed = Parrot_Hash_exists_keyed;
    vt->exists_keyed_str = Parrot_Hash_exists_keyed_str;
    vt->freeze = Parrot_Hash_freeze;
    vt->get_bool = Parrot_Hash_get_bool;
    vt->get_integer = Parrot_Hash_get_integer;
    vt->get_integer_keyed = Parrot_Hash_get_integer_keyed;
    vt->get_integer_keyed_int = Parrot_Hash_get_integer_keyed_int;
    vt->get_integer_keyed_str = Parrot_Hash_get_integer_keyed_str;
    vt->get_iter = Parrot_Hash_get_iter;
    vt->get_number = Parrot_Hash_get_number;
    vt->get_number_keyed = Parrot_Hash_get_number_keyed;
    vt->get_number_keyed_int = Parrot_Hash_get_number_keyed_int;
    vt->get_number_keyed_str = Parrot_Hash_get_number_keyed_str;
    vt->get_pmc_keyed = Parrot_Hash_get_pmc_keyed;
    vt->get_pmc_keyed_int = Parrot_Hash_get_pmc_keyed_int;
    vt->get_pmc_keyed_str = Parrot_Hash_get_pmc_keyed_str;
    vt->get_pointer = Parrot_Hash_get_pointer;
    vt->get_repr = Parrot_Hash_get_repr;
    vt->get_string = Parrot_Hash_get_string;
    vt->get_string_keyed = Parrot_Hash_get_string_keyed;
    vt->get_string_keyed_int = Parrot_Hash_get_string_keyed_int;
    vt->get_string_keyed_str = Parrot_Hash_get_string_keyed_str;
    vt->init = Parrot_Hash_init;
    vt->init_int = Parrot_Hash_init_int;
    vt->is_equal = Parrot_Hash_is_equal;
    vt->is_same = Parrot_Hash_is_same;
    vt->mark = Parrot_Hash_mark;
    vt->set_integer_keyed = Parrot_Hash_set_integer_keyed;
    vt->set_integer_keyed_int = Parrot_Hash_set_integer_keyed_int;
    vt->set_integer_keyed_str = Parrot_Hash_set_integer_keyed_str;
    vt->set_integer_native = Parrot_Hash_set_integer_native;
    vt->set_number_keyed = Parrot_Hash_set_number_keyed;
    vt->set_number_keyed_str = Parrot_Hash_set_number_keyed_str;
    vt->set_pmc_keyed = Parrot_Hash_set_pmc_keyed;
    vt->set_pmc_keyed_str = Parrot_Hash_set_pmc_keyed_str;
    vt->set_pointer = Parrot_Hash_set_pointer;
    vt->set_string_keyed = Parrot_Hash_set_string_keyed;
    vt->set_string_keyed_int = Parrot_Hash_set_string_keyed_int;
    vt->set_string_keyed_str = Parrot_Hash_set_string_keyed_str;
    vt->thaw = Parrot_Hash_thaw;
    vt->visit = Parrot_Hash_visit;
    vt->attr_size = sizeof(Parrot_Hash_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_Hash_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->clone = Parrot_Hash_clone;
    vt->defined_keyed = Parrot_Hash_defined_keyed;
    vt->defined_keyed_str = Parrot_Hash_defined_keyed_str;
    vt->destroy = Parrot_Hash_destroy;
    vt->elements = Parrot_Hash_elements;
    vt->exists_keyed = Parrot_Hash_exists_keyed;
    vt->exists_keyed_str = Parrot_Hash_exists_keyed_str;
    vt->freeze = Parrot_Hash_freeze;
    vt->get_bool = Parrot_Hash_get_bool;
    vt->get_integer = Parrot_Hash_get_integer;
    vt->get_integer_keyed = Parrot_Hash_get_integer_keyed;
    vt->get_integer_keyed_int = Parrot_Hash_get_integer_keyed_int;
    vt->get_integer_keyed_str = Parrot_Hash_get_integer_keyed_str;
    vt->get_iter = Parrot_Hash_get_iter;
    vt->get_number = Parrot_Hash_get_number;
    vt->get_number_keyed = Parrot_Hash_get_number_keyed;
    vt->get_number_keyed_int = Parrot_Hash_get_number_keyed_int;
    vt->get_number_keyed_str = Parrot_Hash_get_number_keyed_str;
    vt->get_pmc_keyed = Parrot_Hash_get_pmc_keyed;
    vt->get_pmc_keyed_int = Parrot_Hash_get_pmc_keyed_int;
    vt->get_pmc_keyed_str = Parrot_Hash_get_pmc_keyed_str;
    vt->get_pointer = Parrot_Hash_get_pointer;
    vt->get_repr = Parrot_Hash_get_repr;
    vt->get_string = Parrot_Hash_get_string;
    vt->get_string_keyed = Parrot_Hash_get_string_keyed;
    vt->get_string_keyed_int = Parrot_Hash_get_string_keyed_int;
    vt->get_string_keyed_str = Parrot_Hash_get_string_keyed_str;
    vt->init = Parrot_Hash_init;
    vt->init_int = Parrot_Hash_init_int;
    vt->is_equal = Parrot_Hash_is_equal;
    vt->is_same = Parrot_Hash_is_same;
    vt->mark = Parrot_Hash_mark;
    vt->visit = Parrot_Hash_visit;
    vt->attr_size = sizeof(Parrot_Hash_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Hash_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_get_vtable(interp);
    Parrot_Hash_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Hash_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_ro_get_vtable(interp);
    Parrot_Hash_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_Hash_get_mro(PARROT_INTERP, PMC* mro) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }

    VTABLE_unshift_string(interp, mro,
        string_make(interp, "Hash", 4, NULL, 0));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_Hash_get_isa(PARROT_INTERP, Hash* isa) {
    if (isa == NULL) {
        isa = parrot_new_hash(interp);
    }
    parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "Hash")), PMCNULL);
    return isa;
}

void
Parrot_Hash_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        ":hash ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_Hash_get_vtable(interp);
        vt->base_type      = enum_class_Hash;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "Hash");
        vt->provides_str = CONST_STRING_GEN(interp, "hash");
        vt->isa_hash     = Parrot_Hash_get_isa(interp, NULL);
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_Hash_ro_get_vtable(interp);
            vt_ro->base_type      = enum_class_Hash;
            vt_ro->flags          = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_Hash_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_Hash_nci_set_key_type), CONST_STRING_GEN(interp, "set_key_type"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_Hash_nci_get_key_type), CONST_STRING_GEN(interp, "get_key_type"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_Hash_nci_set_value_type), CONST_STRING_GEN(interp, "set_value_type"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_Hash_nci_get_value_type), CONST_STRING_GEN(interp, "get_value_type"));
        {
        }
    } /* pass */
} /* Parrot_Hash_class_init */
#line 1169 "./src/pmc/hash.pmc"


/*

=back

=head1 SEE ALSO

F<docs/pdds/pdd08_keys.pod>.

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
