/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/hashiterator.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_hashiterator.h"
#include "pmc_iterator.h"
#include "pmc_default.h"
#include "hashiterator.str"
#include "pmc_continuation.h"
#include "pmc_callcontext.h"
#line 1 "./src/pmc/hashiterator.pmc"
/*
Copyright (C) 2001-2010, Parrot Foundation.
$Id: hashiterator.pmc 47863 2010-06-26 12:50:08Z whiteknight $

=head1 NAME

src/pmc/hashiterator.pmc - Implementation of Iterator for Hashes.

=head1 DESCRIPTION

Generic iterator for traversing Hash.

=head1 SYNOPSIS

=head2 default usage

    .local pmc iterator, hash, key, entry
    iterator = iter hash
  iter_loop:
    unless iterator, iter_end  # while (more values)
    key   = shift iterator     # get the key. Some key
    entry = hash[key]
    ...
    goto iter_loop
  iter_end:

=head2 C++-style usage

    .local pmc iterator, hash, iter_key, key, entry
    iterator = iter hash
  iter_loop:
    unless iterator, iter_end  # while (more values)
    iter_key = shift iterator     # get the key
    key = iter_key.'key'()        # get an original key used to put value
    key = iter_key.'value'()      # get an entry
    ...
    goto iter_loop
  iter_end:


=head1 Methods

=over 4

=cut

*/

#include "pmc/pmc_hash.h"
#include "pmc/pmc_hashiteratorkey.h"

/* HEADERIZER HFILE: none */
/* HEADERIZER BEGIN: static */
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */

static void advance_to_next(PARROT_INTERP, ARGMOD(PMC *self))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        FUNC_MODIFIES(*self);

#define ASSERT_ARGS_advance_to_next __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self))
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */
/* HEADERIZER END: static */

/*

Advance to next position. Return found (if any) HashBucket.

*/

static void
advance_to_next(PARROT_INTERP, ARGMOD(PMC *self))
{
    ASSERT_ARGS(advance_to_next)

    Parrot_HashIterator_attributes * const attrs  = PARROT_HASHITERATOR(self);
    HashBucket                            *bucket = attrs->bucket;

    /* Try to advance current bucket */
    if (bucket)
        bucket = bucket->next;

    while (!bucket) {
        /* If there is no more buckets */
        if (attrs->pos == attrs->total_buckets)
            break;

        bucket = attrs->parrot_hash->bucket_indices[attrs->pos++];
    }
    attrs->bucket = bucket;
    --attrs->elements;

    return;
}
#line 120 "./src/pmc/hashiterator.c"
static  PMC*  Parrot_HashIterator_clone(PARROT_INTERP, PMC *_self);
static  INTVAL  Parrot_HashIterator_elements(PARROT_INTERP, PMC *_self);
static  INTVAL  Parrot_HashIterator_get_bool(PARROT_INTERP, PMC *_self);
static  INTVAL  Parrot_HashIterator_get_integer(PARROT_INTERP, PMC *_self);
static  PMC*  Parrot_HashIterator_get_pmc(PARROT_INTERP, PMC *_self);
static  void  Parrot_HashIterator_init_pmc(PARROT_INTERP, PMC *_self, PMC *hash);
static  void  Parrot_HashIterator_mark(PARROT_INTERP, PMC *_self);
static  void  Parrot_HashIterator_set_integer_native(PARROT_INTERP, PMC *_self, INTVAL value);
static  PMC  * Parrot_HashIterator_shift_pmc(PARROT_INTERP, PMC *_self);
static  STRING*  Parrot_HashIterator_shift_string(PARROT_INTERP, PMC *_self);
void    Parrot_HashIterator_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_HashIterator_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_HashIterator_get_vtable(PARROT_INTERP);
void    Parrot_HashIterator_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_HashIterator_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_HashIterator_ro_get_vtable(PARROT_INTERP);
static  PMC* 
Parrot_HashIterator_clone(PARROT_INTERP, PMC *_self)
{
#line 160 "./src/pmc/hashiterator.pmc"

    return PMCNULL;
#line 143 "./src/pmc/hashiterator.c"
}
static  INTVAL 
Parrot_HashIterator_elements(PARROT_INTERP, PMC *_self)
{
#line 223 "./src/pmc/hashiterator.pmc"

    return PARROT_HASHITERATOR(_self)->elements;
#line 151 "./src/pmc/hashiterator.c"
}
static  INTVAL 
Parrot_HashIterator_get_bool(PARROT_INTERP, PMC *_self)
{
#line 209 "./src/pmc/hashiterator.pmc"

    return PARROT_HASHITERATOR(_self)->bucket != 0;
#line 159 "./src/pmc/hashiterator.c"
}
static  INTVAL 
Parrot_HashIterator_get_integer(PARROT_INTERP, PMC *_self)
{
#line 227 "./src/pmc/hashiterator.pmc"

    return VTABLE_elements(interp, _self);
#line 167 "./src/pmc/hashiterator.c"
}
static  PMC* 
Parrot_HashIterator_get_pmc(PARROT_INTERP, PMC *_self)
{
#line 195 "./src/pmc/hashiterator.pmc"

    return PARROT_HASHITERATOR(_self)->pmc_hash;
#line 175 "./src/pmc/hashiterator.c"
}
static  void 
Parrot_HashIterator_init_pmc(PARROT_INTERP, PMC *_self, PMC *hash)
{
#line 117 "./src/pmc/hashiterator.pmc"

    Parrot_HashIterator_attributes * const attrs =
        (Parrot_HashIterator_attributes *) PMC_data(_self);

    attrs->pmc_hash         = hash;
    attrs->parrot_hash      = (Hash*)VTABLE_get_pointer(interp, hash);
    attrs->total_buckets    = attrs->parrot_hash->mask + 1;
    attrs->bucket           = 0;
    attrs->pos              = 0;
    /* Will be decreased on initial advance_to_next */
    /* XXX Do we really need to support this use-case ? */
    attrs->elements         = attrs->parrot_hash->entries + 1;

    PObj_custom_mark_SET(_self);

    /* Initial state of iterator is "before start" */
    /* So, advance to first element */
    advance_to_next(interp, _self);
#line 199 "./src/pmc/hashiterator.c"
}
static  void 
Parrot_HashIterator_mark(PARROT_INTERP, PMC *_self)
{
#line 147 "./src/pmc/hashiterator.pmc"

    PMC * const hash = PARROT_HASHITERATOR(_self)->pmc_hash;
    Parrot_gc_mark_PMC_alive(interp, hash);
    /* We don't mark underlying parrot_hash. Hash PMC will mark it */
#line 209 "./src/pmc/hashiterator.c"
}
static  void 
Parrot_HashIterator_set_integer_native(PARROT_INTERP, PMC *_self, INTVAL value)
{
#line 171 "./src/pmc/hashiterator.pmc"

    Parrot_HashIterator_attributes * const attrs =
            PARROT_HASHITERATOR(_self);

    if (value == ITERATE_FROM_START) {
        /* Restart iterator */
        attrs->bucket           = 0;
        attrs->pos              = 0;
        advance_to_next(interp, _self);
        return;
    }

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            "HashIterator: unknown iterator type");
#line 229 "./src/pmc/hashiterator.c"
}
static  PMC  *
Parrot_HashIterator_shift_pmc(PARROT_INTERP, PMC *_self)
{
#line 242 "./src/pmc/hashiterator.pmc"

    Parrot_HashIterator_attributes * const attrs =
            PARROT_HASHITERATOR(_self);

    PMC        *ret;

    if (!attrs->bucket)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
            "StopIteration");

    ret = Parrot_pmc_new(interp, enum_class_HashIteratorKey);
    VTABLE_set_pointer_keyed_int(interp, ret, 0, attrs->parrot_hash);
    VTABLE_set_pointer_keyed_int(interp, ret, 1, attrs->bucket);

    /* Move to next bucket */
    advance_to_next(interp, _self);

    return ret;
#line 253 "./src/pmc/hashiterator.c"
}
static  STRING* 
Parrot_HashIterator_shift_string(PARROT_INTERP, PMC *_self)
{
#line 266 "./src/pmc/hashiterator.pmc"

    Parrot_HashIterator_attributes * const attrs =
            PARROT_HASHITERATOR(_self);
    HashBucket                     * const bucket = attrs->bucket;

    if (!attrs->parrot_hash || !attrs->bucket)
        return CONST_STRING(interp, "");

    /* Move to next bucket */
    advance_to_next(interp, _self);

    return hash_key_to_string(interp, attrs->parrot_hash, bucket->key);
#line 271 "./src/pmc/hashiterator.c"
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_HashIterator_update_vtable(VTABLE *vt) {
    vt->clone = Parrot_HashIterator_clone;
    vt->elements = Parrot_HashIterator_elements;
    vt->get_bool = Parrot_HashIterator_get_bool;
    vt->get_integer = Parrot_HashIterator_get_integer;
    vt->get_pmc = Parrot_HashIterator_get_pmc;
    vt->init_pmc = Parrot_HashIterator_init_pmc;
    vt->mark = Parrot_HashIterator_mark;
    vt->set_integer_native = Parrot_HashIterator_set_integer_native;
    vt->shift_pmc = Parrot_HashIterator_shift_pmc;
    vt->shift_string = Parrot_HashIterator_shift_string;
    vt->attr_size = sizeof(Parrot_HashIterator_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_HashIterator_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->clone = Parrot_HashIterator_clone;
    vt->elements = Parrot_HashIterator_elements;
    vt->get_bool = Parrot_HashIterator_get_bool;
    vt->get_integer = Parrot_HashIterator_get_integer;
    vt->get_pmc = Parrot_HashIterator_get_pmc;
    vt->init_pmc = Parrot_HashIterator_init_pmc;
    vt->mark = Parrot_HashIterator_mark;
    vt->attr_size = sizeof(Parrot_HashIterator_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_HashIterator_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_Iterator_get_vtable(interp);
    Parrot_HashIterator_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_HashIterator_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_Iterator_ro_get_vtable(interp);
    Parrot_HashIterator_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_HashIterator_get_mro(PARROT_INTERP, PMC* mro) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }
    mro = Parrot_Iterator_get_mro(interp, mro);

    VTABLE_unshift_string(interp, mro,
        string_make(interp, "HashIterator", 12, NULL, 0));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_HashIterator_get_isa(PARROT_INTERP, Hash* isa) {
    isa = Parrot_Iterator_get_isa(interp, isa);
    parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "HashIterator")), PMCNULL);
    return isa;
}

void
Parrot_HashIterator_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "Fpmc_hash :parrot_hash :bucket Itotal_buckets Ipos Ielements ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_HashIterator_get_vtable(interp);
        vt->base_type      = enum_class_HashIterator;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "HashIterator");
        vt->provides_str = CONST_STRING_GEN(interp, "scalar");
        vt->isa_hash     = Parrot_HashIterator_get_isa(interp, NULL);
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_HashIterator_ro_get_vtable(interp);
            vt_ro->base_type      = enum_class_HashIterator;
            vt_ro->flags          = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_HashIterator_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        {
        }
    } /* pass */
} /* Parrot_HashIterator_class_init */
#line 279 "./src/pmc/hashiterator.pmc"


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
