/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/integer.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_integer.h"
#include "pmc_scalar.h"
#include "pmc_default.h"
#include "integer.str"
#include "pmc_continuation.h"
#include "pmc_callcontext.h"
#line 1 "./src/pmc/integer.pmc"
/*
Copyright (C) 2003-2010, Parrot Foundation.
$Id: integer.pmc 46300 2010-05-05 03:58:50Z jimmy $

=head1 NAME

src/pmc/integer.pmc - Integer PMC class

=head1 DESCRIPTION

C<Integer> provides an integer for languages that want a value-restricted
integer type without going to an I register.

=head2 Functions

=over 4

=cut

*/

#include "pmc/pmc_bigint.h"

/* HEADERIZER HFILE: none */
/* HEADERIZER BEGIN: static */
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */

static void maybe_throw_overflow_error(PARROT_INTERP)
        __attribute__nonnull__(1);

PARROT_IGNORABLE_RESULT
PARROT_CANNOT_RETURN_NULL
static PMC* upgrade_self_to_bignum(PARROT_INTERP, ARGMOD(PMC *self))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        FUNC_MODIFIES(*self);

#define ASSERT_ARGS_maybe_throw_overflow_error __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp))
#define ASSERT_ARGS_upgrade_self_to_bignum __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self))
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */
/* HEADERIZER END: static */

static void
maybe_throw_overflow_error(PARROT_INTERP)
{
    ASSERT_ARGS(maybe_throw_overflow_error)

    /* check to see what the behavior is. If the interpreter is set
       to throw an exception on overflow. If so, throw the exception,
       otherwise, chill out it's no big deal. */
    if (PARROT_ERRORS_test(interp, PARROT_ERRORS_OVERFLOW_FLAG))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_ERR_OVERFLOW,
            "Integer overflow");
}

PARROT_IGNORABLE_RESULT
PARROT_CANNOT_RETURN_NULL
static PMC*
upgrade_self_to_bignum(PARROT_INTERP, ARGMOD(PMC *self))
{
    ASSERT_ARGS(upgrade_self_to_bignum)

    /* Do an in-place upgrade to a Bignum of SELF and return a pointer
       to it (which is probably redundant, but whatever). */
    const INTVAL a = VTABLE_get_integer(interp, self);
    Parrot_pmc_reuse(interp, self, enum_class_BigInt, 0);
    VTABLE_set_integer_native(interp, self, a);
    return self;
}
#line 97 "./src/pmc/integer.c"
static  PMC  * Parrot_Integer_absolute(PARROT_INTERP, PMC *_self, PMC *dest);
static  PMC * Parrot_Integer_add(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_add_int(PARROT_INTERP, PMC *_self, INTVAL b, PMC *dest);
static  PMC  * Parrot_Integer_clone(PARROT_INTERP, PMC *_self);
static  INTVAL Parrot_Integer_cmp(PARROT_INTERP, PMC *_self, PMC *value);
static  INTVAL Parrot_Integer_cmp_num(PARROT_INTERP, PMC *_self, PMC *value);
static  void  Parrot_Integer_decrement(PARROT_INTERP, PMC *_self);
static  PMC * Parrot_Integer_divide(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest);
static  PMC * Parrot_Integer_floor_divide(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_floor_divide_float(PARROT_INTERP, PMC *_self, FLOATVAL value, PMC *dest);
static  PMC  * Parrot_Integer_floor_divide_int(PARROT_INTERP, PMC *_self, INTVAL value, PMC *dest);
static  void  Parrot_Integer_freeze(PARROT_INTERP, PMC *_self, PMC *info);
static  INTVAL  Parrot_Integer_get_bool(PARROT_INTERP, PMC *_self);
static  INTVAL  Parrot_Integer_get_integer(PARROT_INTERP, PMC *_self);
static  FLOATVAL  Parrot_Integer_get_number(PARROT_INTERP, PMC *_self);
static  STRING  * Parrot_Integer_get_repr(PARROT_INTERP, PMC *_self);
static  STRING  * Parrot_Integer_get_string(PARROT_INTERP, PMC *_self);
static  void  Parrot_Integer_i_absolute(PARROT_INTERP, PMC *_self);
static  void Parrot_Integer_i_add(PARROT_INTERP, PMC *_self, PMC *value);
static  void  Parrot_Integer_i_add_float(PARROT_INTERP, PMC *_self, FLOATVAL value);
static  void  Parrot_Integer_i_add_int(PARROT_INTERP, PMC *_self, INTVAL b);
static  void Parrot_Integer_i_divide(PARROT_INTERP, PMC *_self, PMC *value);
static  void Parrot_Integer_i_floor_divide(PARROT_INTERP, PMC *_self, PMC *value);
static  void  Parrot_Integer_i_floor_divide_float(PARROT_INTERP, PMC *_self, FLOATVAL value);
static  void  Parrot_Integer_i_floor_divide_int(PARROT_INTERP, PMC *_self, INTVAL value);
static  void Parrot_Integer_i_modulus(PARROT_INTERP, PMC *_self, PMC *value);
static  void  Parrot_Integer_i_modulus_float(PARROT_INTERP, PMC *_self, FLOATVAL value);
static  void  Parrot_Integer_i_modulus_int(PARROT_INTERP, PMC *_self, INTVAL value);
static  void Parrot_Integer_i_multiply(PARROT_INTERP, PMC *_self, PMC *value);
static  void  Parrot_Integer_i_multiply_float(PARROT_INTERP, PMC *_self, FLOATVAL value);
static  void  Parrot_Integer_i_multiply_int(PARROT_INTERP, PMC *_self, INTVAL b);
static  void Parrot_Integer_i_subtract(PARROT_INTERP, PMC *_self, PMC *value);
static  void  Parrot_Integer_i_subtract_float(PARROT_INTERP, PMC *_self, FLOATVAL value);
static  void  Parrot_Integer_i_subtract_int(PARROT_INTERP, PMC *_self, INTVAL b);
static  void  Parrot_Integer_increment(PARROT_INTERP, PMC *_self);
static  void  Parrot_Integer_init(PARROT_INTERP, PMC *_self);
static  void  Parrot_Integer_init_int(PARROT_INTERP, PMC *_self, INTVAL init);
static  void  Parrot_Integer_init_pmc(PARROT_INTERP, PMC *_self, PMC *init);
static  INTVAL  Parrot_Integer_is_equal(PARROT_INTERP, PMC *_self, PMC *value);
static  PMC * Parrot_Integer_modulus(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_modulus_float(PARROT_INTERP, PMC *_self, FLOATVAL value, PMC *dest);
static  PMC  * Parrot_Integer_modulus_int(PARROT_INTERP, PMC *_self, INTVAL value, PMC *dest);
static  PMC * Parrot_Integer_multiply(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_multiply_int(PARROT_INTERP, PMC *_self, INTVAL b, PMC *dest);
static  void  Parrot_Integer_set_bool(PARROT_INTERP, PMC *_self, INTVAL value);
static  void  Parrot_Integer_set_integer_native(PARROT_INTERP, PMC *_self, INTVAL value);
static  void  Parrot_Integer_set_number_native(PARROT_INTERP, PMC *_self, FLOATVAL value);
static  void  Parrot_Integer_set_pmc(PARROT_INTERP, PMC *_self, PMC *value);
static  void  Parrot_Integer_set_string_native(PARROT_INTERP, PMC *_self, STRING *value);
static  void  Parrot_Integer_share(PARROT_INTERP, PMC *_self);
static  PMC * Parrot_Integer_subtract(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_subtract_int(PARROT_INTERP, PMC *_self, INTVAL b, PMC *dest);
static  void  Parrot_Integer_thaw(PARROT_INTERP, PMC *_self, PMC *info);
static  PMC  * Parrot_Integer_multi_add_Integer_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_multi_add_Complex_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_multi_add_BigInt_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_multi_add_DEFAULT_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest);
static  void  Parrot_Integer_multi_i_add_Integer(PARROT_INTERP, PMC *_self, PMC *value);
static  void  Parrot_Integer_multi_i_add_Complex(PARROT_INTERP, PMC *_self, PMC *value);
static  void  Parrot_Integer_multi_i_add_DEFAULT(PARROT_INTERP, PMC *_self, PMC *value);
static  PMC  * Parrot_Integer_multi_subtract_Integer_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_multi_subtract_Complex_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_multi_subtract_BigInt_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_multi_subtract_DEFAULT_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest);
static  void  Parrot_Integer_multi_i_subtract_Integer(PARROT_INTERP, PMC *_self, PMC *value);
static  void  Parrot_Integer_multi_i_subtract_Complex(PARROT_INTERP, PMC *_self, PMC *value);
static  void  Parrot_Integer_multi_i_subtract_DEFAULT(PARROT_INTERP, PMC *_self, PMC *value);
static  PMC  * Parrot_Integer_multi_multiply_Integer_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_multi_multiply_Complex_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_multi_multiply_BigInt_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_multi_multiply_String_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_multi_multiply_DEFAULT_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest);
static  void  Parrot_Integer_multi_i_multiply_Integer(PARROT_INTERP, PMC *_self, PMC *value);
static  void  Parrot_Integer_multi_i_multiply_BigInt(PARROT_INTERP, PMC *_self, PMC *value);
static  void  Parrot_Integer_multi_i_multiply_Complex(PARROT_INTERP, PMC *_self, PMC *value);
static  void  Parrot_Integer_multi_i_multiply_DEFAULT(PARROT_INTERP, PMC *_self, PMC *value);
static  PMC  * Parrot_Integer_multi_divide_BigInt_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_multi_divide_DEFAULT_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest);
static  void  Parrot_Integer_multi_i_divide_BigInt(PARROT_INTERP, PMC *_self, PMC *value);
static  void  Parrot_Integer_multi_i_divide_DEFAULT(PARROT_INTERP, PMC *_self, PMC *value);
static  PMC  * Parrot_Integer_multi_floor_divide_BigInt_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_multi_floor_divide_DEFAULT_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest);
static  void  Parrot_Integer_multi_i_floor_divide_BigInt(PARROT_INTERP, PMC *_self, PMC *value);
static  void  Parrot_Integer_multi_i_floor_divide_DEFAULT(PARROT_INTERP, PMC *_self, PMC *value);
static  PMC  * Parrot_Integer_multi_modulus_BigInt_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_multi_modulus_DEFAULT_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest);
static  void  Parrot_Integer_multi_i_modulus_BigInt(PARROT_INTERP, PMC *_self, PMC *value);
static  void  Parrot_Integer_multi_i_modulus_DEFAULT(PARROT_INTERP, PMC *_self, PMC *value);
static  INTVAL  Parrot_Integer_multi_cmp_String(PARROT_INTERP, PMC *_self, PMC *value);
static  INTVAL  Parrot_Integer_multi_cmp_Float(PARROT_INTERP, PMC *_self, PMC *value);
static  INTVAL  Parrot_Integer_multi_cmp_DEFAULT(PARROT_INTERP, PMC *_self, PMC *value);
static  INTVAL  Parrot_Integer_multi_cmp_num_String(PARROT_INTERP, PMC *_self, PMC *value);
static  INTVAL  Parrot_Integer_multi_cmp_num_Float(PARROT_INTERP, PMC *_self, PMC *value);
static  INTVAL  Parrot_Integer_multi_cmp_num_DEFAULT(PARROT_INTERP, PMC *_self, PMC *value);
static  void Parrot_Integer_nci_get_as_base(PARROT_INTERP, PMC *_self);
void    Parrot_Integer_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_Integer_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_Integer_get_vtable(PARROT_INTERP);
void    Parrot_Integer_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_Integer_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_Integer_ro_get_vtable(PARROT_INTERP);
static  PMC  *
Parrot_Integer_absolute(PARROT_INTERP, PMC *_self, PMC *dest)
{
#line 1187 "./src/pmc/integer.pmc"

    const INTVAL a = abs(VTABLE_get_integer(interp, _self));

    /* TT # 1245 overflow for -maxint */
    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    VTABLE_set_integer_native(interp, dest, a);
    return dest;

#line 212 "./src/pmc/integer.c"
}
static  PMC *
Parrot_Integer_add(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_Integer:
            return Parrot_Integer_multi_add_Integer_PMC(interp, _self, value, dest);
            break;

        case enum_class_Complex:
            return Parrot_Integer_multi_add_Complex_PMC(interp, _self, value, dest);
            break;

        case enum_class_BigInt:
            return Parrot_Integer_multi_add_BigInt_PMC(interp, _self, value, dest);
            break;

        default:
            if (type < enum_class_core_max)
                return Parrot_Integer_multi_add_DEFAULT_PMC(interp, _self, value, dest);
            else {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "add", "PPP->P", _self, value, dest, &retval);
                return retval;
            }
            break;

    }
}
static  PMC  *
Parrot_Integer_add_int(PARROT_INTERP, PMC *_self, INTVAL b, PMC *dest)
{
#line 350 "./src/pmc/integer.pmc"

    const INTVAL a = VTABLE_get_integer(interp, _self);
    const INTVAL c = a + b;

    if ((c^a) >= 0 || (c^b) >= 0) {
        dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

        VTABLE_set_integer_native(interp, dest, c);
        return dest;
    }
    else {
        PMC *temp;
        maybe_throw_overflow_error(interp);
        temp = Parrot_pmc_new(interp, enum_class_BigInt);
        VTABLE_set_integer_native(interp, temp, a);
        return VTABLE_add_int(interp, temp, b, dest);
    }
#line 267 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_clone(PARROT_INTERP, PMC *_self)
{
#line 121 "./src/pmc/integer.pmc"

    PMC * const clone = Parrot_pmc_new(interp, _self->vtable->base_type);
    VTABLE_set_integer_native(interp, clone, VTABLE_get_integer(interp, _self));
    return clone;
#line 277 "./src/pmc/integer.c"
}
static  INTVAL
Parrot_Integer_cmp(PARROT_INTERP, PMC *_self, PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_String:
            return Parrot_Integer_multi_cmp_String(interp, _self, value);
            break;

        case enum_class_Float:
            return Parrot_Integer_multi_cmp_Float(interp, _self, value);
            break;

        default:
            if (type < enum_class_core_max)
                return Parrot_Integer_multi_cmp_DEFAULT(interp, _self, value);
            else {
                INTVAL retval;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "cmp", "PP->I", _self, value, &retval);
                return retval;
            }
            break;

    }
}
static  INTVAL
Parrot_Integer_cmp_num(PARROT_INTERP, PMC *_self, PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_String:
            return Parrot_Integer_multi_cmp_num_String(interp, _self, value);
            break;

        case enum_class_Float:
            return Parrot_Integer_multi_cmp_num_Float(interp, _self, value);
            break;

        default:
            if (type < enum_class_core_max)
                return Parrot_Integer_multi_cmp_num_DEFAULT(interp, _self, value);
            else {
                INTVAL retval;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "cmp_num", "PP->I", _self, value, &retval);
                return retval;
            }
            break;

    }
}
static  void 
Parrot_Integer_decrement(PARROT_INTERP, PMC *_self)
{
#line 1161 "./src/pmc/integer.pmc"

    const INTVAL a = VTABLE_get_integer(interp, _self);
    const INTVAL c = a - 1;

    if ((c^a) >= 0 || (c^~1) >= 0)
        VTABLE_set_integer_native(interp, _self, c);
    else {
        Parrot_pmc_reuse(interp, _self, enum_class_BigInt, 0);
        VTABLE_set_integer_native(interp, _self, a);
        VTABLE_decrement(interp, _self);
    }
#line 350 "./src/pmc/integer.c"
}
static  PMC *
Parrot_Integer_divide(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigInt:
            return Parrot_Integer_multi_divide_BigInt_PMC(interp, _self, value, dest);
            break;

        default:
            if (type < enum_class_core_max)
                return Parrot_Integer_multi_divide_DEFAULT_PMC(interp, _self, value, dest);
            else {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "divide", "PPP->P", _self, value, dest, &retval);
                return retval;
            }
            break;

    }
}
static  PMC *
Parrot_Integer_floor_divide(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigInt:
            return Parrot_Integer_multi_floor_divide_BigInt_PMC(interp, _self, value, dest);
            break;

        default:
            if (type < enum_class_core_max)
                return Parrot_Integer_multi_floor_divide_DEFAULT_PMC(interp, _self, value, dest);
            else {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "floor_divide", "PPP->P", _self, value, dest, &retval);
                return retval;
            }
            break;

    }
}
static  PMC  *
Parrot_Integer_floor_divide_float(PARROT_INTERP, PMC *_self, FLOATVAL value, PMC *dest)
{
#line 844 "./src/pmc/integer.pmc"

    FLOATVAL f;

    if (FLOAT_IS_ZERO(value))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "float division by zero");

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    f = floor(VTABLE_get_number(interp, _self) / value);
    VTABLE_set_integer_native(interp, dest, (INTVAL)f);

    return dest;
#line 417 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_floor_divide_int(PARROT_INTERP, PMC *_self, INTVAL value, PMC *dest)
{
#line 829 "./src/pmc/integer.pmc"

    FLOATVAL f;

    if (value == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "float division by zero");

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    f = floor(VTABLE_get_number(interp, _self) / value);
    VTABLE_set_integer_native(interp, dest, (INTVAL)f);

    return dest;
#line 436 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_freeze(PARROT_INTERP, PMC *_self, PMC *info)
{
#line 1241 "./src/pmc/integer.pmc"

    interp->vtables[enum_class_default]->freeze(interp, _self, info);
    VTABLE_push_integer(interp, info, VTABLE_get_integer(interp, _self));
#line 445 "./src/pmc/integer.c"
}
static  INTVAL 
Parrot_Integer_get_bool(PARROT_INTERP, PMC *_self)
{
#line 192 "./src/pmc/integer.pmc"

    INTVAL iv;
    GETATTR_Integer_iv(interp, _self, iv);
    return iv ? 1 : 0;
#line 455 "./src/pmc/integer.c"
}
static  INTVAL 
Parrot_Integer_get_integer(PARROT_INTERP, PMC *_self)
{
#line 176 "./src/pmc/integer.pmc"

    INTVAL iv;
    GETATTR_Integer_iv(interp, _self, iv);
    return iv;
#line 465 "./src/pmc/integer.c"
}
static  FLOATVAL 
Parrot_Integer_get_number(PARROT_INTERP, PMC *_self)
{
#line 208 "./src/pmc/integer.pmc"

    INTVAL iv;
    GETATTR_Integer_iv(interp, _self, iv);
    return (FLOATVAL)iv;
#line 475 "./src/pmc/integer.c"
}
static  STRING  *
Parrot_Integer_get_repr(PARROT_INTERP, PMC *_self)
{
#line 230 "./src/pmc/integer.pmc"

    return Parrot_str_from_int(interp, VTABLE_get_integer(interp, _self));
#line 483 "./src/pmc/integer.c"
}
static  STRING  *
Parrot_Integer_get_string(PARROT_INTERP, PMC *_self)
{
#line 226 "./src/pmc/integer.pmc"

    return Parrot_str_from_int(interp, VTABLE_get_integer(interp, _self));
#line 491 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_i_absolute(PARROT_INTERP, PMC *_self)
{
#line 1199 "./src/pmc/integer.pmc"

    const INTVAL a = abs(VTABLE_get_integer(interp, _self));
    VTABLE_set_integer_native(interp, _self, a);
#line 500 "./src/pmc/integer.c"
}
static  void
Parrot_Integer_i_add(PARROT_INTERP, PMC *_self, PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_Integer:
            Parrot_Integer_multi_i_add_Integer(interp, _self, value);
            break;

        case enum_class_Complex:
            Parrot_Integer_multi_i_add_Complex(interp, _self, value);
            break;

        default:
            if (type < enum_class_core_max)
                Parrot_Integer_multi_i_add_DEFAULT(interp, _self, value);
            else {
                
                Parrot_mmd_multi_dispatch_from_c_args(interp, "i_add", "PP->", _self, value);
                return;
            }
            break;

    }
}
static  void 
Parrot_Integer_i_add_float(PARROT_INTERP, PMC *_self, FLOATVAL value)
{
#line 419 "./src/pmc/integer.pmc"

    const INTVAL a = VTABLE_get_integer(interp, _self);
    VTABLE_set_number_native(interp, _self, a + value);
#line 537 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_i_add_int(PARROT_INTERP, PMC *_self, INTVAL b)
{
#line 405 "./src/pmc/integer.pmc"

    const INTVAL a = VTABLE_get_integer(interp, _self);
    const INTVAL c = a + b;

    if ((c^a) >= 0 || (c^b) >= 0)
        VTABLE_set_integer_native(interp, _self, c);
    else {
        maybe_throw_overflow_error(interp);
        _self = upgrade_self_to_bignum(interp, _self);
        VTABLE_i_add_int(interp, _self, b);
    }
#line 554 "./src/pmc/integer.c"
}
static  void
Parrot_Integer_i_divide(PARROT_INTERP, PMC *_self, PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigInt:
            Parrot_Integer_multi_i_divide_BigInt(interp, _self, value);
            break;

        default:
            if (type < enum_class_core_max)
                Parrot_Integer_multi_i_divide_DEFAULT(interp, _self, value);
            else {
                
                Parrot_mmd_multi_dispatch_from_c_args(interp, "i_divide", "PP->", _self, value);
                return;
            }
            break;

    }
}
static  void
Parrot_Integer_i_floor_divide(PARROT_INTERP, PMC *_self, PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigInt:
            Parrot_Integer_multi_i_floor_divide_BigInt(interp, _self, value);
            break;

        default:
            if (type < enum_class_core_max)
                Parrot_Integer_multi_i_floor_divide_DEFAULT(interp, _self, value);
            else {
                
                Parrot_mmd_multi_dispatch_from_c_args(interp, "i_floor_divide", "PP->", _self, value);
                return;
            }
            break;

    }
}
static  void 
Parrot_Integer_i_floor_divide_float(PARROT_INTERP, PMC *_self, FLOATVAL value)
{
#line 890 "./src/pmc/integer.pmc"

    FLOATVAL f;

    if (FLOAT_IS_ZERO(value))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "float division by zero");

    f = floor(VTABLE_get_number(interp, _self) / value);
    VTABLE_set_integer_native(interp, _self, (INTVAL)f);
#line 617 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_i_floor_divide_int(PARROT_INTERP, PMC *_self, INTVAL value)
{
#line 878 "./src/pmc/integer.pmc"

    FLOATVAL f;

    if (value == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "float division by zero");

    f = floor(VTABLE_get_number(interp, _self) / value);
    VTABLE_set_integer_native(interp, _self, (INTVAL)f);
#line 632 "./src/pmc/integer.c"
}
static  void
Parrot_Integer_i_modulus(PARROT_INTERP, PMC *_self, PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigInt:
            Parrot_Integer_multi_i_modulus_BigInt(interp, _self, value);
            break;

        default:
            if (type < enum_class_core_max)
                Parrot_Integer_multi_i_modulus_DEFAULT(interp, _self, value);
            else {
                
                Parrot_mmd_multi_dispatch_from_c_args(interp, "i_modulus", "PP->", _self, value);
                return;
            }
            break;

    }
}
static  void 
Parrot_Integer_i_modulus_float(PARROT_INTERP, PMC *_self, FLOATVAL value)
{
#line 1005 "./src/pmc/integer.pmc"

    if (FLOAT_IS_ZERO(value))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "int modulus by zero");

    VTABLE_set_integer_native(interp, _self,
            intval_mod(VTABLE_get_integer(interp, _self) , (INTVAL)value));
#line 669 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_i_modulus_int(PARROT_INTERP, PMC *_self, INTVAL value)
{
#line 995 "./src/pmc/integer.pmc"

    if (value == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "int modulus by zero");

    VTABLE_set_integer_native(interp, _self,
            intval_mod(VTABLE_get_integer(interp, _self) , value));
#line 682 "./src/pmc/integer.c"
}
static  void
Parrot_Integer_i_multiply(PARROT_INTERP, PMC *_self, PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_Integer:
            Parrot_Integer_multi_i_multiply_Integer(interp, _self, value);
            break;

        case enum_class_BigInt:
            Parrot_Integer_multi_i_multiply_BigInt(interp, _self, value);
            break;

        case enum_class_Complex:
            Parrot_Integer_multi_i_multiply_Complex(interp, _self, value);
            break;

        default:
            if (type < enum_class_core_max)
                Parrot_Integer_multi_i_multiply_DEFAULT(interp, _self, value);
            else {
                
                Parrot_mmd_multi_dispatch_from_c_args(interp, "i_multiply", "PP->", _self, value);
                return;
            }
            break;

    }
}
static  void 
Parrot_Integer_i_multiply_float(PARROT_INTERP, PMC *_self, FLOATVAL value)
{
#line 715 "./src/pmc/integer.pmc"

    const INTVAL a = VTABLE_get_integer(interp, _self);
    VTABLE_set_number_native(interp, _self, a * value);
#line 723 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_i_multiply_int(PARROT_INTERP, PMC *_self, INTVAL b)
{
#line 700 "./src/pmc/integer.pmc"

    const INTVAL a  = VTABLE_get_integer(interp, _self);
    const INTVAL c  = a * b;
    const double cf = (double)a * (double)b;

    if ((double) c == cf)
        VTABLE_set_integer_native(interp, _self, c);
    else {
        maybe_throw_overflow_error(interp);
        upgrade_self_to_bignum(interp, _self);
        VTABLE_i_multiply_int(interp, _self, b);
    }
#line 741 "./src/pmc/integer.c"
}
static  void
Parrot_Integer_i_subtract(PARROT_INTERP, PMC *_self, PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_Integer:
            Parrot_Integer_multi_i_subtract_Integer(interp, _self, value);
            break;

        case enum_class_Complex:
            Parrot_Integer_multi_i_subtract_Complex(interp, _self, value);
            break;

        default:
            if (type < enum_class_core_max)
                Parrot_Integer_multi_i_subtract_DEFAULT(interp, _self, value);
            else {
                
                Parrot_mmd_multi_dispatch_from_c_args(interp, "i_subtract", "PP->", _self, value);
                return;
            }
            break;

    }
}
static  void 
Parrot_Integer_i_subtract_float(PARROT_INTERP, PMC *_self, FLOATVAL value)
{
#line 581 "./src/pmc/integer.pmc"

    const INTVAL a = VTABLE_get_integer(interp, _self);
    VTABLE_set_number_native(interp, _self, a - value);
#line 778 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_i_subtract_int(PARROT_INTERP, PMC *_self, INTVAL b)
{
#line 567 "./src/pmc/integer.pmc"

    const INTVAL a = VTABLE_get_integer(interp, _self);
    const INTVAL c = a - b;

    if ((c^a) >= 0 || (c^~b) >= 0)
        VTABLE_set_integer_native(interp, _self, c);
    else {
        maybe_throw_overflow_error(interp);
        _self = upgrade_self_to_bignum(interp, _self);
        VTABLE_i_subtract_int(interp, _self, b);
    }
#line 795 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_increment(PARROT_INTERP, PMC *_self)
{
#line 1135 "./src/pmc/integer.pmc"

    INTVAL a, c;
    GETATTR_Integer_iv(interp, _self, a);
    c = a + 1;

    /* did not overflow */
    if ((c^a) >= 0 || (c^1) >= 0)
        SETATTR_Integer_iv(interp, _self, c);
    else {
        Parrot_pmc_reuse(interp, _self, enum_class_BigInt, 0);
        VTABLE_set_integer_native(interp, _self, a);
        VTABLE_increment(interp, _self);
    }
#line 814 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_init(PARROT_INTERP, PMC *_self)
{
#line 91 "./src/pmc/integer.pmc"

    Parrot_Integer_attributes * const attrs =
        (Parrot_Integer_attributes *)PMC_data(_self);

    attrs->iv      = 0;
#line 825 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_init_int(PARROT_INTERP, PMC *_self, INTVAL init)
{
#line 105 "./src/pmc/integer.pmc"

    Parrot_Integer_attributes * const attrs =
        (Parrot_Integer_attributes *)PMC_data(_self);

    attrs->iv = init;
#line 836 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_init_pmc(PARROT_INTERP, PMC *_self, PMC *init)
{
#line 98 "./src/pmc/integer.pmc"

    Parrot_Integer_attributes * const attrs =
        (Parrot_Integer_attributes *)PMC_data(_self);

    attrs->iv      = VTABLE_get_integer(interp, init);
#line 847 "./src/pmc/integer.c"
}
static  INTVAL 
Parrot_Integer_is_equal(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 1024 "./src/pmc/integer.pmc"

    INTVAL retval;
    PMC *temp;

    switch (value->vtable->base_type) {
      case enum_class_BigInt:
        temp = Parrot_pmc_new(interp, enum_class_BigInt);
        VTABLE_set_integer_native(interp, temp, VTABLE_get_integer(interp, _self));
        Parrot_mmd_multi_dispatch_from_c_args(interp,
                "is_equal", "PP->I", temp, value, &retval);
        return retval;
        break;
      default:
        return (VTABLE_get_integer(interp, _self)
            ==  VTABLE_get_integer(interp, value));
        break;
    }
#line 870 "./src/pmc/integer.c"
}
static  PMC *
Parrot_Integer_modulus(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigInt:
            return Parrot_Integer_multi_modulus_BigInt_PMC(interp, _self, value, dest);
            break;

        default:
            if (type < enum_class_core_max)
                return Parrot_Integer_multi_modulus_DEFAULT_PMC(interp, _self, value, dest);
            else {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "modulus", "PPP->P", _self, value, dest, &retval);
                return retval;
            }
            break;

    }
}
static  PMC  *
Parrot_Integer_modulus_float(PARROT_INTERP, PMC *_self, FLOATVAL value, PMC *dest)
{
#line 963 "./src/pmc/integer.pmc"

    if (FLOAT_IS_ZERO(value))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "int modulus by zero");

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    VTABLE_set_integer_native(interp, dest,
            intval_mod(VTABLE_get_integer(interp, _self), (INTVAL)value));
    return dest;
#line 910 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_modulus_int(PARROT_INTERP, PMC *_self, INTVAL value, PMC *dest)
{
#line 950 "./src/pmc/integer.pmc"

    if (value == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "int modulus by zero");

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    VTABLE_set_integer_native(interp, dest,
            intval_mod(VTABLE_get_integer(interp, _self), value));
    return dest;
#line 926 "./src/pmc/integer.c"
}
static  PMC *
Parrot_Integer_multiply(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_Integer:
            return Parrot_Integer_multi_multiply_Integer_PMC(interp, _self, value, dest);
            break;

        case enum_class_Complex:
            return Parrot_Integer_multi_multiply_Complex_PMC(interp, _self, value, dest);
            break;

        case enum_class_BigInt:
            return Parrot_Integer_multi_multiply_BigInt_PMC(interp, _self, value, dest);
            break;

        case enum_class_String:
            return Parrot_Integer_multi_multiply_String_PMC(interp, _self, value, dest);
            break;

        default:
            if (type < enum_class_core_max)
                return Parrot_Integer_multi_multiply_DEFAULT_PMC(interp, _self, value, dest);
            else {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "multiply", "PPP->P", _self, value, dest, &retval);
                return retval;
            }
            break;

    }
}
static  PMC  *
Parrot_Integer_multiply_int(PARROT_INTERP, PMC *_self, INTVAL b, PMC *dest)
{
#line 645 "./src/pmc/integer.pmc"

    const INTVAL a  = VTABLE_get_integer(interp, _self);
    const INTVAL c  = a * b;
    const double cf = (double)a * (double)b;

    if ((double) c == cf) {
        dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

        VTABLE_set_integer_native(interp, dest, c);
        return dest;
    }
    else {
        PMC *temp;
        maybe_throw_overflow_error(interp);
        temp = Parrot_pmc_new(interp, enum_class_BigInt);
        VTABLE_set_integer_native(interp, temp, a);
        return VTABLE_multiply_int(interp, temp, b, dest);
    }
#line 986 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_set_bool(PARROT_INTERP, PMC *_self, INTVAL value)
{
#line 273 "./src/pmc/integer.pmc"

    Parrot_pmc_reuse(interp, _self, enum_class_Boolean, 0);
    VTABLE_set_bool(interp, _self, value);
#line 995 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_set_integer_native(PARROT_INTERP, PMC *_self, INTVAL value)
{
#line 245 "./src/pmc/integer.pmc"

    SETATTR_Integer_iv(interp, _self, value);
#line 1003 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_set_number_native(PARROT_INTERP, PMC *_self, FLOATVAL value)
{
#line 267 "./src/pmc/integer.pmc"

    Parrot_pmc_reuse(interp, _self, enum_class_Float, 0);
    VTABLE_set_number_native(interp, _self, value);
#line 1012 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_set_pmc(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 137 "./src/pmc/integer.pmc"

    VTABLE_set_integer_native(interp, _self, VTABLE_get_integer(interp, value));
#line 1020 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_set_string_native(PARROT_INTERP, PMC *_self, STRING *value)
{
#line 280 "./src/pmc/integer.pmc"

    Parrot_pmc_reuse(interp, _self, enum_class_String, 0);
    VTABLE_set_string_native(interp, _self, value);
#line 1029 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_share(PARROT_INTERP, PMC *_self)
{
#line 152 "./src/pmc/integer.pmc"

    /*
     * assume that the access to a long is atomic.
     * integers are most often (1) equal to C longs,
     * not C ints, and this makes a difference in 64-bit
     * platforms where longs are 64-bit but ints are 32-bit.
     * (1) Not equal when integers have been configured
     *     to be software-emulated long longs.
     */
    if (sizeof (INTVAL) != sizeof (long))
        interp->vtables[enum_class_default]->share(interp, _self);
#line 1046 "./src/pmc/integer.c"
}
static  PMC *
Parrot_Integer_subtract(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_Integer:
            return Parrot_Integer_multi_subtract_Integer_PMC(interp, _self, value, dest);
            break;

        case enum_class_Complex:
            return Parrot_Integer_multi_subtract_Complex_PMC(interp, _self, value, dest);
            break;

        case enum_class_BigInt:
            return Parrot_Integer_multi_subtract_BigInt_PMC(interp, _self, value, dest);
            break;

        default:
            if (type < enum_class_core_max)
                return Parrot_Integer_multi_subtract_DEFAULT_PMC(interp, _self, value, dest);
            else {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "subtract", "PPP->P", _self, value, dest, &retval);
                return retval;
            }
            break;

    }
}
static  PMC  *
Parrot_Integer_subtract_int(PARROT_INTERP, PMC *_self, INTVAL b, PMC *dest)
{
#line 501 "./src/pmc/integer.pmc"

    const INTVAL a = VTABLE_get_integer(interp, _self);
    const INTVAL c = a - b;

    if ((c^a) >= 0 || (c^~b) >= 0) {
        dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

        VTABLE_set_integer_native(interp, dest, c);
        return dest;
    }
    else {
        PMC *temp;
        maybe_throw_overflow_error(interp);
        temp = Parrot_pmc_new(interp, enum_class_BigInt);
        VTABLE_set_integer_native(interp, temp, a);
        return VTABLE_subtract_int(interp, temp, b, dest);
    }
#line 1101 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_thaw(PARROT_INTERP, PMC *_self, PMC *info)
{
#line 1256 "./src/pmc/integer.pmc"

    interp->vtables[enum_class_default]->thaw(interp, _self, info);
    VTABLE_set_integer_native(interp, _self, VTABLE_shift_integer(interp, info));
#line 1110 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_add_Integer_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest)
{
#line 297 "./src/pmc/integer.pmc"

    const INTVAL a = _self->vtable->get_integer(interp, _self);
    const INTVAL b = VTABLE_get_integer(interp, value);
    const INTVAL c = a + b;

    if ((c^a) >= 0 || (c^b) >= 0) {
        dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

        /* need this for e.g. Undef PMC */
        VTABLE_set_integer_native(interp, dest, c);
        return dest;
    }
    else {
        PMC * temp;
        maybe_throw_overflow_error(interp);
        temp = Parrot_pmc_new(interp, enum_class_BigInt);
        VTABLE_set_integer_native(interp, temp, a);
        return VTABLE_add(interp, temp, value, dest);
    }
#line 1135 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_add_Complex_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest)
{
#line 319 "./src/pmc/integer.pmc"

    const INTVAL a = _self->vtable->get_integer(interp, _self);
    dest           = Parrot_pmc_new(interp, VTABLE_type(interp, value));

    VTABLE_set_number_native(interp, dest,
            a + VTABLE_get_number_keyed_int(interp, value, 0));
    VTABLE_set_number_keyed_int(interp, dest, 1,
            VTABLE_get_number_keyed_int(interp, value, 1));

    return dest;
#line 1151 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_add_BigInt_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest)
{
#line 332 "./src/pmc/integer.pmc"

    PMC *temp;
    maybe_throw_overflow_error(interp);
    temp = Parrot_pmc_new(interp, enum_class_BigInt);
    VTABLE_set_integer_native(interp, temp, _self->vtable->get_integer(interp, _self));
    return VTABLE_add(interp, temp, value, dest);
#line 1163 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_add_DEFAULT_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest)
{
#line 341 "./src/pmc/integer.pmc"

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, value));

    VTABLE_set_number_native(interp, dest,
            _self->vtable->get_integer(interp, _self) + VTABLE_get_number(interp, value));
    return dest;
#line 1175 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_multi_i_add_Integer(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 384 "./src/pmc/integer.pmc"

    Parrot_Integer_i_add_int(interp, _self, VTABLE_get_integer(interp, value));
#line 1183 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_multi_i_add_Complex(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 389 "./src/pmc/integer.pmc"

    const INTVAL a = _self->vtable->get_integer(interp, _self);
    UNUSED(a);

    Parrot_pmc_reuse(interp, _self, enum_class_Complex, 0);
    VTABLE_set_number_native(interp, _self,
            _self->vtable->get_integer(interp, _self) + VTABLE_get_number(interp, value));
#line 1196 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_multi_i_add_DEFAULT(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 399 "./src/pmc/integer.pmc"

    VTABLE_set_number_native(interp, _self,
            _self->vtable->get_integer(interp, _self) + VTABLE_get_number(interp, value));
#line 1205 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_subtract_Integer_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest)
{
#line 439 "./src/pmc/integer.pmc"

    const INTVAL a = _self->vtable->get_integer(interp, _self);
    const INTVAL b = VTABLE_get_integer(interp, value);
    const INTVAL c = a - b;

    if ((c^a) >= 0 || (c^~b) >= 0) {
        dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

        VTABLE_set_integer_native(interp, dest, c);
        return dest;
    }
    else {
        PMC *temp;
        maybe_throw_overflow_error(interp);
        temp = Parrot_pmc_new(interp, enum_class_BigInt);
        VTABLE_set_integer_native(interp, temp, a);
        return VTABLE_subtract(interp, temp, value, dest);
    }
#line 1229 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_subtract_Complex_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest)
{
#line 460 "./src/pmc/integer.pmc"

    const INTVAL a = _self->vtable->get_integer(interp, _self);
    dest           = Parrot_pmc_new(interp, VTABLE_type(interp, value));

    VTABLE_set_number_native(interp, dest,
            a - VTABLE_get_number_keyed_int(interp, value, 0));
    VTABLE_set_number_keyed_int(interp, dest, 1,
            -VTABLE_get_number_keyed_int(interp, value, 1));

    return dest;
#line 1245 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_subtract_BigInt_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest)
{
#line 473 "./src/pmc/integer.pmc"

    PMC *temp;
    maybe_throw_overflow_error(interp);
    temp = Parrot_pmc_new(interp, enum_class_BigInt);
    VTABLE_set_integer_native(interp, temp, _self->vtable->get_integer(interp, _self));
    return VTABLE_subtract(interp, temp, value, dest);
#line 1257 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_subtract_DEFAULT_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest)
{
#line 482 "./src/pmc/integer.pmc"

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, value));

    VTABLE_set_number_native(interp, dest,
            _self->vtable->get_integer(interp, _self) - VTABLE_get_number(interp, value));
    return dest;
#line 1269 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_multi_i_subtract_Integer(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 535 "./src/pmc/integer.pmc"

    const INTVAL a = _self->vtable->get_integer(interp, _self);
    const INTVAL b = VTABLE_get_integer(interp, value);
    const INTVAL c = a - b;

    if ((c^a) >= 0 || (c^~b) >= 0)
        VTABLE_set_integer_native(interp, _self, c);
    else {
        maybe_throw_overflow_error(interp);
        _self = upgrade_self_to_bignum(interp, _self);
        VTABLE_i_subtract(interp, _self, value);
    }
#line 1287 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_multi_i_subtract_Complex(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 550 "./src/pmc/integer.pmc"

    const INTVAL a = _self->vtable->get_integer(interp, _self);

    Parrot_pmc_reuse(interp, _self, enum_class_Complex, 0);
    VTABLE_set_number_native(interp, _self,
            (FLOATVAL)a - VTABLE_get_number_keyed_int(interp, value, 0));
    VTABLE_set_number_keyed_int(interp, _self, 1,
            -VTABLE_get_number_keyed_int(interp, value, 1));
#line 1301 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_multi_i_subtract_DEFAULT(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 561 "./src/pmc/integer.pmc"

    VTABLE_set_number_native(interp, _self,
            _self->vtable->get_integer(interp, _self) - VTABLE_get_number(interp, value));
#line 1310 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_multiply_Integer_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest)
{
#line 599 "./src/pmc/integer.pmc"

    const INTVAL a  = VTABLE_get_integer(interp, _self);
    const INTVAL b  = VTABLE_get_integer(interp, value);
    const INTVAL c  = a * b;
    const double cf = (double)a * (double)b;

    if ((double) c == cf) {
        dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

        VTABLE_set_integer_native(interp, dest, c);
        return dest;
    }
    else {
        PMC *temp;
        maybe_throw_overflow_error(interp);
        temp = Parrot_pmc_new(interp, enum_class_BigInt);
        VTABLE_set_integer_native(interp, temp, a);
        return VTABLE_multiply(interp, temp, value, dest);
    }
#line 1335 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_multiply_Complex_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest)
{
#line 621 "./src/pmc/integer.pmc"

    return VTABLE_multiply(interp, value, _self, dest);
#line 1343 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_multiply_BigInt_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest)
{
#line 626 "./src/pmc/integer.pmc"

    return VTABLE_multiply_int(interp, value, _self->vtable->get_integer(interp, _self), dest);
#line 1351 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_multiply_String_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest)
{
#line 631 "./src/pmc/integer.pmc"

    return Parrot_Integer_multi_multiply_Integer_PMC(interp, _self, value, dest);
#line 1359 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_multiply_DEFAULT_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest)
{
#line 636 "./src/pmc/integer.pmc"

    const FLOATVAL valf = VTABLE_get_number(interp, value);
    dest                = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    VTABLE_set_number_native(interp, dest, _self->vtable->get_number(interp, _self) * valf);
    return dest;
#line 1371 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_multi_i_multiply_Integer(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 679 "./src/pmc/integer.pmc"

    Parrot_Integer_i_multiply_int(interp, _self, VTABLE_get_integer(interp, value));
#line 1379 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_multi_i_multiply_BigInt(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 684 "./src/pmc/integer.pmc"

    interp->vtables[enum_class_BigInt]->multiply_int(interp, value, _self->vtable->get_integer(interp, _self), _self);
#line 1387 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_multi_i_multiply_Complex(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 689 "./src/pmc/integer.pmc"

    VTABLE_multiply(interp, value, _self, _self);
#line 1395 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_multi_i_multiply_DEFAULT(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 694 "./src/pmc/integer.pmc"

    VTABLE_set_number_native(interp, _self,
            _self->vtable->get_integer(interp, _self) * VTABLE_get_number(interp, value));
#line 1404 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_divide_BigInt_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest)
{
#line 743 "./src/pmc/integer.pmc"

    PMC *temp;
    maybe_throw_overflow_error(interp);
    temp = Parrot_pmc_new(interp, enum_class_BigInt);
    VTABLE_set_integer_native(interp, temp, _self->vtable->get_integer(interp, _self));
    return VTABLE_divide(interp, temp, value, dest);
#line 1416 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_divide_DEFAULT_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest)
{
#line 751 "./src/pmc/integer.pmc"

    const FLOATVAL d = VTABLE_get_number(interp, value);

    if (FLOAT_IS_ZERO(d))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "float division by zero");

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    VTABLE_set_number_native(interp, dest, _self->vtable->get_number(interp, _self) / d);
    return dest;
#line 1432 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_multi_i_divide_BigInt(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 764 "./src/pmc/integer.pmc"

    maybe_throw_overflow_error(interp);
    _self = upgrade_self_to_bignum(interp, _self);
    VTABLE_i_divide(interp, _self, value);
#line 1442 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_multi_i_divide_DEFAULT(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 771 "./src/pmc/integer.pmc"

    const FLOATVAL d = VTABLE_get_number(interp, value);

    if (FLOAT_IS_ZERO(d))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "float division by zero");

    VTABLE_set_number_native(interp, _self, _self->vtable->get_number(interp, _self) / d);
#line 1456 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_floor_divide_BigInt_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest)
{
#line 804 "./src/pmc/integer.pmc"

    PMC *temp;
    maybe_throw_overflow_error(interp);
    temp = Parrot_pmc_new(interp, enum_class_BigInt);
    VTABLE_set_integer_native(interp, temp, _self->vtable->get_integer(interp, _self));
    return VTABLE_floor_divide(interp, temp, value, dest);
#line 1468 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_floor_divide_DEFAULT_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest)
{
#line 813 "./src/pmc/integer.pmc"

    const FLOATVAL d = VTABLE_get_number(interp, value);
    FLOATVAL f;

    if (FLOAT_IS_ZERO(d))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "float division by zero");

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    f = floor(_self->vtable->get_number(interp, _self) / d);
    VTABLE_set_integer_native(interp, dest, (INTVAL)f);
    return dest;
#line 1487 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_multi_i_floor_divide_BigInt(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 859 "./src/pmc/integer.pmc"

    maybe_throw_overflow_error(interp);
    _self = upgrade_self_to_bignum(interp, _self);
    VTABLE_i_floor_divide(interp, _self, value);
#line 1497 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_multi_i_floor_divide_DEFAULT(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 865 "./src/pmc/integer.pmc"

    const FLOATVAL d = VTABLE_get_number(interp, value);
    FLOATVAL f;

    if (FLOAT_IS_ZERO(d))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "float division by zero");

    f = floor(_self->vtable->get_number(interp, _self) / d);
    VTABLE_set_integer_native(interp, _self, (INTVAL)f);
#line 1513 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_modulus_BigInt_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest)
{
#line 926 "./src/pmc/integer.pmc"

    PMC *temp;
    maybe_throw_overflow_error(interp);
    temp = Parrot_pmc_new(interp, enum_class_BigInt);
    VTABLE_set_integer_native(interp, temp, _self->vtable->get_integer(interp, _self));
    return VTABLE_modulus(interp, temp, value, dest);
#line 1525 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_modulus_DEFAULT_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest)
{
#line 935 "./src/pmc/integer.pmc"

    const INTVAL d = VTABLE_get_integer(interp, value);

    if (d == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "int modulus by zero");

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    VTABLE_set_integer_native(interp, dest,
            intval_mod(_self->vtable->get_integer(interp, _self), d));
    return dest;
#line 1543 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_multi_i_modulus_BigInt(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 976 "./src/pmc/integer.pmc"

    maybe_throw_overflow_error(interp);
    _self = upgrade_self_to_bignum(interp, _self);
    VTABLE_i_modulus(interp, _self, value);
#line 1553 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_multi_i_modulus_DEFAULT(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 983 "./src/pmc/integer.pmc"

    const INTVAL d = VTABLE_get_integer(interp, value);

    if (d == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "int modulus by zero");

    VTABLE_set_integer_native(interp, _self,
            intval_mod(_self->vtable->get_integer(interp, _self), d));
#line 1568 "./src/pmc/integer.c"
}
static  INTVAL 
Parrot_Integer_multi_cmp_String(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 1054 "./src/pmc/integer.pmc"

    const FLOATVAL fdiff = _self->vtable->get_number(interp, _self) - VTABLE_get_number(interp, value);

    if (FLOAT_IS_ZERO(fdiff)) {
        const INTVAL idiff =
            _self->vtable->get_integer(interp, _self) - VTABLE_get_integer(interp, value);
        return idiff > 0 ? 1 : idiff < 0 ? -1 : 0;
    }

    return fdiff > 0 ? 1 : -1;
#line 1584 "./src/pmc/integer.c"
}
static  INTVAL 
Parrot_Integer_multi_cmp_Float(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 1067 "./src/pmc/integer.pmc"

    INTVAL iv;
    GETATTR_Integer_iv(interp, _self, iv);

    {
        const FLOATVAL diff = (FLOATVAL)iv - VTABLE_get_number(interp, value);
        return diff > 0 ? 1 : diff < 0 ? -1 : 0;
    }
#line 1598 "./src/pmc/integer.c"
}
static  INTVAL 
Parrot_Integer_multi_cmp_DEFAULT(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 1078 "./src/pmc/integer.pmc"

    /* int or undef */
    INTVAL selfint;
    GETATTR_Integer_iv(interp, _self, selfint);
    {
        const INTVAL valueint = VTABLE_get_integer(interp, value);
        return selfint > valueint ? 1 : selfint < valueint ? -1 : 0;
    }
#line 1612 "./src/pmc/integer.c"
}
static  INTVAL 
Parrot_Integer_multi_cmp_num_String(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 1099 "./src/pmc/integer.pmc"

    const FLOATVAL fdiff = _self->vtable->get_number(interp, _self) - VTABLE_get_number(interp, value);

    if (FLOAT_IS_ZERO(fdiff)) {
        const INTVAL idiff =
            _self->vtable->get_integer(interp, _self) - VTABLE_get_integer(interp, value);
        return idiff > 0 ? 1 : idiff < 0 ? -1 : 0;
    }

    return fdiff > 0 ? 1 : -1;
#line 1628 "./src/pmc/integer.c"
}
static  INTVAL 
Parrot_Integer_multi_cmp_num_Float(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 1112 "./src/pmc/integer.pmc"

    const FLOATVAL diff = _self->vtable->get_number(interp, _self) - VTABLE_get_number(interp, value);
    return diff > 0 ? 1 : diff < 0 ? -1 : 0;
#line 1637 "./src/pmc/integer.c"
}
static  INTVAL 
Parrot_Integer_multi_cmp_num_DEFAULT(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 1118 "./src/pmc/integer.pmc"

    /* int or undef */
    const INTVAL diff = _self->vtable->get_integer(interp, _self) - VTABLE_get_integer(interp, value);
    return diff > 0 ? 1 : diff < 0 ? -1 : 0;
#line 1647 "./src/pmc/integer.c"
}
static  void
Parrot_Integer_nci_get_as_base(PARROT_INTERP, PMC *_self)
{
#line 422 "/home/mandrake/rpm/BUILD/parrot-2.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 1659 "./src/pmc/integer.pmc"
PMC* _self;
INTVAL base;

#line 430 "/home/mandrake/rpm/BUILD/parrot-2.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiI",
            &_self, &base);
#line 434 "/home/mandrake/rpm/BUILD/parrot-2.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 1216 "./src/pmc/integer.pmc"

    char buf[128];
    STRING *result;

    if ((base < 2) || (base > 36))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
            "get_as_base: base out of bounds");

    result = Parrot_str_from_int_base(interp, buf,
            (HUGEINTVAL)VTABLE_get_integer(interp, _self),
            (unsigned int)base);

    #line 260 "/home/mandrake/rpm/BUILD/parrot-2.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *result */
#line 267 "/home/mandrake/rpm/BUILD/parrot-2.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "S", (STRING*)result);
    return;
    /*END RETURN STRING *result */
    }
#line 1228 "./src/pmc/integer.pmc"

#line 441 "/home/mandrake/rpm/BUILD/parrot-2.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 1697 "./src/pmc/integer.c"
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_Integer_update_vtable(VTABLE *vt) {
    vt->absolute = Parrot_Integer_absolute;
    vt->add = Parrot_Integer_add;
    vt->add_int = Parrot_Integer_add_int;
    vt->clone = Parrot_Integer_clone;
    vt->cmp = Parrot_Integer_cmp;
    vt->cmp_num = Parrot_Integer_cmp_num;
    vt->decrement = Parrot_Integer_decrement;
    vt->divide = Parrot_Integer_divide;
    vt->floor_divide = Parrot_Integer_floor_divide;
    vt->floor_divide_float = Parrot_Integer_floor_divide_float;
    vt->floor_divide_int = Parrot_Integer_floor_divide_int;
    vt->freeze = Parrot_Integer_freeze;
    vt->get_bool = Parrot_Integer_get_bool;
    vt->get_integer = Parrot_Integer_get_integer;
    vt->get_number = Parrot_Integer_get_number;
    vt->get_repr = Parrot_Integer_get_repr;
    vt->get_string = Parrot_Integer_get_string;
    vt->i_absolute = Parrot_Integer_i_absolute;
    vt->i_add = Parrot_Integer_i_add;
    vt->i_add_float = Parrot_Integer_i_add_float;
    vt->i_add_int = Parrot_Integer_i_add_int;
    vt->i_divide = Parrot_Integer_i_divide;
    vt->i_floor_divide = Parrot_Integer_i_floor_divide;
    vt->i_floor_divide_float = Parrot_Integer_i_floor_divide_float;
    vt->i_floor_divide_int = Parrot_Integer_i_floor_divide_int;
    vt->i_modulus = Parrot_Integer_i_modulus;
    vt->i_modulus_float = Parrot_Integer_i_modulus_float;
    vt->i_modulus_int = Parrot_Integer_i_modulus_int;
    vt->i_multiply = Parrot_Integer_i_multiply;
    vt->i_multiply_float = Parrot_Integer_i_multiply_float;
    vt->i_multiply_int = Parrot_Integer_i_multiply_int;
    vt->i_subtract = Parrot_Integer_i_subtract;
    vt->i_subtract_float = Parrot_Integer_i_subtract_float;
    vt->i_subtract_int = Parrot_Integer_i_subtract_int;
    vt->increment = Parrot_Integer_increment;
    vt->init = Parrot_Integer_init;
    vt->init_int = Parrot_Integer_init_int;
    vt->init_pmc = Parrot_Integer_init_pmc;
    vt->is_equal = Parrot_Integer_is_equal;
    vt->modulus = Parrot_Integer_modulus;
    vt->modulus_float = Parrot_Integer_modulus_float;
    vt->modulus_int = Parrot_Integer_modulus_int;
    vt->multiply = Parrot_Integer_multiply;
    vt->multiply_int = Parrot_Integer_multiply_int;
    vt->set_bool = Parrot_Integer_set_bool;
    vt->set_integer_native = Parrot_Integer_set_integer_native;
    vt->set_number_native = Parrot_Integer_set_number_native;
    vt->set_pmc = Parrot_Integer_set_pmc;
    vt->set_string_native = Parrot_Integer_set_string_native;
    vt->share = Parrot_Integer_share;
    vt->subtract = Parrot_Integer_subtract;
    vt->subtract_int = Parrot_Integer_subtract_int;
    vt->thaw = Parrot_Integer_thaw;
    vt->attr_size = sizeof(Parrot_Integer_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_Integer_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->absolute = Parrot_Integer_absolute;
    vt->add = Parrot_Integer_add;
    vt->add_int = Parrot_Integer_add_int;
    vt->clone = Parrot_Integer_clone;
    vt->cmp = Parrot_Integer_cmp;
    vt->cmp_num = Parrot_Integer_cmp_num;
    vt->divide = Parrot_Integer_divide;
    vt->floor_divide = Parrot_Integer_floor_divide;
    vt->floor_divide_float = Parrot_Integer_floor_divide_float;
    vt->floor_divide_int = Parrot_Integer_floor_divide_int;
    vt->freeze = Parrot_Integer_freeze;
    vt->get_bool = Parrot_Integer_get_bool;
    vt->get_integer = Parrot_Integer_get_integer;
    vt->get_number = Parrot_Integer_get_number;
    vt->get_repr = Parrot_Integer_get_repr;
    vt->get_string = Parrot_Integer_get_string;
    vt->init = Parrot_Integer_init;
    vt->init_int = Parrot_Integer_init_int;
    vt->init_pmc = Parrot_Integer_init_pmc;
    vt->is_equal = Parrot_Integer_is_equal;
    vt->modulus = Parrot_Integer_modulus;
    vt->modulus_float = Parrot_Integer_modulus_float;
    vt->modulus_int = Parrot_Integer_modulus_int;
    vt->multiply = Parrot_Integer_multiply;
    vt->multiply_int = Parrot_Integer_multiply_int;
    vt->share = Parrot_Integer_share;
    vt->subtract = Parrot_Integer_subtract;
    vt->subtract_int = Parrot_Integer_subtract_int;
    vt->attr_size = sizeof(Parrot_Integer_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Integer_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_scalar_get_vtable(interp);
    Parrot_Integer_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Integer_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_scalar_ro_get_vtable(interp);
    Parrot_Integer_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_Integer_get_mro(PARROT_INTERP, PMC* mro) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }
    mro = Parrot_scalar_get_mro(interp, mro);

    VTABLE_unshift_string(interp, mro,
        string_make(interp, "Integer", 7, NULL, 0));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_Integer_get_isa(PARROT_INTERP, Hash* isa) {
    isa = Parrot_scalar_get_isa(interp, isa);
    parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "Integer")), PMCNULL);
    return isa;
}

void
Parrot_Integer_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "Iiv ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_Integer_get_vtable(interp);
        vt->base_type      = enum_class_Integer;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "Integer");
        vt->provides_str = CONST_STRING_GEN(interp, "scalar integer");
        vt->isa_hash     = Parrot_Integer_get_isa(interp, NULL);
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_Integer_ro_get_vtable(interp);
            vt_ro->base_type      = enum_class_Integer;
            vt_ro->flags          = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_Integer_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_Integer_nci_get_as_base), CONST_STRING_GEN(interp, "get_as_base"));
        {
            STRING * const mfl_0 = CONST_STRING_GEN(interp, "add");
            STRING * const mfl_1 = CONST_STRING_GEN(interp, "PJPPP");
            STRING * const mfl_2 = CONST_STRING_GEN(interp, "Integer,Integer,PMC");
            STRING * const mfl_3 = CONST_STRING_GEN(interp, "Integer");
            STRING * const mfl_4 = CONST_STRING_GEN(interp, "Integer,Complex,PMC");
            STRING * const mfl_5 = CONST_STRING_GEN(interp, "Integer,BigInt,PMC");
            STRING * const mfl_6 = CONST_STRING_GEN(interp, "Integer,DEFAULT,PMC");
            STRING * const mfl_7 = CONST_STRING_GEN(interp, "i_add");
            STRING * const mfl_8 = CONST_STRING_GEN(interp, "vJPP");
            STRING * const mfl_9 = CONST_STRING_GEN(interp, "Integer,Integer");
            STRING * const mfl_10 = CONST_STRING_GEN(interp, "Integer,Complex");
            STRING * const mfl_11 = CONST_STRING_GEN(interp, "Integer,DEFAULT");
            STRING * const mfl_12 = CONST_STRING_GEN(interp, "subtract");
            STRING * const mfl_13 = CONST_STRING_GEN(interp, "i_subtract");
            STRING * const mfl_14 = CONST_STRING_GEN(interp, "multiply");
            STRING * const mfl_15 = CONST_STRING_GEN(interp, "Integer,String,PMC");
            STRING * const mfl_16 = CONST_STRING_GEN(interp, "i_multiply");
            STRING * const mfl_17 = CONST_STRING_GEN(interp, "Integer,BigInt");
            STRING * const mfl_18 = CONST_STRING_GEN(interp, "divide");
            STRING * const mfl_19 = CONST_STRING_GEN(interp, "i_divide");
            STRING * const mfl_20 = CONST_STRING_GEN(interp, "floor_divide");
            STRING * const mfl_21 = CONST_STRING_GEN(interp, "i_floor_divide");
            STRING * const mfl_22 = CONST_STRING_GEN(interp, "modulus");
            STRING * const mfl_23 = CONST_STRING_GEN(interp, "i_modulus");
            STRING * const mfl_24 = CONST_STRING_GEN(interp, "cmp");
            STRING * const mfl_25 = CONST_STRING_GEN(interp, "IJPP");
            STRING * const mfl_26 = CONST_STRING_GEN(interp, "Integer,String");
            STRING * const mfl_27 = CONST_STRING_GEN(interp, "Integer,Float");
            STRING * const mfl_28 = CONST_STRING_GEN(interp, "cmp_num");

            multi_func_list _temp_multi_func_list[41];
            _temp_multi_func_list[0].multi_name = mfl_0;
            _temp_multi_func_list[0].short_sig = mfl_1;
            _temp_multi_func_list[0].full_sig = mfl_2;
            _temp_multi_func_list[0].ns_name = mfl_3;
            _temp_multi_func_list[0].func_ptr = (funcptr_t) Parrot_Integer_multi_add_Integer_PMC;

            _temp_multi_func_list[1].multi_name = mfl_0;
            _temp_multi_func_list[1].short_sig = mfl_1;
            _temp_multi_func_list[1].full_sig = mfl_4;
            _temp_multi_func_list[1].ns_name = mfl_3;
            _temp_multi_func_list[1].func_ptr = (funcptr_t) Parrot_Integer_multi_add_Complex_PMC;

            _temp_multi_func_list[2].multi_name = mfl_0;
            _temp_multi_func_list[2].short_sig = mfl_1;
            _temp_multi_func_list[2].full_sig = mfl_5;
            _temp_multi_func_list[2].ns_name = mfl_3;
            _temp_multi_func_list[2].func_ptr = (funcptr_t) Parrot_Integer_multi_add_BigInt_PMC;

            _temp_multi_func_list[3].multi_name = mfl_0;
            _temp_multi_func_list[3].short_sig = mfl_1;
            _temp_multi_func_list[3].full_sig = mfl_6;
            _temp_multi_func_list[3].ns_name = mfl_3;
            _temp_multi_func_list[3].func_ptr = (funcptr_t) Parrot_Integer_multi_add_DEFAULT_PMC;

            _temp_multi_func_list[4].multi_name = mfl_7;
            _temp_multi_func_list[4].short_sig = mfl_8;
            _temp_multi_func_list[4].full_sig = mfl_9;
            _temp_multi_func_list[4].ns_name = mfl_3;
            _temp_multi_func_list[4].func_ptr = (funcptr_t) Parrot_Integer_multi_i_add_Integer;

            _temp_multi_func_list[5].multi_name = mfl_7;
            _temp_multi_func_list[5].short_sig = mfl_8;
            _temp_multi_func_list[5].full_sig = mfl_10;
            _temp_multi_func_list[5].ns_name = mfl_3;
            _temp_multi_func_list[5].func_ptr = (funcptr_t) Parrot_Integer_multi_i_add_Complex;

            _temp_multi_func_list[6].multi_name = mfl_7;
            _temp_multi_func_list[6].short_sig = mfl_8;
            _temp_multi_func_list[6].full_sig = mfl_11;
            _temp_multi_func_list[6].ns_name = mfl_3;
            _temp_multi_func_list[6].func_ptr = (funcptr_t) Parrot_Integer_multi_i_add_DEFAULT;

            _temp_multi_func_list[7].multi_name = mfl_12;
            _temp_multi_func_list[7].short_sig = mfl_1;
            _temp_multi_func_list[7].full_sig = mfl_2;
            _temp_multi_func_list[7].ns_name = mfl_3;
            _temp_multi_func_list[7].func_ptr = (funcptr_t) Parrot_Integer_multi_subtract_Integer_PMC;

            _temp_multi_func_list[8].multi_name = mfl_12;
            _temp_multi_func_list[8].short_sig = mfl_1;
            _temp_multi_func_list[8].full_sig = mfl_4;
            _temp_multi_func_list[8].ns_name = mfl_3;
            _temp_multi_func_list[8].func_ptr = (funcptr_t) Parrot_Integer_multi_subtract_Complex_PMC;

            _temp_multi_func_list[9].multi_name = mfl_12;
            _temp_multi_func_list[9].short_sig = mfl_1;
            _temp_multi_func_list[9].full_sig = mfl_5;
            _temp_multi_func_list[9].ns_name = mfl_3;
            _temp_multi_func_list[9].func_ptr = (funcptr_t) Parrot_Integer_multi_subtract_BigInt_PMC;

            _temp_multi_func_list[10].multi_name = mfl_12;
            _temp_multi_func_list[10].short_sig = mfl_1;
            _temp_multi_func_list[10].full_sig = mfl_6;
            _temp_multi_func_list[10].ns_name = mfl_3;
            _temp_multi_func_list[10].func_ptr = (funcptr_t) Parrot_Integer_multi_subtract_DEFAULT_PMC;

            _temp_multi_func_list[11].multi_name = mfl_13;
            _temp_multi_func_list[11].short_sig = mfl_8;
            _temp_multi_func_list[11].full_sig = mfl_9;
            _temp_multi_func_list[11].ns_name = mfl_3;
            _temp_multi_func_list[11].func_ptr = (funcptr_t) Parrot_Integer_multi_i_subtract_Integer;

            _temp_multi_func_list[12].multi_name = mfl_13;
            _temp_multi_func_list[12].short_sig = mfl_8;
            _temp_multi_func_list[12].full_sig = mfl_10;
            _temp_multi_func_list[12].ns_name = mfl_3;
            _temp_multi_func_list[12].func_ptr = (funcptr_t) Parrot_Integer_multi_i_subtract_Complex;

            _temp_multi_func_list[13].multi_name = mfl_13;
            _temp_multi_func_list[13].short_sig = mfl_8;
            _temp_multi_func_list[13].full_sig = mfl_11;
            _temp_multi_func_list[13].ns_name = mfl_3;
            _temp_multi_func_list[13].func_ptr = (funcptr_t) Parrot_Integer_multi_i_subtract_DEFAULT;

            _temp_multi_func_list[14].multi_name = mfl_14;
            _temp_multi_func_list[14].short_sig = mfl_1;
            _temp_multi_func_list[14].full_sig = mfl_2;
            _temp_multi_func_list[14].ns_name = mfl_3;
            _temp_multi_func_list[14].func_ptr = (funcptr_t) Parrot_Integer_multi_multiply_Integer_PMC;

            _temp_multi_func_list[15].multi_name = mfl_14;
            _temp_multi_func_list[15].short_sig = mfl_1;
            _temp_multi_func_list[15].full_sig = mfl_4;
            _temp_multi_func_list[15].ns_name = mfl_3;
            _temp_multi_func_list[15].func_ptr = (funcptr_t) Parrot_Integer_multi_multiply_Complex_PMC;

            _temp_multi_func_list[16].multi_name = mfl_14;
            _temp_multi_func_list[16].short_sig = mfl_1;
            _temp_multi_func_list[16].full_sig = mfl_5;
            _temp_multi_func_list[16].ns_name = mfl_3;
            _temp_multi_func_list[16].func_ptr = (funcptr_t) Parrot_Integer_multi_multiply_BigInt_PMC;

            _temp_multi_func_list[17].multi_name = mfl_14;
            _temp_multi_func_list[17].short_sig = mfl_1;
            _temp_multi_func_list[17].full_sig = mfl_15;
            _temp_multi_func_list[17].ns_name = mfl_3;
            _temp_multi_func_list[17].func_ptr = (funcptr_t) Parrot_Integer_multi_multiply_String_PMC;

            _temp_multi_func_list[18].multi_name = mfl_14;
            _temp_multi_func_list[18].short_sig = mfl_1;
            _temp_multi_func_list[18].full_sig = mfl_6;
            _temp_multi_func_list[18].ns_name = mfl_3;
            _temp_multi_func_list[18].func_ptr = (funcptr_t) Parrot_Integer_multi_multiply_DEFAULT_PMC;

            _temp_multi_func_list[19].multi_name = mfl_16;
            _temp_multi_func_list[19].short_sig = mfl_8;
            _temp_multi_func_list[19].full_sig = mfl_9;
            _temp_multi_func_list[19].ns_name = mfl_3;
            _temp_multi_func_list[19].func_ptr = (funcptr_t) Parrot_Integer_multi_i_multiply_Integer;

            _temp_multi_func_list[20].multi_name = mfl_16;
            _temp_multi_func_list[20].short_sig = mfl_8;
            _temp_multi_func_list[20].full_sig = mfl_17;
            _temp_multi_func_list[20].ns_name = mfl_3;
            _temp_multi_func_list[20].func_ptr = (funcptr_t) Parrot_Integer_multi_i_multiply_BigInt;

            _temp_multi_func_list[21].multi_name = mfl_16;
            _temp_multi_func_list[21].short_sig = mfl_8;
            _temp_multi_func_list[21].full_sig = mfl_10;
            _temp_multi_func_list[21].ns_name = mfl_3;
            _temp_multi_func_list[21].func_ptr = (funcptr_t) Parrot_Integer_multi_i_multiply_Complex;

            _temp_multi_func_list[22].multi_name = mfl_16;
            _temp_multi_func_list[22].short_sig = mfl_8;
            _temp_multi_func_list[22].full_sig = mfl_11;
            _temp_multi_func_list[22].ns_name = mfl_3;
            _temp_multi_func_list[22].func_ptr = (funcptr_t) Parrot_Integer_multi_i_multiply_DEFAULT;

            _temp_multi_func_list[23].multi_name = mfl_18;
            _temp_multi_func_list[23].short_sig = mfl_1;
            _temp_multi_func_list[23].full_sig = mfl_5;
            _temp_multi_func_list[23].ns_name = mfl_3;
            _temp_multi_func_list[23].func_ptr = (funcptr_t) Parrot_Integer_multi_divide_BigInt_PMC;

            _temp_multi_func_list[24].multi_name = mfl_18;
            _temp_multi_func_list[24].short_sig = mfl_1;
            _temp_multi_func_list[24].full_sig = mfl_6;
            _temp_multi_func_list[24].ns_name = mfl_3;
            _temp_multi_func_list[24].func_ptr = (funcptr_t) Parrot_Integer_multi_divide_DEFAULT_PMC;

            _temp_multi_func_list[25].multi_name = mfl_19;
            _temp_multi_func_list[25].short_sig = mfl_8;
            _temp_multi_func_list[25].full_sig = mfl_17;
            _temp_multi_func_list[25].ns_name = mfl_3;
            _temp_multi_func_list[25].func_ptr = (funcptr_t) Parrot_Integer_multi_i_divide_BigInt;

            _temp_multi_func_list[26].multi_name = mfl_19;
            _temp_multi_func_list[26].short_sig = mfl_8;
            _temp_multi_func_list[26].full_sig = mfl_11;
            _temp_multi_func_list[26].ns_name = mfl_3;
            _temp_multi_func_list[26].func_ptr = (funcptr_t) Parrot_Integer_multi_i_divide_DEFAULT;

            _temp_multi_func_list[27].multi_name = mfl_20;
            _temp_multi_func_list[27].short_sig = mfl_1;
            _temp_multi_func_list[27].full_sig = mfl_5;
            _temp_multi_func_list[27].ns_name = mfl_3;
            _temp_multi_func_list[27].func_ptr = (funcptr_t) Parrot_Integer_multi_floor_divide_BigInt_PMC;

            _temp_multi_func_list[28].multi_name = mfl_20;
            _temp_multi_func_list[28].short_sig = mfl_1;
            _temp_multi_func_list[28].full_sig = mfl_6;
            _temp_multi_func_list[28].ns_name = mfl_3;
            _temp_multi_func_list[28].func_ptr = (funcptr_t) Parrot_Integer_multi_floor_divide_DEFAULT_PMC;

            _temp_multi_func_list[29].multi_name = mfl_21;
            _temp_multi_func_list[29].short_sig = mfl_8;
            _temp_multi_func_list[29].full_sig = mfl_17;
            _temp_multi_func_list[29].ns_name = mfl_3;
            _temp_multi_func_list[29].func_ptr = (funcptr_t) Parrot_Integer_multi_i_floor_divide_BigInt;

            _temp_multi_func_list[30].multi_name = mfl_21;
            _temp_multi_func_list[30].short_sig = mfl_8;
            _temp_multi_func_list[30].full_sig = mfl_11;
            _temp_multi_func_list[30].ns_name = mfl_3;
            _temp_multi_func_list[30].func_ptr = (funcptr_t) Parrot_Integer_multi_i_floor_divide_DEFAULT;

            _temp_multi_func_list[31].multi_name = mfl_22;
            _temp_multi_func_list[31].short_sig = mfl_1;
            _temp_multi_func_list[31].full_sig = mfl_5;
            _temp_multi_func_list[31].ns_name = mfl_3;
            _temp_multi_func_list[31].func_ptr = (funcptr_t) Parrot_Integer_multi_modulus_BigInt_PMC;

            _temp_multi_func_list[32].multi_name = mfl_22;
            _temp_multi_func_list[32].short_sig = mfl_1;
            _temp_multi_func_list[32].full_sig = mfl_6;
            _temp_multi_func_list[32].ns_name = mfl_3;
            _temp_multi_func_list[32].func_ptr = (funcptr_t) Parrot_Integer_multi_modulus_DEFAULT_PMC;

            _temp_multi_func_list[33].multi_name = mfl_23;
            _temp_multi_func_list[33].short_sig = mfl_8;
            _temp_multi_func_list[33].full_sig = mfl_17;
            _temp_multi_func_list[33].ns_name = mfl_3;
            _temp_multi_func_list[33].func_ptr = (funcptr_t) Parrot_Integer_multi_i_modulus_BigInt;

            _temp_multi_func_list[34].multi_name = mfl_23;
            _temp_multi_func_list[34].short_sig = mfl_8;
            _temp_multi_func_list[34].full_sig = mfl_11;
            _temp_multi_func_list[34].ns_name = mfl_3;
            _temp_multi_func_list[34].func_ptr = (funcptr_t) Parrot_Integer_multi_i_modulus_DEFAULT;

            _temp_multi_func_list[35].multi_name = mfl_24;
            _temp_multi_func_list[35].short_sig = mfl_25;
            _temp_multi_func_list[35].full_sig = mfl_26;
            _temp_multi_func_list[35].ns_name = mfl_3;
            _temp_multi_func_list[35].func_ptr = (funcptr_t) Parrot_Integer_multi_cmp_String;

            _temp_multi_func_list[36].multi_name = mfl_24;
            _temp_multi_func_list[36].short_sig = mfl_25;
            _temp_multi_func_list[36].full_sig = mfl_27;
            _temp_multi_func_list[36].ns_name = mfl_3;
            _temp_multi_func_list[36].func_ptr = (funcptr_t) Parrot_Integer_multi_cmp_Float;

            _temp_multi_func_list[37].multi_name = mfl_24;
            _temp_multi_func_list[37].short_sig = mfl_25;
            _temp_multi_func_list[37].full_sig = mfl_11;
            _temp_multi_func_list[37].ns_name = mfl_3;
            _temp_multi_func_list[37].func_ptr = (funcptr_t) Parrot_Integer_multi_cmp_DEFAULT;

            _temp_multi_func_list[38].multi_name = mfl_28;
            _temp_multi_func_list[38].short_sig = mfl_25;
            _temp_multi_func_list[38].full_sig = mfl_26;
            _temp_multi_func_list[38].ns_name = mfl_3;
            _temp_multi_func_list[38].func_ptr = (funcptr_t) Parrot_Integer_multi_cmp_num_String;

            _temp_multi_func_list[39].multi_name = mfl_28;
            _temp_multi_func_list[39].short_sig = mfl_25;
            _temp_multi_func_list[39].full_sig = mfl_27;
            _temp_multi_func_list[39].ns_name = mfl_3;
            _temp_multi_func_list[39].func_ptr = (funcptr_t) Parrot_Integer_multi_cmp_num_Float;

            _temp_multi_func_list[40].multi_name = mfl_28;
            _temp_multi_func_list[40].short_sig = mfl_25;
            _temp_multi_func_list[40].full_sig = mfl_11;
            _temp_multi_func_list[40].ns_name = mfl_3;
            _temp_multi_func_list[40].func_ptr = (funcptr_t) Parrot_Integer_multi_cmp_num_DEFAULT;

            Parrot_mmd_add_multi_list_from_c_args(interp,
                _temp_multi_func_list, 41);
        }
    } /* pass */
} /* Parrot_Integer_class_init */
#line 1259 "./src/pmc/integer.pmc"


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
