/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/iterator.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_iterator.h"
#include "pmc_default.h"
#include "iterator.str"
#include "pmc_continuation.h"
#include "pmc_callcontext.h"
#line 1 "./src/pmc/iterator.pmc"
/*
Copyright (C) 2001-2009, Parrot Foundation.
$Id: iterator.pmc 45219 2010-03-28 01:11:50Z petdance $

=head1 NAME

src/pmc/iterator.pmc - Iterator PMC

=head1 DESCRIPTION

These are the vtable functions for the Iterator base class. Iterators are
used in combination with other classes(mainly aggregates) to visit all entries
in that aggregate.

=head1 SYNOPSIS

=head2 default usage

    .local pmc iterator, array, entry
    iterator = iter array
  iter_loop:
    unless iterator, iter_end  # while (more values)
    entry = shift iterator     # get an entry
    ...
    goto iter_loop
  iter_end:

=head2 iterate from the end, for arrays

    .local pmc iterator, array, entry
    iterator = iter array
    iterator = .ITERATE_FROM_END
  iter_loop:
    unless iterator, iter_end  # while (more values)
    entry = pop iterator     # get an entry
    ...
    goto iter_loop
  iter_end:

=head2 iterate over a hash

    .local pmc iterator, hash, key, entry
    iterator = iter hash
  iter_loop:
    unless iterator, iter_end  # while (more values)
    key   = shift iterator     # get the key..
    entry = hash[key]
    ...
    goto iter_loop
  iter_end:

=head1 Methods

=over 4

=cut

*/

/* HEADERIZER HFILE: none */
/* HEADERIZER BEGIN: static */
/* HEADERIZER END: static */
#line 86 "./src/pmc/iterator.c"
static  INTVAL  Parrot_Iterator_defined(PARROT_INTERP, PMC *_self);
static  INTVAL  Parrot_Iterator_defined_keyed(PARROT_INTERP, PMC *_self, PMC *key);
static  INTVAL  Parrot_Iterator_exists_keyed(PARROT_INTERP, PMC *_self, PMC *key);
static  INTVAL  Parrot_Iterator_get_integer_keyed(PARROT_INTERP, PMC *_self, PMC *key);
static  PMC  * Parrot_Iterator_get_iter(PARROT_INTERP, PMC *_self);
static  FLOATVAL  Parrot_Iterator_get_number_keyed(PARROT_INTERP, PMC *_self, PMC *key);
static  PMC  * Parrot_Iterator_get_pmc_keyed(PARROT_INTERP, PMC *_self, PMC *key);
static  STRING  * Parrot_Iterator_get_string_keyed(PARROT_INTERP, PMC *_self, PMC *key);
static  void  Parrot_Iterator_init(PARROT_INTERP, PMC *_self);
static  void  Parrot_Iterator_init_pmc(PARROT_INTERP, PMC *_self, PMC *aggregate);
static  void  Parrot_Iterator_set_integer_native(PARROT_INTERP, PMC *_self, INTVAL value);
static  void Parrot_Iterator_nci_next(PARROT_INTERP, PMC *_self);
void    Parrot_Iterator_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_Iterator_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_Iterator_get_vtable(PARROT_INTERP);
void    Parrot_Iterator_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_Iterator_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_Iterator_ro_get_vtable(PARROT_INTERP);
static  INTVAL 
Parrot_Iterator_defined(PARROT_INTERP, PMC *_self)
{
#line 172 "./src/pmc/iterator.pmc"

    return (INTVAL)(VTABLE_get_pmc(interp, _self) != PMCNULL);
#line 111 "./src/pmc/iterator.c"
}
static  INTVAL 
Parrot_Iterator_defined_keyed(PARROT_INTERP, PMC *_self, PMC *key)
{
#line 184 "./src/pmc/iterator.pmc"

    return VTABLE_defined_keyed(interp, VTABLE_get_pmc(interp, _self), key);
#line 119 "./src/pmc/iterator.c"
}
static  INTVAL 
Parrot_Iterator_exists_keyed(PARROT_INTERP, PMC *_self, PMC *key)
{
#line 158 "./src/pmc/iterator.pmc"

    return VTABLE_exists_keyed(interp, VTABLE_get_pmc(interp, _self), key);
#line 127 "./src/pmc/iterator.c"
}
static  INTVAL 
Parrot_Iterator_get_integer_keyed(PARROT_INTERP, PMC *_self, PMC *key)
{
#line 106 "./src/pmc/iterator.pmc"

    return VTABLE_get_integer_keyed(interp, VTABLE_get_pmc(interp, _self), key);
#line 135 "./src/pmc/iterator.c"
}
static  PMC  *
Parrot_Iterator_get_iter(PARROT_INTERP, PMC *_self)
{
#line 189 "./src/pmc/iterator.pmc"

    return _self;
#line 143 "./src/pmc/iterator.c"
}
static  FLOATVAL 
Parrot_Iterator_get_number_keyed(PARROT_INTERP, PMC *_self, PMC *key)
{
#line 118 "./src/pmc/iterator.pmc"

    return VTABLE_get_number_keyed(interp, VTABLE_get_pmc(interp, _self), key);
#line 151 "./src/pmc/iterator.c"
}
static  PMC  *
Parrot_Iterator_get_pmc_keyed(PARROT_INTERP, PMC *_self, PMC *key)
{
#line 144 "./src/pmc/iterator.pmc"

    return VTABLE_get_pmc_keyed(interp, VTABLE_get_pmc(interp, _self), key);
#line 159 "./src/pmc/iterator.c"
}
static  STRING  *
Parrot_Iterator_get_string_keyed(PARROT_INTERP, PMC *_self, PMC *key)
{
#line 131 "./src/pmc/iterator.pmc"

    return VTABLE_get_string_keyed(interp, VTABLE_get_pmc(interp, _self), key);
#line 167 "./src/pmc/iterator.c"
}
static  void 
Parrot_Iterator_init(PARROT_INTERP, PMC *_self)
{
#line 76 "./src/pmc/iterator.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            "Iterator init without aggregate");
#line 176 "./src/pmc/iterator.c"
}
static  void 
Parrot_Iterator_init_pmc(PARROT_INTERP, PMC *_self, PMC *aggregate)
{
#line 92 "./src/pmc/iterator.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            "Direct creation of Iterator");
#line 185 "./src/pmc/iterator.c"
}
static  void 
Parrot_Iterator_set_integer_native(PARROT_INTERP, PMC *_self, INTVAL value)
{
#line 209 "./src/pmc/iterator.pmc"

    PMC *self = _self;
    PARROT_FAILURE("Iterator: implementation have to override this method");

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNIMPLEMENTED,
            "Iterator: unimplemented method");
#line 197 "./src/pmc/iterator.c"
}
static  void
Parrot_Iterator_nci_next(PARROT_INTERP, PMC *_self)
{
#line 422 "/home/mandrake/rpm/BUILD/parrot-2.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 209 "./src/pmc/iterator.pmc"
PMC* _self;

#line 430 "/home/mandrake/rpm/BUILD/parrot-2.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
#line 434 "/home/mandrake/rpm/BUILD/parrot-2.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 195 "./src/pmc/iterator.pmc"

    PMC * const next = VTABLE_shift_pmc(interp, _self);
    #line 260 "/home/mandrake/rpm/BUILD/parrot-2.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC* next */
#line 267 "/home/mandrake/rpm/BUILD/parrot-2.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "P", (PMC*)next);
    return;
    /*END RETURN PMC* next */
    }
#line 197 "./src/pmc/iterator.pmc"

#line 441 "/home/mandrake/rpm/BUILD/parrot-2.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 236 "./src/pmc/iterator.c"
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_Iterator_update_vtable(VTABLE *vt) {
    vt->defined = Parrot_Iterator_defined;
    vt->defined_keyed = Parrot_Iterator_defined_keyed;
    vt->exists_keyed = Parrot_Iterator_exists_keyed;
    vt->get_integer_keyed = Parrot_Iterator_get_integer_keyed;
    vt->get_iter = Parrot_Iterator_get_iter;
    vt->get_number_keyed = Parrot_Iterator_get_number_keyed;
    vt->get_pmc_keyed = Parrot_Iterator_get_pmc_keyed;
    vt->get_string_keyed = Parrot_Iterator_get_string_keyed;
    vt->init = Parrot_Iterator_init;
    vt->init_pmc = Parrot_Iterator_init_pmc;
    vt->set_integer_native = Parrot_Iterator_set_integer_native;
    vt->attr_size = 0;

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_Iterator_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->defined = Parrot_Iterator_defined;
    vt->defined_keyed = Parrot_Iterator_defined_keyed;
    vt->exists_keyed = Parrot_Iterator_exists_keyed;
    vt->get_integer_keyed = Parrot_Iterator_get_integer_keyed;
    vt->get_iter = Parrot_Iterator_get_iter;
    vt->get_number_keyed = Parrot_Iterator_get_number_keyed;
    vt->get_pmc_keyed = Parrot_Iterator_get_pmc_keyed;
    vt->get_string_keyed = Parrot_Iterator_get_string_keyed;
    vt->init = Parrot_Iterator_init;
    vt->init_pmc = Parrot_Iterator_init_pmc;
    vt->attr_size = 0;

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Iterator_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_get_vtable(interp);
    Parrot_Iterator_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Iterator_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_ro_get_vtable(interp);
    Parrot_Iterator_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_Iterator_get_mro(PARROT_INTERP, PMC* mro) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }

    VTABLE_unshift_string(interp, mro,
        string_make(interp, "Iterator", 8, NULL, 0));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_Iterator_get_isa(PARROT_INTERP, Hash* isa) {
    if (isa == NULL) {
        isa = parrot_new_hash(interp);
    }
    parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "Iterator")), PMCNULL);
    return isa;
}

void
Parrot_Iterator_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_Iterator_get_vtable(interp);
        vt->base_type      = enum_class_Iterator;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "Iterator");
        vt->provides_str = CONST_STRING_GEN(interp, "scalar");
        vt->isa_hash     = Parrot_Iterator_get_isa(interp, NULL);
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_Iterator_ro_get_vtable(interp);
            vt_ro->base_type      = enum_class_Iterator;
            vt_ro->flags          = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_Iterator_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_Iterator_nci_next), CONST_STRING_GEN(interp, "next"));
        {
        }
    } /* pass */
} /* Parrot_Iterator_class_init */
#line 215 "./src/pmc/iterator.pmc"


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
